searchData={"items":[{"type":"module","title":"MetaObjectSchema","doc":"Meta-schema system enabling objects to reason about and modify their own schemas.\nImplements hierarchical schema inheritance with runtime evolution capabilities.","ref":"MetaObjectSchema.html"},{"type":"type","title":"MetaObjectSchema.action_spec/0","doc":"","ref":"MetaObjectSchema.html#t:action_spec/0"},{"type":"function","title":"MetaObjectSchema.base_agent_schema/0","doc":"Returns the base agent schema that defines fundamental agent capabilities.\n\nProvides a foundational schema for autonomous agents with core attributes,\nbehavioral patterns, interaction protocols, and meta-cognitive capabilities.\nThis schema serves as the parent for all specialized agent schemas.","ref":"MetaObjectSchema.html#base_agent_schema/0"},{"type":"function","title":"Returns - MetaObjectSchema.base_agent_schema/0","doc":"- Base agent schema struct with:\n  - Core attributes: identity, state, goals, memory\n  - Behavioral patterns: goal pursuit, social interaction\n  - Interaction protocols: basic messaging\n  - Learning parameters and evolution constraints\n  - Reflection capabilities and meta-operations","ref":"MetaObjectSchema.html#base_agent_schema/0-returns"},{"type":"function","title":"Examples - MetaObjectSchema.base_agent_schema/0","doc":"iex> MetaObjectSchema.base_agent_schema()\n    %MetaObjectSchema{schema_id: :base_agent, version: \"1.0.0\", ...}","ref":"MetaObjectSchema.html#base_agent_schema/0-examples"},{"type":"type","title":"MetaObjectSchema.behavior_pattern/0","doc":"","ref":"MetaObjectSchema.html#t:behavior_pattern/0"},{"type":"type","title":"MetaObjectSchema.compatibility_rule/0","doc":"","ref":"MetaObjectSchema.html#t:compatibility_rule/0"},{"type":"type","title":"MetaObjectSchema.compatibility_score/0","doc":"","ref":"MetaObjectSchema.html#t:compatibility_score/0"},{"type":"type","title":"MetaObjectSchema.constraint/0","doc":"","ref":"MetaObjectSchema.html#t:constraint/0"},{"type":"type","title":"MetaObjectSchema.evolution_rules/0","doc":"","ref":"MetaObjectSchema.html#t:evolution_rules/0"},{"type":"type","title":"MetaObjectSchema.inheritance_spec/0","doc":"","ref":"MetaObjectSchema.html#t:inheritance_spec/0"},{"type":"type","title":"MetaObjectSchema.learning_config/0","doc":"","ref":"MetaObjectSchema.html#t:learning_config/0"},{"type":"type","title":"MetaObjectSchema.meta_operation/0","doc":"","ref":"MetaObjectSchema.html#t:meta_operation/0"},{"type":"function","title":"MetaObjectSchema.meta_schema_evolution_rules/0","doc":"Returns the rules and constraints governing meta-schema evolution.\n\nDefines the framework for how schemas can evolve over time while maintaining\nsystem stability and compatibility. Includes compatibility requirements,\nadaptation triggers, evolution strategies, and validation requirements.","ref":"MetaObjectSchema.html#meta_schema_evolution_rules/0"},{"type":"function","title":"Returns - MetaObjectSchema.meta_schema_evolution_rules/0","doc":"- Map containing evolution rules with:\n  - `:compatibility_preservation` - Backward compatibility requirements\n  - `:adaptation_triggers` - Conditions that trigger schema evolution\n  - `:evolution_strategies` - Available strategies (incremental, branching, revolutionary)\n  - `:validation_requirements` - Testing and validation requirements","ref":"MetaObjectSchema.html#meta_schema_evolution_rules/0-returns"},{"type":"function","title":"Examples - MetaObjectSchema.meta_schema_evolution_rules/0","doc":"iex> MetaObjectSchema.meta_schema_evolution_rules()\n    %{compatibility_preservation: %{minimum_backward_compatibility: 0.8}, ...}","ref":"MetaObjectSchema.html#meta_schema_evolution_rules/0-examples"},{"type":"type","title":"MetaObjectSchema.protocol_spec/0","doc":"","ref":"MetaObjectSchema.html#t:protocol_spec/0"},{"type":"type","title":"MetaObjectSchema.reflection_capability/0","doc":"","ref":"MetaObjectSchema.html#t:reflection_capability/0"},{"type":"type","title":"MetaObjectSchema.response_spec/0","doc":"","ref":"MetaObjectSchema.html#t:response_spec/0"},{"type":"type","title":"MetaObjectSchema.schema_attribute/0","doc":"","ref":"MetaObjectSchema.html#t:schema_attribute/0"},{"type":"function","title":"MetaObjectSchema.specialist_agent_schema/1","doc":"Creates a specialized agent schema based on the provided specialization type.\n\nExtends the base agent schema with domain-specific capabilities and behaviors\ntailored to the specialization. Currently supports researcher, coordinator,\nand creative agent specializations.","ref":"MetaObjectSchema.html#specialist_agent_schema/1"},{"type":"function","title":"Parameters - MetaObjectSchema.specialist_agent_schema/1","doc":"- `specialization` - The type of specialization (`:researcher`, `:coordinator`, `:creative`)","ref":"MetaObjectSchema.html#specialist_agent_schema/1-parameters"},{"type":"function","title":"Returns - MetaObjectSchema.specialist_agent_schema/1","doc":"- Specialized agent schema struct with extended capabilities:\n  - `:researcher` - Enhanced with knowledge acquisition and hypothesis formation\n  - `:coordinator` - Enhanced with resource allocation and optimization strategies  \n  - `:creative` - Enhanced with creative synthesis and aesthetic evaluation","ref":"MetaObjectSchema.html#specialist_agent_schema/1-returns"},{"type":"function","title":"Examples - MetaObjectSchema.specialist_agent_schema/1","doc":"iex> MetaObjectSchema.specialist_agent_schema(:researcher)\n    %MetaObjectSchema{schema_id: :researcher_agent, ...}\n    \n    iex> MetaObjectSchema.specialist_agent_schema(:coordinator)\n    %MetaObjectSchema{schema_id: :coordinator_agent, ...}","ref":"MetaObjectSchema.html#specialist_agent_schema/1-examples"},{"type":"type","title":"MetaObjectSchema.state_condition/0","doc":"","ref":"MetaObjectSchema.html#t:state_condition/0"},{"type":"type","title":"MetaObjectSchema.t/0","doc":"","ref":"MetaObjectSchema.html#t:t/0"},{"type":"type","title":"MetaObjectSchema.trigger_condition/0","doc":"","ref":"MetaObjectSchema.html#t:trigger_condition/0"},{"type":"module","title":"OORL","doc":"Object-Oriented Reinforcement Learning Framework\n\nOORL extends traditional reinforcement learning by treating each learning agent\nas a full autonomous object with encapsulated state, behavior polymorphism, and\nsophisticated social learning capabilities. This framework enables complex\nmulti-agent learning scenarios that go far beyond traditional flat RL approaches.","ref":"OORL.html"},{"type":"module","title":"Core Principles - OORL","doc":"OORL objects exhibit several advanced capabilities:\n\n1. **Behavioral Inheritance**: Objects can inherit and override learning strategies\n   from parent classes, enabling sophisticated policy hierarchies\n2. **Dynamic Coalition Formation**: Objects form temporary alliances for\n   collective learning and problem solving\n3. **Reward Function Evolution**: Objects evolve their own intrinsic reward\n   functions through meta-learning processes\n4. **Multi-Objective Optimization**: Objects balance multiple competing goals\n   through hierarchical objective structures\n5. **Distributed Policy Learning**: Objects share knowledge and learn collectively\n   across object networks through social learning mechanisms","ref":"OORL.html#module-core-principles"},{"type":"module","title":"Framework Architecture - OORL","doc":"","ref":"OORL.html#module-framework-architecture"},{"type":"module","title":"Learning Levels - OORL","doc":"OORL operates at multiple levels of learning:\n\n- **Individual Learning**: Traditional RL with policy and value function updates\n- **Social Learning**: Learning from peer objects through observation and imitation\n- **Collective Learning**: Distributed optimization across object coalitions\n- **Meta-Learning**: Learning to learn - adaptation of learning strategies themselves","ref":"OORL.html#module-learning-levels"},{"type":"module","title":"Key Components - OORL","doc":"- `OORL.PolicyLearning`: Individual and social policy learning algorithms\n- `OORL.CollectiveLearning`: Coalition formation and distributed optimization\n- `OORL.MetaLearning`: Meta-learning and strategy evolution","ref":"OORL.html#module-key-components"},{"type":"module","title":"Performance Characteristics - OORL","doc":"- **Learning Speed**: 2-5x faster convergence through social learning\n- **Scalability**: Linear scaling with number of objects in coalition\n- **Robustness**: Graceful degradation with partial coalition failures\n- **Adaptation**: Dynamic strategy adjustment based on environment changes","ref":"OORL.html#module-performance-characteristics"},{"type":"module","title":"Example Usage - OORL","doc":"# Initialize OORL learning for an object\n    {:ok, oorl_state} = OORL.initialize_oorl_object(\"agent_1\", %{\n      policy_type: :neural,\n      social_learning_enabled: true,\n      meta_learning_enabled: true\n    })\n    \n    # Perform learning step with social context\n    social_context = %{\n      peer_rewards: [{\"agent_2\", 0.8}, {\"agent_3\", 0.6}],\n      interaction_dyads: [\"dyad_1\", \"dyad_2\"]\n    }\n    \n    {:ok, results} = OORL.learning_step(\n      \"agent_1\", current_state, action, reward, next_state, social_context\n    )\n    \n    # Form learning coalition\n    {:ok, coalition} = OORL.CollectiveLearning.form_learning_coalition(\n      [\"agent_1\", \"agent_2\", \"agent_3\"],\n      %{task_type: :coordination, difficulty: :high}\n    )","ref":"OORL.html#module-example-usage"},{"type":"type","title":"OORL.action_observation/0","doc":"","ref":"OORL.html#t:action_observation/0"},{"type":"type","title":"OORL.coalition_id/0","doc":"","ref":"OORL.html#t:coalition_id/0"},{"type":"type","title":"OORL.dyad_id/0","doc":"","ref":"OORL.html#t:dyad_id/0"},{"type":"type","title":"OORL.experience/0","doc":"Learning experience containing state transition and social context.","ref":"OORL.html#t:experience/0"},{"type":"type","title":"Fields - OORL.experience/0","doc":"- `state` - Environment state before action\n- `action` - Action taken by the object\n- `reward` - Numerical reward received\n- `next_state` - Environment state after action\n- `social_context` - Social learning context at time of experience\n- `meta_features` - Meta-learning features (complexity, novelty, etc.)\n- `timestamp` - When the experience occurred\n- `interaction_dyad` - Dyad involved in the experience (if any)\n- `learning_signal` - Strength of learning signal for this experience","ref":"OORL.html#t:experience/0-fields"},{"type":"type","title":"Learning Integration - OORL.experience/0","doc":"Experiences are used for:\n- Policy gradient updates\n- Value function learning\n- Social learning integration\n- Meta-learning strategy adaptation","ref":"OORL.html#t:experience/0-learning-integration"},{"type":"type","title":"OORL.exploration_spec/0","doc":"Exploration strategy configuration","ref":"OORL.html#t:exploration_spec/0"},{"type":"type","title":"OORL.goal_id/0","doc":"Unique goal identifier","ref":"OORL.html#t:goal_id/0"},{"type":"type","title":"OORL.goal_spec/0","doc":"Goal specification with success criteria","ref":"OORL.html#t:goal_spec/0"},{"type":"type","title":"OORL.goal_tree/0","doc":"Hierarchical goal structure with priorities","ref":"OORL.html#t:goal_tree/0"},{"type":"type","title":"OORL.graph/0","doc":"Social learning graph representing object relationships","ref":"OORL.html#t:graph/0"},{"type":"function","title":"OORL.initialize_oorl_object/2","doc":"Initializes an OORL object with learning capabilities.\n\nSets up a complete OORL learning system for an object including\npolicy networks, value functions, social learning capabilities,\nand meta-learning features. This is the entry point for enabling\nadvanced learning capabilities on any AAOS object.","ref":"OORL.html#initialize_oorl_object/2"},{"type":"function","title":"Parameters - OORL.initialize_oorl_object/2","doc":"- `object_id` - Unique identifier for the learning object\n- `learning_config` - Configuration options map with the following keys:\n  - `:policy_type` - Policy representation (:neural, :tabular, default: :neural)\n  - `:social_learning_enabled` - Enable social learning (default: true)\n  - `:meta_learning_enabled` - Enable meta-learning (default: true)\n  - `:curiosity_driven` - Enable curiosity-driven exploration (default: true)\n  - `:coalition_participation` - Allow coalition membership (default: true)\n  - `:learning_rate` - Base learning rate (default: 0.01)\n  - `:exploration_rate` - Initial exploration rate (default: 0.1)\n  - `:discount_factor` - Future reward discount (default: 0.95)","ref":"OORL.html#initialize_oorl_object/2-parameters"},{"type":"function","title":"Returns - OORL.initialize_oorl_object/2","doc":"- `{:ok, oorl_state}` - Successfully initialized OORL state structure","ref":"OORL.html#initialize_oorl_object/2-returns"},{"type":"function","title":"OORL State Structure - OORL.initialize_oorl_object/2","doc":"The returned state includes:\n- **Policy Network**: Decision-making policy (neural or tabular)\n- **Value Function**: State value estimation function\n- **Experience Buffer**: Replay buffer for learning\n- **Social Learning Graph**: Network of social connections\n- **Meta-Learning State**: Strategy adaptation mechanisms\n- **Goal Hierarchy**: Multi-objective goal structure\n- **Reward Function**: Multi-component reward specification\n- **Exploration Strategy**: Exploration/exploitation balance","ref":"OORL.html#initialize_oorl_object/2-oorl-state-structure"},{"type":"function","title":"Examples - OORL.initialize_oorl_object/2","doc":"# Initialize with neural policy\n    iex> {:ok, state} = OORL.initialize_oorl_object(\"agent_1\", %{\n    ...>   policy_type: :neural,\n    ...>   learning_rate: 0.001,\n    ...>   social_learning_enabled: true\n    ...> })\n    iex> state.policy_network.type\n    :neural\n    \n    # Initialize tabular policy for discrete environments\n    iex> {:ok, state} = OORL.initialize_oorl_object(\"discrete_agent\", %{\n    ...>   policy_type: :tabular,\n    ...>   exploration_rate: 0.2\n    ...> })\n    iex> state.policy_network.type\n    :tabular\n    \n    # Initialize with meta-learning disabled\n    iex> {:ok, state} = OORL.initialize_oorl_object(\"simple_agent\", %{\n    ...>   meta_learning_enabled: false,\n    ...>   curiosity_driven: false\n    ...> })\n    iex> state.exploration_strategy.type\n    :epsilon_greedy","ref":"OORL.html#initialize_oorl_object/2-examples"},{"type":"function","title":"Configuration Guidelines - OORL.initialize_oorl_object/2","doc":"","ref":"OORL.html#initialize_oorl_object/2-configuration-guidelines"},{"type":"function","title":"Policy Type Selection - OORL.initialize_oorl_object/2","doc":"- **Neural**: Continuous state/action spaces, complex patterns\n- **Tabular**: Discrete spaces, interpretable policies\n- **Hybrid**: Mixed discrete/continuous environments","ref":"OORL.html#initialize_oorl_object/2-policy-type-selection"},{"type":"function","title":"Learning Rates - OORL.initialize_oorl_object/2","doc":"- **High** (0.1-0.5): Fast changing environments\n- **Medium** (0.01-0.1): Typical applications\n- **Low** (0.001-0.01): Stable environments, fine-tuning","ref":"OORL.html#initialize_oorl_object/2-learning-rates"},{"type":"function","title":"Social Learning - OORL.initialize_oorl_object/2","doc":"- Enable for multi-agent environments\n- Disable for single-agent optimization\n- Consider computational overhead","ref":"OORL.html#initialize_oorl_object/2-social-learning"},{"type":"function","title":"Performance Impact - OORL.initialize_oorl_object/2","doc":"- Initialization time: ~5-10ms\n- Memory usage: ~5-50KB depending on configuration\n- Neural networks: Higher memory, better generalization\n- Tabular policies: Lower memory, exact solutions","ref":"OORL.html#initialize_oorl_object/2-performance-impact"},{"type":"function","title":"Error Conditions - OORL.initialize_oorl_object/2","doc":"Initialization may fail due to:\n- Invalid configuration parameters\n- Insufficient system resources\n- Conflicting option combinations","ref":"OORL.html#initialize_oorl_object/2-error-conditions"},{"type":"function","title":"OORL.learning_step/6","doc":"Performs a single learning step for an OORL object.\n\nProcesses a complete learning experience including individual policy\nupdates, social learning integration, and meta-learning adaptation.\nThis is the core learning function that integrates multiple levels\nof learning in a single operation.","ref":"OORL.html#learning_step/6"},{"type":"function","title":"Parameters - OORL.learning_step/6","doc":"- `object_id` - ID of the learning object (must be OORL-enabled)\n- `state` - Current environment state (any serializable term)\n- `action` - Action taken by the object\n- `reward` - Numerical reward signal received\n- `next_state` - Resulting environment state after action\n- `social_context` - Social learning context containing:\n  - `:observed_actions` - Actions observed from peer objects\n  - `:peer_rewards` - Reward signals from peer objects\n  - `:coalition_membership` - Active coalition memberships\n  - `:interaction_dyads` - Active interaction dyads\n  - `:message_history` - Recent communication history","ref":"OORL.html#learning_step/6-parameters"},{"type":"function","title":"Returns - OORL.learning_step/6","doc":"- `{:ok, learning_results}` - Successful learning with detailed results:\n  - `:policy_update` - Individual policy learning results\n  - `:social_updates` - Social learning integration results\n  - `:meta_updates` - Meta-learning adaptation results\n  - `:total_learning_signal` - Aggregate learning signal strength\n- `{:error, reason}` - Learning step failed due to:\n  - `:object_not_found` - Object not registered\n  - `:invalid_state` - State format invalid\n  - `:learning_disabled` - OORL not enabled for object\n  - `:resource_exhausted` - Insufficient computational resources","ref":"OORL.html#learning_step/6-returns"},{"type":"function","title":"Learning Process - OORL.learning_step/6","doc":"Each learning step involves:\n\n1. **Experience Creation**: Package (state, action, reward, next_state)\n2. **Individual Learning**: Update policy using RL algorithm\n3. **Social Learning**: Integrate peer observations and rewards\n4. **Meta-Learning**: Adapt learning strategy based on performance\n5. **Result Aggregation**: Combine learning signals from all levels","ref":"OORL.html#learning_step/6-learning-process"},{"type":"function","title":"Examples - OORL.learning_step/6","doc":"# Basic learning step\n    iex> social_context = %{\n    ...>   peer_rewards: [{\"agent_2\", 0.8}],\n    ...>   interaction_dyads: [\"dyad_1\"]\n    ...> }\n    iex> {:ok, results} = OORL.learning_step(\n    ...>   \"agent_1\", \n    ...>   %{position: {0, 0}}, \n    ...>   :move_right, \n    ...>   1.0, \n    ...>   %{position: {1, 0}},\n    ...>   social_context\n    ...> )\n    iex> results.total_learning_signal\n    0.35\n    \n    # Learning with rich social context\n    iex> rich_context = %{\n    ...>   observed_actions: [\n    ...>     %{object_id: \"agent_2\", action: :explore, outcome: :success},\n    ...>     %{object_id: \"agent_3\", action: :exploit, outcome: :failure}\n    ...>   ],\n    ...>   peer_rewards: [{\"agent_2\", 1.2}, {\"agent_3\", -0.5}],\n    ...>   coalition_membership: [\"coalition_alpha\"],\n    ...>   interaction_dyads: [\"dyad_2\", \"dyad_3\"]\n    ...> }\n    iex> {:ok, results} = OORL.learning_step(\n    ...>   \"social_agent\", current_state, action, reward, next_state, rich_context\n    ...> )\n    iex> results.social_updates.peer_influence\n    0.25","ref":"OORL.html#learning_step/6-examples"},{"type":"function","title":"Learning Algorithms - OORL.learning_step/6","doc":"The learning step uses different algorithms based on policy type:","ref":"OORL.html#learning_step/6-learning-algorithms"},{"type":"function","title":"Neural Policies - OORL.learning_step/6","doc":"- Policy gradient with social regularization\n- Experience replay with peer experiences\n- Neural network parameter updates","ref":"OORL.html#learning_step/6-neural-policies"},{"type":"function","title":"Tabular Policies - OORL.learning_step/6","doc":"- Q-learning with social Q-value sharing\n- Direct state-action value updates\n- Exploration bonus from peer actions","ref":"OORL.html#learning_step/6-tabular-policies"},{"type":"function","title":"Social Learning Integration - OORL.learning_step/6","doc":"Social learning enhances individual learning through:\n- **Imitation**: Copy successful actions from high-performing peers\n- **Advice Taking**: Weight peer rewards in policy updates\n- **Coordination**: Align actions with coalition objectives\n- **Knowledge Transfer**: Share learned policies across similar states","ref":"OORL.html#learning_step/6-social-learning-integration"},{"type":"function","title":"Performance Characteristics - OORL.learning_step/6","doc":"- Learning step time: 1-10ms depending on complexity\n- Memory usage: Temporary allocations for experience processing\n- Convergence: 2-5x faster with effective social learning\n- Scalability: Linear with number of peer objects in context","ref":"OORL.html#learning_step/6-performance-characteristics"},{"type":"function","title":"Meta-Learning Adaptation - OORL.learning_step/6","doc":"Meta-learning continuously adapts:\n- Learning rates based on convergence speed\n- Exploration strategies based on environment dynamics\n- Social weights based on peer performance\n- Reward function components based on goal achievement","ref":"OORL.html#learning_step/6-meta-learning-adaptation"},{"type":"type","title":"OORL.learning_strategy/0","doc":"Learning strategy configuration","ref":"OORL.html#t:learning_strategy/0"},{"type":"type","title":"OORL.message/0","doc":"","ref":"OORL.html#t:message/0"},{"type":"type","title":"OORL.meta_state/0","doc":"Meta-learning state for strategy adaptation","ref":"OORL.html#t:meta_state/0"},{"type":"type","title":"OORL.network_spec/0","doc":"Neural network architecture specification","ref":"OORL.html#t:network_spec/0"},{"type":"type","title":"OORL.object_id/0","doc":"","ref":"OORL.html#t:object_id/0"},{"type":"type","title":"OORL.oorl_state/0","doc":"Complete OORL state for an object with all learning capabilities.","ref":"OORL.html#t:oorl_state/0"},{"type":"type","title":"Fields - OORL.oorl_state/0","doc":"- `policy_network` - Decision-making policy (neural, tabular, or hybrid)\n- `value_function` - State value estimation function\n- `experience_buffer` - Replay buffer for learning experiences\n- `social_learning_graph` - Network of social connections and trust\n- `meta_learning_state` - Strategy adaptation and meta-learning\n- `goal_hierarchy` - Multi-objective goal structure with priorities\n- `reward_function` - Multi-component reward specification\n- `exploration_strategy` - Exploration/exploitation strategy","ref":"OORL.html#t:oorl_state/0-fields"},{"type":"type","title":"Integration - OORL.oorl_state/0","doc":"All components work together to provide:\n- Individual reinforcement learning\n- Social learning from peers\n- Collective learning in coalitions\n- Meta-learning for strategy adaptation","ref":"OORL.html#t:oorl_state/0-integration"},{"type":"type","title":"OORL.performance_metric/0","doc":"Performance metric for meta-learning","ref":"OORL.html#t:performance_metric/0"},{"type":"type","title":"OORL.policy_spec/0","doc":"Policy specification defining the learning agent's decision-making strategy.","ref":"OORL.html#t:policy_spec/0"},{"type":"type","title":"Fields - OORL.policy_spec/0","doc":"- `type` - Policy representation type\n- `parameters` - Policy-specific parameters\n- `architecture` - Network structure for neural policies\n- `update_rule` - Algorithm for policy updates\n- `social_influence_weight` - Weighting for social learning integration","ref":"OORL.html#t:policy_spec/0-fields"},{"type":"type","title":"OORL.reward_component/0","doc":"Reward component for multi-objective optimization","ref":"OORL.html#t:reward_component/0"},{"type":"type","title":"OORL.reward_spec/0","doc":"Reward function specification with components","ref":"OORL.html#t:reward_spec/0"},{"type":"type","title":"OORL.social_context/0","doc":"Social learning context containing peer information and interaction history.","ref":"OORL.html#t:social_context/0"},{"type":"type","title":"Fields - OORL.social_context/0","doc":"- `observed_actions` - Actions observed from peer objects with outcomes\n- `peer_rewards` - Recent reward signals from peer objects  \n- `coalition_membership` - List of coalitions this object belongs to\n- `reputation_scores` - Trust and reliability scores for peer objects\n- `interaction_dyads` - Active interaction dyads with other objects\n- `message_history` - Recent communication history for context","ref":"OORL.html#t:social_context/0-fields"},{"type":"type","title":"Usage in Learning - OORL.social_context/0","doc":"Social context enables:\n- Imitation learning from successful peers\n- Coordination with coalition members\n- Trust-based learning partner selection\n- Communication-informed decision making","ref":"OORL.html#t:social_context/0-usage-in-learning"},{"type":"type","title":"OORL.trigger_condition/0","doc":"Trigger condition for strategy adaptation","ref":"OORL.html#t:trigger_condition/0"},{"type":"type","title":"OORL.value_spec/0","doc":"Value function specification and parameters","ref":"OORL.html#t:value_spec/0"},{"type":"module","title":"OORL.CollectiveLearning","doc":"Distributed learning across object coalitions","ref":"OORL.CollectiveLearning.html"},{"type":"function","title":"OORL.CollectiveLearning.distributed_policy_optimization/1","doc":"Performs distributed policy optimization across coalition members.\n\nUses federated learning approach with privacy preservation to\noptimize policies across the coalition while maintaining individual\nobject autonomy.","ref":"OORL.CollectiveLearning.html#distributed_policy_optimization/1"},{"type":"function","title":"Parameters - OORL.CollectiveLearning.distributed_policy_optimization/1","doc":"- `coalition` - Active learning coalition","ref":"OORL.CollectiveLearning.html#distributed_policy_optimization/1-parameters"},{"type":"function","title":"Returns - OORL.CollectiveLearning.distributed_policy_optimization/1","doc":"- `{:ok, global_update}` - Successful distributed optimization","ref":"OORL.CollectiveLearning.html#distributed_policy_optimization/1-returns"},{"type":"function","title":"OORL.CollectiveLearning.emergence_detection/1","doc":"Detects emergent behaviors in coalition learning.\n\nMonitors for emergent behaviors that arise from collective learning,\nwhere the coalition achieves capabilities beyond the sum of individual\nmember capabilities.","ref":"OORL.CollectiveLearning.html#emergence_detection/1"},{"type":"function","title":"Parameters - OORL.CollectiveLearning.emergence_detection/1","doc":"- `coalition` - Coalition to monitor for emergence","ref":"OORL.CollectiveLearning.html#emergence_detection/1-parameters"},{"type":"function","title":"Returns - OORL.CollectiveLearning.emergence_detection/1","doc":"- `{:emergent_behavior_detected, info}` - Emergence detected with details\n- `{:no_emergence, score}` - No significant emergence detected","ref":"OORL.CollectiveLearning.html#emergence_detection/1-returns"},{"type":"function","title":"OORL.CollectiveLearning.form_learning_coalition/2","doc":"Forms a learning coalition of objects for collaborative learning.\n\nCreates temporary coalitions based on complementary capabilities\nand task alignment to enable distributed learning benefits. Coalitions\nprovide significant advantages for complex learning tasks that exceed\nindividual object capabilities.","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2"},{"type":"function","title":"Parameters - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- `objects` - List of candidate object IDs for coalition membership\n- `task_requirements` - Task specification map containing:\n  - `:task_type` - Type of learning task (:coordination, :optimization, :exploration)\n  - `:difficulty` - Task difficulty level (:low, :medium, :high, :extreme)\n  - `:required_capabilities` - List of required capabilities/skills\n  - `:time_horizon` - Task completion timeline\n  - `:success_criteria` - Definition of successful task completion","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-parameters"},{"type":"function","title":"Returns - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- `{:ok, coalition}` - Successfully formed coalition containing:\n  - `:members` - List of coalition member object IDs\n  - `:trust_weights` - Trust scores between members\n  - `:shared_experience_buffer` - Collective experience storage\n  - `:collective_goals` - Shared objectives and priorities\n  - `:coordination_protocol` - Communication and decision protocols\n- `{:error, reason}` - Coalition formation failed:\n  - `:insufficient_synergy` - Members don't provide sufficient benefit\n  - `:incompatible_goals` - Conflicting objectives between members\n  - `:resource_constraints` - Insufficient computational resources\n  - `:no_suitable_candidates` - No objects meet requirements","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-returns"},{"type":"function","title":"Coalition Formation Process - OORL.CollectiveLearning.form_learning_coalition/2","doc":"1. **Capability Analysis**: Assess each object's relevant capabilities\n2. **Compatibility Matrix**: Calculate pairwise compatibility scores\n3. **Task Alignment**: Measure alignment with task requirements\n4. **Synergy Evaluation**: Estimate collective performance benefits\n5. **Optimal Selection**: Choose best subset of objects for coalition\n6. **Protocol Setup**: Establish communication and coordination protocols","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-coalition-formation-process"},{"type":"function","title":"Examples - OORL.CollectiveLearning.form_learning_coalition/2","doc":"# Form coalition for coordination task\n    iex> objects = [\"agent_1\", \"agent_2\", \"agent_3\", \"coordinator_1\"]\n    iex> task_requirements = %{\n    ...>   task_type: :coordination,\n    ...>   difficulty: :high,\n    ...>   required_capabilities: [:planning, :communication, :adaptation],\n    ...>   time_horizon: 1000,\n    ...>   success_criteria: %{collective_reward: 10.0}\n    ...> }\n    iex> {:ok, coalition} = OORL.CollectiveLearning.form_learning_coalition(\n    ...>   objects, task_requirements\n    ...> )\n    iex> length(coalition.members)\n    3\n    \n    # Coalition formation failure\n    iex> incompatible_objects = [\"competitive_1\", \"competitive_2\"]\n    iex> task = %{task_type: :cooperation, difficulty: :high}\n    iex> OORL.CollectiveLearning.form_learning_coalition(\n    ...>   incompatible_objects, task\n    ...> )\n    {:error, \"Coalition formation failed: insufficient_synergy\"}","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-examples"},{"type":"function","title":"Coalition Benefits - OORL.CollectiveLearning.form_learning_coalition/2","doc":"Successful coalitions provide:","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-coalition-benefits"},{"type":"function","title":"Distributed Learning - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- **Parallel Exploration**: Members explore different regions simultaneously\n- **Knowledge Sharing**: Rapid propagation of successful strategies\n- **Computational Scaling**: Distributed processing across members","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-distributed-learning"},{"type":"function","title":"Emergent Capabilities - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- **Collective Intelligence**: Group performance exceeds individual sum\n- **Specialization**: Members develop complementary skills\n- **Robust Solutions**: Multiple perspectives improve solution quality","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-emergent-capabilities"},{"type":"function","title":"Risk Mitigation - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- **Failure Tolerance**: Coalition survives individual member failures\n- **Diverse Strategies**: Multiple approaches reduce local optima risks\n- **Adaptive Capacity**: Coalition can reorganize based on performance","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-risk-mitigation"},{"type":"function","title":"Selection Criteria - OORL.CollectiveLearning.form_learning_coalition/2","doc":"Objects are selected based on:","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-selection-criteria"},{"type":"function","title":"Capability Complementarity - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- Different but compatible skill sets\n- Filling gaps in required capabilities\n- Avoiding redundant capabilities","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-capability-complementarity"},{"type":"function","title":"Performance Potential - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- Individual learning performance history\n- Collaboration success in past coalitions\n- Adaptation and improvement rate","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-performance-potential"},{"type":"function","title":"Social Compatibility - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- Successful interaction history\n- Compatible communication styles\n- Aligned incentive structures","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-social-compatibility"},{"type":"function","title":"Performance Characteristics - OORL.CollectiveLearning.form_learning_coalition/2","doc":"- Formation time: 10-100ms depending on candidate count\n- Optimal size: 3-7 members for most tasks\n- Success rate: 70-90% for well-matched requirements\n- Overhead: 15-25% computational cost for coordination","ref":"OORL.CollectiveLearning.html#form_learning_coalition/2-performance-characteristics"},{"type":"module","title":"OORL.MetaLearning","doc":"Learning to learn: adaptation of learning strategies themselves","ref":"OORL.MetaLearning.html"},{"type":"function","title":"OORL.MetaLearning.curiosity_driven_exploration/2","doc":"Implements curiosity-driven exploration strategy.\n\nUses information gain estimates and state novelty to drive\nexploration toward potentially informative experiences. This\napproach goes beyond random exploration to actively seek\nlearning opportunities.","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2"},{"type":"function","title":"Parameters - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"- `object_id` - ID of the exploring object\n- `state_visitation_history` - List of previously visited states:\n  - Each entry represents a state the object has experienced\n  - More recent states weighted more heavily\n  - State representation can be any serializable term","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-parameters"},{"type":"function","title":"Returns - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"- `{:ok, exploration_strategy}` - Curiosity-driven exploration plan:\n  - `:exploration_policy` - Type of exploration (:curiosity_driven)\n  - `:target_states` - Specific states to explore next\n  - `:expected_information_gain` - Predicted learning benefit","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-returns"},{"type":"function","title":"Curiosity Mechanisms - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-curiosity-mechanisms"},{"type":"function","title":"State Novelty Assessment - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"Measures how \"new\" or \"interesting\" states are:\n- **Frequency-Based**: Rarely visited states are more novel\n- **Similarity-Based**: States dissimilar to known states\n- **Temporal**: Recent exploration patterns influence novelty","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-state-novelty-assessment"},{"type":"function","title":"Information Gain Estimation - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"Predicts learning value of exploring different states:\n- **Uncertainty Reduction**: States that reduce model uncertainty\n- **Prediction Error**: States where model predictions fail\n- **Feature Discovery**: States revealing new environment aspects","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-information-gain-estimation"},{"type":"function","title":"Examples - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"# Generate curiosity-driven exploration plan\n    iex> state_history = [\n    ...>   %{position: {0, 0}, visited_count: 10},\n    ...>   %{position: {1, 0}, visited_count: 5},\n    ...>   %{position: {0, 1}, visited_count: 2},\n    ...>   %{position: {2, 2}, visited_count: 1}\n    ...> ]\n    iex> {:ok, strategy} = OORL.MetaLearning.curiosity_driven_exploration(\n    ...>   \"explorer_agent\", state_history\n    ...> )\n    iex> strategy.target_states\n    [%{position: {2, 2}}, %{position: {3, 0}}, %{position: {1, 2}}]\n    iex> strategy.expected_information_gain\n    0.75","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-examples"},{"type":"function","title":"Exploration Strategy Benefits - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-exploration-strategy-benefits"},{"type":"function","title":"Efficient Learning - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"- **Focused Exploration**: Target high-value learning opportunities\n- **Reduced Waste**: Avoid redundant exploration of known areas\n- **Accelerated Discovery**: Find important environment features faster","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-efficient-learning"},{"type":"function","title":"Robust Policies - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"- **Comprehensive Coverage**: Explore diverse state space regions\n- **Edge Case Discovery**: Find unusual but important situations\n- **Generalization**: Better performance in unseen situations","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-robust-policies"},{"type":"function","title":"Adaptive Behavior - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"- **Environment Mapping**: Build comprehensive world models\n- **Opportunity Recognition**: Identify beneficial unexplored options\n- **Risk Assessment**: Understand environment dangers and benefits","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-adaptive-behavior"},{"type":"function","title":"Novelty Calculation - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"State novelty is computed using:\n```\nnovelty = 1.0 - (visitation_count / total_visits)\n```\n\nWhere frequently visited states have low novelty scores.","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-novelty-calculation"},{"type":"function","title":"Information Gain Estimation - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"Predicted information gain considers:\n- **Model Uncertainty**: States where predictions are uncertain\n- **Feature Density**: States rich in learnable features\n- **Transition Novelty**: States with unexpected transition dynamics\n- **Reward Potential**: States potentially containing rewards","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-information-gain-estimation-1"},{"type":"function","title":"Integration with Learning - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"Curiosity-driven exploration integrates with:\n- **Policy Learning**: Direct exploration actions toward novel states\n- **Value Function**: Update value estimates for explored states\n- **World Model**: Improve environment understanding\n- **Goal Discovery**: Find new objectives through exploration","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-integration-with-learning"},{"type":"function","title":"Performance Characteristics - OORL.MetaLearning.curiosity_driven_exploration/2","doc":"- Computation time: 1-5ms depending on history size\n- Memory usage: O(n) where n is unique state count\n- Exploration efficiency: 2-4x better than random exploration\n- Discovery rate: Higher probability of finding important features","ref":"OORL.MetaLearning.html#curiosity_driven_exploration/2-performance-characteristics"},{"type":"function","title":"OORL.MetaLearning.evolve_learning_strategy/3","doc":"Evolves an object's learning strategy based on performance history.\n\nUses AI reasoning to adapt learning parameters and strategies based\non past performance and current environmental conditions. This enables\ncontinuous improvement of the learning process itself.","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3"},{"type":"function","title":"Parameters - OORL.MetaLearning.evolve_learning_strategy/3","doc":"- `object_id` - ID of the object evolving its strategy\n- `performance_history` - List of historical performance metrics including:\n  - Timestamps and performance scores over time\n  - Learning rate effectiveness measurements\n  - Convergence speed and stability metrics\n  - Social learning benefit assessments\n- `environmental_context` - Current environmental conditions:\n  - Environment dynamics and change rate\n  - Task complexity and requirements\n  - Available computational resources\n  - Social context and peer availability","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-parameters"},{"type":"function","title":"Returns - OORL.MetaLearning.evolve_learning_strategy/3","doc":"- `{:ok, new_strategy}` - Updated learning strategy containing:\n  - `:exploration_rate` - Adaptive exploration parameter\n  - `:learning_rate_schedule` - Dynamic learning rate schedule\n  - `:experience_replay_strategy` - Memory management strategy\n  - `:social_learning_weight` - Social vs individual learning balance\n- `{:error, reason}` - Strategy evolution failed:\n  - `:insufficient_history` - Not enough performance data\n  - `:ai_reasoning_unavailable` - AI enhancement not available\n  - `:invalid_context` - Environmental context malformed","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-returns"},{"type":"function","title":"Strategy Evolution Process - OORL.MetaLearning.evolve_learning_strategy/3","doc":"1. **Performance Analysis**: Analyze historical learning effectiveness\n2. **Environment Assessment**: Evaluate current environmental demands\n3. **Strategy Selection**: Choose optimal parameters using AI reasoning\n4. **Validation**: Verify strategy improvements through simulation\n5. **Gradual Adaptation**: Smoothly transition to new strategy","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-strategy-evolution-process"},{"type":"function","title":"AI-Enhanced Adaptation - OORL.MetaLearning.evolve_learning_strategy/3","doc":"AI reasoning optimizes strategies by:\n- **Pattern Recognition**: Identify successful learning patterns\n- **Multi-Objective Optimization**: Balance multiple learning objectives\n- **Predictive Modeling**: Anticipate future performance needs\n- **Causal Analysis**: Understand cause-effect relationships","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-ai-enhanced-adaptation"},{"type":"function","title":"Examples - OORL.MetaLearning.evolve_learning_strategy/3","doc":"# Evolve strategy based on poor recent performance\n    iex> performance_history = [\n    ...>   %{timestamp: ~D[2024-01-01], score: 0.6, learning_rate: 0.01},\n    ...>   %{timestamp: ~D[2024-01-02], score: 0.55, learning_rate: 0.01},\n    ...>   %{timestamp: ~D[2024-01-03], score: 0.52, learning_rate: 0.01}\n    ...> ]\n    iex> environmental_context = %{\n    ...>   change_rate: :high,\n    ...>   task_complexity: :medium,\n    ...>   peer_availability: :low\n    ...> }\n    iex> {:ok, strategy} = OORL.MetaLearning.evolve_learning_strategy(\n    ...>   \"declining_agent\", performance_history, environmental_context\n    ...> )\n    iex> strategy.exploration_rate\n    0.25  # Increased exploration for changing environment","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-examples"},{"type":"function","title":"Adaptation Strategies - OORL.MetaLearning.evolve_learning_strategy/3","doc":"Common adaptations include:","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-adaptation-strategies"},{"type":"function","title":"Learning Rate Schedules - OORL.MetaLearning.evolve_learning_strategy/3","doc":"- **Adaptive**: Adjust based on convergence rate\n- **Cyclical**: Periodic increases for continued exploration\n- **Warm Restart**: Reset to high values periodically","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-learning-rate-schedules"},{"type":"function","title":"Exploration Strategies - OORL.MetaLearning.evolve_learning_strategy/3","doc":"- **Epsilon-Greedy**: Simple exploration-exploitation trade-off\n- **UCB**: Upper confidence bound exploration\n- **Curiosity-Driven**: Information gain based exploration","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-exploration-strategies"},{"type":"function","title":"Experience Replay - OORL.MetaLearning.evolve_learning_strategy/3","doc":"- **Uniform**: Random sampling from experience buffer\n- **Prioritized**: Sample important experiences more frequently\n- **Temporal**: Weight recent experiences more heavily","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-experience-replay"},{"type":"function","title":"Social Learning Balance - OORL.MetaLearning.evolve_learning_strategy/3","doc":"- **Individual Focus**: Emphasize personal experience\n- **Social Focus**: Leverage peer knowledge heavily\n- **Adaptive Balance**: Adjust based on peer performance","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-social-learning-balance"},{"type":"function","title":"Performance Monitoring - OORL.MetaLearning.evolve_learning_strategy/3","doc":"Strategy evolution tracks:\n- **Convergence Speed**: How quickly learning converges\n- **Final Performance**: Ultimate achievement level\n- **Stability**: Robustness to environment changes\n- **Efficiency**: Computational cost vs benefit ratio","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-performance-monitoring"},{"type":"function","title":"Continuous Improvement - OORL.MetaLearning.evolve_learning_strategy/3","doc":"Meta-learning enables:\n- **Self-Optimization**: Objects improve their own learning\n- **Transfer Learning**: Apply successful strategies to new tasks\n- **Robustness**: Adaptation to changing environments\n- **Efficiency**: Reduced computational waste through optimization","ref":"OORL.MetaLearning.html#evolve_learning_strategy/3-continuous-improvement"},{"type":"function","title":"OORL.MetaLearning.reward_function_evolution/2","doc":"Evolves the object's intrinsic reward function.\n\nAnalyzes goal satisfaction patterns to detect reward misalignment\nand evolve more effective intrinsic reward functions.","ref":"OORL.MetaLearning.html#reward_function_evolution/2"},{"type":"function","title":"Parameters - OORL.MetaLearning.reward_function_evolution/2","doc":"- `object_id` - ID of the object evolving rewards\n- `goal_satisfaction_history` - History of goal achievement","ref":"OORL.MetaLearning.html#reward_function_evolution/2-parameters"},{"type":"function","title":"Returns - OORL.MetaLearning.reward_function_evolution/2","doc":"- `{:reward_evolution_needed, components}` - Evolution recommended\n- `{:no_evolution_needed, score}` - Current rewards are aligned","ref":"OORL.MetaLearning.html#reward_function_evolution/2-returns"},{"type":"module","title":"OORL.PolicyLearning","doc":"Individual policy learning with social awareness based on AAOS interaction dyads","ref":"OORL.PolicyLearning.html"},{"type":"function","title":"OORL.PolicyLearning.interaction_dyad_learning/2","doc":"Learns from interaction dyad experiences.\n\nProcesses learning specifically from dyadic interactions, which often\nprovide higher-quality learning signals due to sustained cooperation.","ref":"OORL.PolicyLearning.html#interaction_dyad_learning/2"},{"type":"function","title":"Parameters - OORL.PolicyLearning.interaction_dyad_learning/2","doc":"- `object_id` - ID of the learning object\n- `dyad_experiences` - Experiences from interaction dyads","ref":"OORL.PolicyLearning.html#interaction_dyad_learning/2-parameters"},{"type":"function","title":"Returns - OORL.PolicyLearning.interaction_dyad_learning/2","doc":"- Aggregated learning updates from all active dyads","ref":"OORL.PolicyLearning.html#interaction_dyad_learning/2-returns"},{"type":"function","title":"OORL.PolicyLearning.social_imitation_learning/3","doc":"Performs selective imitation learning from high-performing peers.\n\nAnalyzes peer performance and compatibility to selectively imitate\nsuccessful behaviors while maintaining object individuality. This\nprevents naive copying and ensures beneficial social learning.","ref":"OORL.PolicyLearning.html#social_imitation_learning/3"},{"type":"function","title":"Parameters - OORL.PolicyLearning.social_imitation_learning/3","doc":"- `object_id` - ID of the learning object\n- `peer_policies` - Map of peer object IDs to their policy specifications\n- `performance_rankings` - List of {peer_id, performance_score} tuples\n  sorted by performance (highest first)","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-parameters"},{"type":"function","title":"Returns - OORL.PolicyLearning.social_imitation_learning/3","doc":"Map of peer IDs to imitation weights (0.0-1.0) where:\n- Higher weights indicate stronger imitation influence\n- Weights are based on both performance and compatibility\n- Zero weights mean no imitation from that peer","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-returns"},{"type":"function","title":"Selection Criteria - OORL.PolicyLearning.social_imitation_learning/3","doc":"Peers are selected for imitation based on:","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-selection-criteria"},{"type":"function","title":"Performance Threshold - OORL.PolicyLearning.social_imitation_learning/3","doc":"- Only top 3 performers are considered\n- Performance must exceed minimum threshold\n- Recent performance weighted more heavily","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-performance-threshold"},{"type":"function","title":"Compatibility Assessment - OORL.PolicyLearning.social_imitation_learning/3","doc":"- Policy similarity and behavioral alignment\n- Successful interaction history\n- Complementary vs competing objectives","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-compatibility-assessment"},{"type":"function","title":"Interaction Dyad Strength - OORL.PolicyLearning.social_imitation_learning/3","doc":"- Stronger dyads indicate successful collaboration\n- Trust and reliability from past interactions\n- Communication effectiveness","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-interaction-dyad-strength"},{"type":"function","title":"Examples - OORL.PolicyLearning.social_imitation_learning/3","doc":"# Imitation learning with performance rankings\n    iex> peer_policies = %{\n    ...>   \"agent_2\" => %{type: :neural, performance: 0.85},\n    ...>   \"agent_3\" => %{type: :tabular, performance: 0.92},\n    ...>   \"agent_4\" => %{type: :neural, performance: 0.78}\n    ...> }\n    iex> performance_rankings = [\n    ...>   {\"agent_3\", 0.92},\n    ...>   {\"agent_2\", 0.85},\n    ...>   {\"agent_4\", 0.78}\n    ...> ]\n    iex> weights = OORL.PolicyLearning.social_imitation_learning(\n    ...>   \"agent_1\", peer_policies, performance_rankings\n    ...> )\n    iex> weights\n    %{\"agent_3\" => 0.75, \"agent_2\" => 0.45}","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-examples"},{"type":"function","title":"Imitation Weight Calculation - OORL.PolicyLearning.social_imitation_learning/3","doc":"The weight for each peer is computed as:\n```\nweight = compatibility * performance * dyad_strength\n```\n\nWhere:\n- `compatibility` ∈ [0.0, 1.0] based on behavioral similarity\n- `performance` ∈ [0.0, 1.0] normalized performance score\n- `dyad_strength` ∈ [0.0, 1.0] interaction dyad effectiveness","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-imitation-weight-calculation"},{"type":"function","title":"Compatibility Factors - OORL.PolicyLearning.social_imitation_learning/3","doc":"Compatibility assessment includes:\n- **Policy Architecture**: Similar neural networks vs tabular policies\n- **Goal Alignment**: Compatible vs conflicting objectives\n- **Behavioral Patterns**: Similar action preferences and strategies\n- **Environmental Niche**: Operating in similar state spaces","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-compatibility-factors"},{"type":"function","title":"Benefits of Selective Imitation - OORL.PolicyLearning.social_imitation_learning/3","doc":"- **Accelerated Learning**: Learn successful strategies faster\n- **Exploration Guidance**: Discover effective action sequences\n- **Robustness**: Multiple perspectives improve policy robustness\n- **Specialization**: Maintain individual strengths while learning","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-benefits-of-selective-imitation"},{"type":"function","title":"Safeguards - OORL.PolicyLearning.social_imitation_learning/3","doc":"- **Individuality Preservation**: Imitation weights bounded to preserve autonomy\n- **Performance Validation**: Verify imitated behaviors improve performance\n- **Compatibility Filtering**: Reject incompatible behavioral patterns\n- **Gradual Integration**: Slowly integrate imitated behaviors","ref":"OORL.PolicyLearning.html#social_imitation_learning/3-safeguards"},{"type":"function","title":"OORL.PolicyLearning.update_policy/3","doc":"Updates an object's policy based on experiences and social context.\n\nPerforms multi-objective policy gradient updates with social regularization\nand interaction dyad awareness. This function integrates individual learning\nwith social learning signals to improve policy performance.","ref":"OORL.PolicyLearning.html#update_policy/3"},{"type":"function","title":"Parameters - OORL.PolicyLearning.update_policy/3","doc":"- `object_id` - ID of the object updating its policy\n- `experiences` - List of recent experiences to learn from:\n  - Each experience contains state, action, reward, next_state\n  - Experiences are weighted by interaction dyad strength\n  - Recent experiences have higher learning weight\n- `social_context` - Social learning context with peer information:\n  - Peer rewards for imitation learning\n  - Observed actions for behavioral copying\n  - Interaction dyad information for weighting","ref":"OORL.PolicyLearning.html#update_policy/3-parameters"},{"type":"function","title":"Returns - OORL.PolicyLearning.update_policy/3","doc":"- `{:ok, policy_updates}` - Successful policy updates containing:\n  - `:parameter_deltas` - Changes to policy parameters\n  - `:learning_rate_adjustment` - Adaptive learning rate modification\n  - `:exploration_modification` - Exploration strategy updates\n- `{:error, reason}` - Update failed due to:\n  - `:insufficient_data` - Not enough experiences for reliable update\n  - `:invalid_experiences` - Malformed experience data\n  - `:ai_reasoning_failed` - AI enhancement failed, using fallback","ref":"OORL.PolicyLearning.html#update_policy/3-returns"},{"type":"function","title":"Learning Algorithm - OORL.PolicyLearning.update_policy/3","doc":"The policy update process:\n\n1. **Experience Weighting**: Weight experiences by dyad strength\n2. **AI Enhancement**: Use AI reasoning for optimization (if available)\n3. **Fallback Learning**: Traditional gradient methods if AI fails\n4. **Social Regularization**: Incorporate peer behavior signals\n5. **Parameter Updates**: Apply computed parameter changes","ref":"OORL.PolicyLearning.html#update_policy/3-learning-algorithm"},{"type":"function","title":"AI-Enhanced Learning - OORL.PolicyLearning.update_policy/3","doc":"When AI reasoning is available, the system:\n- Analyzes experience patterns for optimal learning\n- Considers social compatibility and interaction dynamics\n- Optimizes for multiple objectives simultaneously\n- Provides interpretable learning recommendations","ref":"OORL.PolicyLearning.html#update_policy/3-ai-enhanced-learning"},{"type":"function","title":"Examples - OORL.PolicyLearning.update_policy/3","doc":"# Update policy with experiences and social context\n    iex> experiences = [\n    ...>   %{state: %{x: 0}, action: :right, reward: 1.0, next_state: %{x: 1}},\n    ...>   %{state: %{x: 1}, action: :up, reward: 0.5, next_state: %{x: 1, y: 1}}\n    ...> ]\n    iex> social_context = %{\n    ...>   peer_rewards: [{\"agent_2\", 0.8}],\n    ...>   interaction_dyads: [\"dyad_1\"]\n    ...> }\n    iex> {:ok, updates} = OORL.PolicyLearning.update_policy(\n    ...>   \"agent_1\", experiences, social_context\n    ...> )\n    iex> updates.learning_rate_adjustment\n    1.05","ref":"OORL.PolicyLearning.html#update_policy/3-examples"},{"type":"function","title":"Social Learning Integration - OORL.PolicyLearning.update_policy/3","doc":"Social context enhances learning through:\n- **Peer Imitation**: Higher-performing peers influence policy updates\n- **Dyad Weighting**: Stronger dyads provide more learning signal\n- **Behavioral Alignment**: Policy updates consider social coordination","ref":"OORL.PolicyLearning.html#update_policy/3-social-learning-integration"},{"type":"function","title":"Performance Characteristics - OORL.PolicyLearning.update_policy/3","doc":"- Update time: 2-15ms depending on experience count and AI usage\n- Convergence: Typically 20-50% faster with social learning\n- Stability: Social regularization improves learning stability\n- Scalability: Linear with number of experiences and peer count","ref":"OORL.PolicyLearning.html#update_policy/3-performance-characteristics"},{"type":"module","title":"OORL.ProtocolVerification","doc":"Provides protocol verification capabilities including LTS (Labeled Transition System)\nverification, reachability analysis, and protocol property checking.","ref":"OORL.ProtocolVerification.html"},{"type":"function","title":"OORL.ProtocolVerification.analyze_protocol_completeness/1","doc":"","ref":"OORL.ProtocolVerification.html#analyze_protocol_completeness/1"},{"type":"function","title":"OORL.ProtocolVerification.build_state_graph/1","doc":"","ref":"OORL.ProtocolVerification.html#build_state_graph/1"},{"type":"function","title":"OORL.ProtocolVerification.check_deadlock_freedom/1","doc":"","ref":"OORL.ProtocolVerification.html#check_deadlock_freedom/1"},{"type":"function","title":"OORL.ProtocolVerification.check_liveness_properties/2","doc":"","ref":"OORL.ProtocolVerification.html#check_liveness_properties/2"},{"type":"function","title":"OORL.ProtocolVerification.compute_reachable_states/1","doc":"","ref":"OORL.ProtocolVerification.html#compute_reachable_states/1"},{"type":"function","title":"OORL.ProtocolVerification.verify_reachability_properties/2","doc":"","ref":"OORL.ProtocolVerification.html#verify_reachability_properties/2"},{"type":"module","title":"Object","doc":"Object-Oriented Reinforcement Learning (OORL) Object implementation based on\nAutonomous Agent Object Specification (AAOS).\n\nRepresents an autonomous object with internal state, methods, goals, world model,\ninteraction history, and self-descriptive meta-DSL capabilities.","ref":"Object.html"},{"type":"module","title":"Core Features - Object","doc":"- **Autonomous State Management**: Each object maintains its own internal state\n- **Method Execution**: Objects can execute predefined and dynamic methods\n- **Goal-Oriented Behavior**: Objects have objective functions that guide their actions\n- **World Model**: Objects maintain beliefs about their environment\n- **Interaction History**: Complete record of all interactions with other objects\n- **Meta-DSL**: Self-descriptive language for introspection and self-modification\n- **Communication**: Mailbox system for message passing with other objects\n- **Learning**: Reinforcement learning capabilities with experience replay\n- **Social Learning**: Ability to learn from interactions with peer objects","ref":"Object.html#module-core-features"},{"type":"module","title":"Object Lifecycle - Object","doc":"1. **Creation**: Objects are created with initial state and capabilities\n2. **Interaction**: Objects interact with environment and other objects\n3. **Learning**: Objects update their policies based on experiences\n4. **Evolution**: Objects can modify their own behavior through meta-DSL\n5. **Coordination**: Objects form dyads and coalitions for collaborative tasks","ref":"Object.html#module-object-lifecycle"},{"type":"module","title":"Meta-DSL Constructs - Object","doc":"Objects support several meta-language constructs for self-modification:\n\n- `:define` - Define new attributes or capabilities\n- `:goal` - Modify objective functions\n- `:belief` - Update world model beliefs\n- `:infer` - Perform inference on current knowledge\n- `:decide` - Make decisions based on current state\n- `:learn` - Process learning experiences\n- `:refine` - Adjust learning parameters","ref":"Object.html#module-meta-dsl-constructs"},{"type":"module","title":"Examples - Object","doc":"# Create a basic object\n    object = Object.new(id: \"agent_1\", state: %{energy: 100})\n    \n    # Update object state\n    object = Object.update_state(object, %{energy: 95})\n    \n    # Execute a method\n    {:ok, updated_object} = Object.execute_method(object, :learn, [experience])\n    \n    # Apply meta-DSL construct\n    result = Object.apply_meta_dsl(object, :infer, inference_data)","ref":"Object.html#module-examples"},{"type":"function","title":"Object.apply_meta_dsl/3","doc":"Applies meta-DSL constructs for self-reflection and modification.\n\nExecutes meta-language constructs that allow objects to reason about\nand modify their own behavior, state, and goals. This is a core capability\nfor autonomous self-improvement and adaptation.","ref":"Object.html#apply_meta_dsl/3"},{"type":"function","title":"Parameters - Object.apply_meta_dsl/3","doc":"- `object` - The object to apply meta-DSL construct to\n- `construct` - Meta-DSL construct to execute:\n  - `:define` - Define new attributes or capabilities\n  - `:goal` - Modify objective functions\n  - `:belief` - Update world model beliefs\n  - `:infer` - Perform inference on current knowledge\n  - `:decide` - Make decisions based on current state\n  - `:learn` - Process learning experiences\n  - `:refine` - Adjust learning parameters\n- `args` - Arguments specific to the construct","ref":"Object.html#apply_meta_dsl/3-parameters"},{"type":"function","title":"Returns - Object.apply_meta_dsl/3","doc":"Map containing updates to be applied:\n- `:state_updates` - Updates to object state\n- `:world_model_updates` - Updates to world model\n- `:goal_update` - New goal function\n- `:meta_dsl_updates` - Updates to meta-DSL state","ref":"Object.html#apply_meta_dsl/3-returns"},{"type":"function","title":"Examples - Object.apply_meta_dsl/3","doc":"# Define a new attribute\n    # iex> result = Object.apply_meta_dsl(object, :define, {:confidence, 0.8})\n    # iex> result.state_updates\n    %{confidence: 0.8}\n    \n    # Update beliefs through inference\n    # iex> inference_data = %{observations: [%{light: :on}], priors: %{light: :off}}\n    # iex> Object.apply_meta_dsl(object, :infer, inference_data)\n    %{world_model_updates: %{beliefs: %{light: :on}}, ...}\n    \n    # Make a decision\n    # iex> context = %{options: [:explore, :exploit], current_reward: 0.5}\n    # iex> Object.apply_meta_dsl(object, :decide, context)\n    %{state_updates: %{last_action: :explore}, ...}","ref":"Object.html#apply_meta_dsl/3-examples"},{"type":"function","title":"Meta-DSL Constructs - Object.apply_meta_dsl/3","doc":"Each construct implements specific self-modification capabilities:\n\n- **DEFINE**: Create new state variables or capabilities\n- **GOAL**: Modify or replace objective functions\n- **BELIEF**: Update world model through reasoning\n- **INFER**: Bayesian inference on observations\n- **DECIDE**: Goal-directed decision making\n- **LEARN**: Experience-based learning\n- **REFINE**: Meta-learning parameter adjustment","ref":"Object.html#apply_meta_dsl/3-meta-dsl-constructs"},{"type":"function","title":"Object.create_subtype/2","doc":"Creates a specialized object subtype.\n\nFactory function for creating objects with specialized behaviors and\ncapabilities based on their intended role in the system. Each subtype\ncomes with predefined methods, state structure, and behavioral patterns.","ref":"Object.html#create_subtype/2"},{"type":"function","title":"Parameters - Object.create_subtype/2","doc":"- `subtype` - Object subtype to create:\n  - `:ai_agent` - AI reasoning and learning agent\n  - `:human_client` - Human user interaction interface\n  - `:sensor_object` - Environmental sensing and data collection\n  - `:actuator_object` - Physical action and control\n  - `:coordinator_object` - Multi-object coordination and management\n- `opts` - Additional options passed to subtype constructor","ref":"Object.html#create_subtype/2-parameters"},{"type":"function","title":"Returns - Object.create_subtype/2","doc":"Specialized object with subtype-specific capabilities.","ref":"Object.html#create_subtype/2-returns"},{"type":"function","title":"Subtype Characteristics - Object.create_subtype/2","doc":"","ref":"Object.html#create_subtype/2-subtype-characteristics"},{"type":"function","title":"AI Agent - Object.create_subtype/2","doc":"- Methods: [:learn, :reason, :plan, :execute, :adapt, :self_modify]\n- Capabilities: Advanced reasoning, meta-learning, adaptation\n- Use cases: Autonomous decision making, complex problem solving","ref":"Object.html#create_subtype/2-ai-agent"},{"type":"function","title":"Human Client - Object.create_subtype/2","doc":"- Methods: [:communicate, :provide_feedback, :request_service]\n- Capabilities: Natural language interface, preference learning\n- Use cases: Human-AI collaboration, user interfaces","ref":"Object.html#create_subtype/2-human-client"},{"type":"function","title":"Sensor Object - Object.create_subtype/2","doc":"- Methods: [:sense, :calibrate, :filter_noise, :transmit_data]\n- Capabilities: Environmental monitoring, data preprocessing\n- Use cases: IoT sensors, monitoring systems","ref":"Object.html#create_subtype/2-sensor-object"},{"type":"function","title":"Actuator Object - Object.create_subtype/2","doc":"- Methods: [:execute_action, :queue_action, :calibrate_motion, :monitor_wear]\n- Capabilities: Physical control, motion planning, safety monitoring\n- Use cases: Robotics, industrial control, automation","ref":"Object.html#create_subtype/2-actuator-object"},{"type":"function","title":"Coordinator Object - Object.create_subtype/2","doc":"- Methods: [:coordinate, :resolve_conflicts, :allocate_resources, :monitor_performance]\n- Capabilities: Multi-agent coordination, resource management\n- Use cases: System orchestration, resource allocation","ref":"Object.html#create_subtype/2-coordinator-object"},{"type":"function","title":"Examples - Object.create_subtype/2","doc":"# Create an AI agent with advanced capabilities\n    # iex> agent = Object.create_subtype(:ai_agent, \n    ...>   id: \"reasoning_agent\",\n    ...>   state: %{intelligence_level: :advanced}\n    ...> )\n    # iex> agent.subtype\n    :ai_agent\n    # iex> :reason in agent.methods\n    true\n    \n    # Create a sensor with specific configuration\n    # iex> sensor = Object.create_subtype(:sensor_object,\n    ...>   id: \"temp_sensor\",\n    ...>   state: %{sensor_type: :temperature, accuracy: 0.98}\n    ...> )\n    # iex> :calibrate in sensor.methods\n    true","ref":"Object.html#create_subtype/2-examples"},{"type":"function","title":"Customization - Object.create_subtype/2","doc":"All subtypes can be further customized:\n- Add additional methods\n- Modify state structure\n- Override default behaviors\n- Extend capabilities","ref":"Object.html#create_subtype/2-customization"},{"type":"function","title":"Object.embed/2","doc":"Generates an embedding representation of the object.\n\nCreates a dense vector representation of the object that captures its\nessential characteristics. This embedding can be used for similarity\ncalculations, clustering, and machine learning applications.","ref":"Object.html#embed/2"},{"type":"function","title":"Parameters - Object.embed/2","doc":"- `object` - The object to embed\n- `dimension` - Embedding vector dimension (default: 64)","ref":"Object.html#embed/2-parameters"},{"type":"function","title":"Returns - Object.embed/2","doc":"List of floats representing the object in the embedding space.\nValues are normalized to the range [-1, 1].","ref":"Object.html#embed/2-returns"},{"type":"function","title":"Embedding Strategy - Object.embed/2","doc":"The embedding is based on:\n- Object state hash for state information\n- Methods hash for capability information\n- Deterministic random generation for reproducibility","ref":"Object.html#embed/2-embedding-strategy"},{"type":"function","title":"Examples - Object.embed/2","doc":"# Generate 64-dimensional embedding\n    # iex> embedding = Object.embed(object)\n    # iex> length(embedding)\n    64\n    # iex> Enum.all?(embedding, fn x -> x >= -1 and x <= 1 end)\n    true\n    \n    # Custom dimension\n    # iex> small_embed = Object.embed(object, 8)\n    # iex> length(small_embed)\n    8","ref":"Object.html#embed/2-examples"},{"type":"function","title":"Use Cases - Object.embed/2","doc":"- **Similarity Search**: Find similar objects efficiently\n- **Clustering**: Group objects by embedded characteristics\n- **Visualization**: Project objects to 2D/3D for analysis\n- **Machine Learning**: Features for ML models","ref":"Object.html#embed/2-use-cases"},{"type":"function","title":"Properties - Object.embed/2","doc":"- **Deterministic**: Same object always produces same embedding\n- **Stable**: Small object changes produce small embedding changes\n- **Distributed**: Similar objects have similar embeddings","ref":"Object.html#embed/2-properties"},{"type":"function","title":"Object.evaluate_goal/1","doc":"Evaluates the object's goal function against current state.\n\nComputes how well the object's current state satisfies its objectives\nby applying the goal function to the current state. This is used for\ndecision-making and learning signal generation.","ref":"Object.html#evaluate_goal/1"},{"type":"function","title":"Parameters - Object.evaluate_goal/1","doc":"- `object` - The object whose goal to evaluate","ref":"Object.html#evaluate_goal/1-parameters"},{"type":"function","title":"Returns - Object.evaluate_goal/1","doc":"Numerical goal satisfaction score. Higher values indicate better goal achievement.","ref":"Object.html#evaluate_goal/1-returns"},{"type":"function","title":"Examples - Object.evaluate_goal/1","doc":"# Object with energy maximization goal\n    # iex> object = Object.new(state: %{energy: 80})\n    # iex> Object.evaluate_goal(object)\n    80\n    \n    # Custom goal function\n    # iex> goal_fn = fn state -> state.x + state.y end\n    # iex> object = Object.new(state: %{x: 3, y: 4}, goal: goal_fn)\n    # iex> Object.evaluate_goal(object)\n    7","ref":"Object.html#evaluate_goal/1-examples"},{"type":"function","title":"Goal Function Types - Object.evaluate_goal/1","doc":"- **Maximization**: Maximize sum of numeric state values (default)\n- **Distance**: Minimize distance to target state\n- **Composite**: Weighted combination of multiple objectives\n- **Learned**: Evolved through meta-learning processes","ref":"Object.html#evaluate_goal/1-goal-function-types"},{"type":"function","title":"Object.execute_method/3","doc":"Executes a method on the object with comprehensive error handling and resource protection.\n\nInvokes the specified method with given arguments, ensuring the method is available\nand the system has sufficient resources. All method executions are protected by\ncircuit breakers and retry logic to ensure system stability.","ref":"Object.html#execute_method/3"},{"type":"function","title":"Parameters - Object.execute_method/3","doc":"- `object` - The object to execute the method on\n- `method` - Method name (must be in object's methods list)\n- `args` - List of arguments to pass to the method (default: [])","ref":"Object.html#execute_method/3-parameters"},{"type":"function","title":"Returns - Object.execute_method/3","doc":"- `{:ok, updated_object}` - Method executed successfully\n- `{:error, reason}` - Method execution failed","ref":"Object.html#execute_method/3-returns"},{"type":"function","title":"Error Conditions - Object.execute_method/3","doc":"- `:method_not_available` - Method not in object's methods list\n- `:throttled` - System under high load, execution delayed\n- `:timeout` - Method execution exceeded time limit\n- `:resource_exhausted` - Insufficient system resources","ref":"Object.html#execute_method/3-error-conditions"},{"type":"function","title":"Examples - Object.execute_method/3","doc":"# Execute a learning method\n    # iex> experience = %{reward: 1.0, action: :move_forward}\n    # iex> {:ok, updated} = Object.execute_method(object, :learn, [experience])\n    # iex> updated.state.q_values\n    %{move_forward: 0.01}\n    \n    # Execute state update method\n    # iex> {:ok, updated} = Object.execute_method(object, :update_state, [%{energy: 95}])\n    # iex> updated.state.energy\n    95\n    \n    # Method not available\n    # iex> Object.execute_method(object, :invalid_method, [])\n    {:error, :method_not_available}","ref":"Object.html#execute_method/3-examples"},{"type":"function","title":"Resource Protection - Object.execute_method/3","doc":"- Resource permission checked before execution\n- Circuit breakers prevent system overload\n- Execution timeouts prevent runaway methods\n- Performance monitoring tracks method efficiency","ref":"Object.html#execute_method/3-resource-protection"},{"type":"function","title":"Object.form_interaction_dyad/3","doc":"Forms an interaction dyad with another object.\n\nCreates a bidirectional interaction relationship with another object,\nenabling enhanced communication, coordination, and social learning.\nDyads are fundamental units of social interaction in the AAOS system.","ref":"Object.html#form_interaction_dyad/3"},{"type":"function","title":"Parameters - Object.form_interaction_dyad/3","doc":"- `object` - First object in the dyad\n- `other_object_id` - ID of the second object\n- `compatibility_score` - Initial compatibility assessment (0.0-1.0, default: 0.5)","ref":"Object.html#form_interaction_dyad/3-parameters"},{"type":"function","title":"Returns - Object.form_interaction_dyad/3","doc":"Updated object with dyad information added to mailbox.","ref":"Object.html#form_interaction_dyad/3-returns"},{"type":"function","title":"Compatibility Scoring - Object.form_interaction_dyad/3","doc":"Compatibility scores guide dyad effectiveness:\n- `0.0-0.3` - Low compatibility, limited interaction benefit\n- `0.3-0.7` - Moderate compatibility, good for specific tasks\n- `0.7-1.0` - High compatibility, excellent collaboration potential","ref":"Object.html#form_interaction_dyad/3-compatibility-scoring"},{"type":"function","title":"Examples - Object.form_interaction_dyad/3","doc":"# Form dyad with high compatibility\n    # iex> updated = Object.form_interaction_dyad(object, \"agent_2\", 0.8)\n    # iex> dyads = Object.Mailbox.get_active_dyads(updated.mailbox)\n    # iex> map_size(dyads)\n    1\n    \n    # Default compatibility\n    # iex> Object.form_interaction_dyad(object, \"sensor_1\")\n    %Object{mailbox: %{interaction_dyads: %{\"obj_1-sensor_1\" => %{...}}, ...}, ...}","ref":"Object.html#form_interaction_dyad/3-examples"},{"type":"function","title":"Dyad Benefits - Object.form_interaction_dyad/3","doc":"- **Enhanced Communication**: Priority message routing\n- **Social Learning**: Shared experience and knowledge\n- **Coordination**: Simplified cooperation protocols\n- **Trust Building**: Reputation and reliability tracking","ref":"Object.html#form_interaction_dyad/3-dyad-benefits"},{"type":"function","title":"Lifecycle - Object.form_interaction_dyad/3","doc":"1. **Formation**: Initial dyad creation with compatibility assessment\n2. **Interaction**: Regular communication and coordination\n3. **Evolution**: Compatibility adjustment based on outcomes\n4. **Dissolution**: Automatic or manual dyad termination","ref":"Object.html#form_interaction_dyad/3-lifecycle"},{"type":"function","title":"Object.get_communication_stats/1","doc":"Gets the object's mailbox statistics.\n\nRetrieves comprehensive statistics about the object's communication\npatterns, interaction history, and mailbox performance. Useful for\nmonitoring, debugging, and performance optimization.","ref":"Object.html#get_communication_stats/1"},{"type":"function","title":"Parameters - Object.get_communication_stats/1","doc":"- `object` - The object to get statistics for","ref":"Object.html#get_communication_stats/1-parameters"},{"type":"function","title":"Returns - Object.get_communication_stats/1","doc":"Map containing:\n- `:total_messages_sent` - Number of messages sent\n- `:total_messages_received` - Number of messages received\n- `:pending_inbox` - Current inbox message count\n- `:pending_outbox` - Current outbox message count\n- `:active_dyads` - Number of active interaction dyads\n- `:total_dyads` - Total dyads (including inactive)\n- `:history_size` - Current message history size\n- `:uptime` - Object uptime in seconds","ref":"Object.html#get_communication_stats/1-returns"},{"type":"function","title":"Examples - Object.get_communication_stats/1","doc":"# iex> stats = Object.get_communication_stats(object)\n    # iex> stats.total_messages_sent\n    15\n    # iex> stats.active_dyads\n    3\n    # iex> stats.uptime\n    3600","ref":"Object.html#get_communication_stats/1-examples"},{"type":"function","title":"Monitoring Uses - Object.get_communication_stats/1","doc":"- **Performance**: Message throughput and latency\n- **Health**: Mailbox capacity and processing rates\n- **Social**: Interaction patterns and dyad effectiveness\n- **Debugging**: Message flow analysis and error tracking","ref":"Object.html#get_communication_stats/1-monitoring-uses"},{"type":"function","title":"Performance Metrics - Object.get_communication_stats/1","doc":"Key performance indicators:\n- Messages per second: `total_messages / uptime`\n- Dyad efficiency: `active_dyads / total_dyads`\n- Processing ratio: `pending_inbox / total_received`","ref":"Object.html#get_communication_stats/1-performance-metrics"},{"type":"type","title":"Object.goal_function/0","doc":"Function that evaluates how well the object's current state satisfies its goals","ref":"Object.html#t:goal_function/0"},{"type":"function","title":"Object.interact/2","doc":"Processes an interaction with another object or environment with error protection.\n\nHandles various types of interactions including messages, coordination requests,\nand environmental events. All interactions are recorded in the object's history\nfor learning and analysis purposes.","ref":"Object.html#interact/2"},{"type":"function","title":"Parameters - Object.interact/2","doc":"- `object` - The object processing the interaction\n- `interaction` - Map describing the interaction with required fields:\n  - `:type` - Type of interaction (atom)\n  - Other fields depend on interaction type","ref":"Object.html#interact/2-parameters"},{"type":"function","title":"Returns - Object.interact/2","doc":"Updated object with interaction recorded in history.","ref":"Object.html#interact/2-returns"},{"type":"function","title":"Interaction Types - Object.interact/2","doc":"- `:message` - Message from another object\n- `:coordination` - Coordination request or response\n- `:environmental` - Environmental event or observation\n- `:learning` - Learning signal or feedback","ref":"Object.html#interact/2-interaction-types"},{"type":"function","title":"Examples - Object.interact/2","doc":"# Process a message interaction\n    # iex> interaction = %{type: :message, from: \"agent_2\", content: \"hello\"}\n    # iex> updated = Object.interact(object, interaction)\n    # iex> length(updated.interaction_history)\n    1\n    \n    # Process coordination request\n    # iex> coord = %{type: :coordination, action: :form_coalition}\n    # iex> Object.interact(object, coord)\n    %Object{interaction_history: [%{type: :coordination, outcome: :success, ...}], ...}","ref":"Object.html#interact/2-examples"},{"type":"function","title":"Error Recovery - Object.interact/2","doc":"- Failed interactions are still recorded with error outcomes\n- Circuit breaker prevents cascade failures\n- Retry logic for transient failures\n- Graceful degradation maintains object functionality","ref":"Object.html#interact/2-error-recovery"},{"type":"type","title":"Object.interaction_record/0","doc":"Record of a single interaction with another object or the environment.\n\nContains:\n- `timestamp` - When the interaction occurred\n- `type` - Type of interaction (message, coordination, etc.)\n- `data` - Interaction-specific data\n- `outcome` - Result of the interaction","ref":"Object.html#t:interaction_record/0"},{"type":"function","title":"Object.learn/2","doc":"Implements learning functionality using meta-DSL constructs with error resilience.\n\nProcesses learning experiences using reinforcement learning principles,\nupdating the object's internal policies and knowledge. Learning is protected\nby resource monitoring and circuit breakers to ensure system stability.","ref":"Object.html#learn/2"},{"type":"function","title":"Parameters - Object.learn/2","doc":"- `object` - The object to perform learning on\n- `experience` - Learning experience map containing:\n  - `:reward` - Numerical reward signal\n  - `:action` - Action that was taken\n  - Additional context-specific fields","ref":"Object.html#learn/2-parameters"},{"type":"function","title":"Returns - Object.learn/2","doc":"Updated object with learning applied, or unchanged object if learning failed.","ref":"Object.html#learn/2-returns"},{"type":"function","title":"Learning Algorithm - Object.learn/2","doc":"Uses Q-learning with the following update rule:\n```\nQ(s,a) = Q(s,a) + α * (r - Q(s,a))\n```\n\nWhere:\n- α = learning rate\n- r = reward\n- Q(s,a) = action-value function","ref":"Object.html#learn/2-learning-algorithm"},{"type":"function","title":"Examples - Object.learn/2","doc":"# Learn from positive reward\n    # iex> exp = %{reward: 1.0, action: :explore, state: %{position: {1, 1}}}\n    # iex> learned = Object.learn(object, exp)\n    # iex> learned.state.q_values[:explore]\n    0.01\n    \n    # Learn from negative reward\n    # iex> exp = %{reward: -0.5, action: :retreat}\n    # iex> Object.learn(object, exp)\n    %Object{state: %{q_values: %{retreat: -0.005}}, ...}","ref":"Object.html#learn/2-examples"},{"type":"function","title":"Resource Management - Object.learn/2","doc":"- Learning requests resource permission before execution\n- Exponential backoff retry strategy for failures\n- Circuit breaker prevents learning system overload\n- Performance monitoring tracks learning effectiveness","ref":"Object.html#learn/2-resource-management"},{"type":"type","title":"Object.meta_dsl_state/0","doc":"Meta-DSL state for self-reflection and modification capabilities.\n\nContains:\n- `constructs` - Available meta-DSL constructs\n- `execution_context` - Current execution context\n- `learning_parameters` - Parameters for learning algorithms","ref":"Object.html#t:meta_dsl_state/0"},{"type":"type","title":"Object.method_name/0","doc":"Name of a method that can be executed on an object","ref":"Object.html#t:method_name/0"},{"type":"function","title":"Object.new/1","doc":"Creates a new Object with the specified attributes.\n\nInitializes a complete autonomous object with all AAOS-compliant capabilities\nincluding communication, learning, and meta-reasoning. Objects are created\nwith default behaviors that can be customized through the options.","ref":"Object.html#new/1"},{"type":"function","title":"Parameters - Object.new/1","doc":"- `opts` - Keyword list of options for object creation:\n  - `:id` - Unique identifier for the object (auto-generated if not provided)\n  - `:state` - Internal state parameters (default: empty map)\n  - `:methods` - Available methods/functions (default: [:update_state, :interact, :learn])\n  - `:goal` - Objective function (default: maximize state values)\n  - `:world_model` - Beliefs about environment (default: empty beliefs)\n  - `:meta_dsl` - Self-descriptive meta-language constructs (auto-initialized)\n  - `:parameters` - Configuration parameters (default: empty map)\n  - `:subtype` - Object specialization type (default: :generic)","ref":"Object.html#new/1-parameters"},{"type":"function","title":"Returns - Object.new/1","doc":"New Object struct with all fields initialized and ready for use.","ref":"Object.html#new/1-returns"},{"type":"function","title":"Examples - Object.new/1","doc":"# Create a basic sensor object\n    # iex> Object.new(id: \"sensor_1\", state: %{readings: [1, 2, 3]})\n    %Object{id: \"sensor_1\", state: %{readings: [1, 2, 3]}, ...}\n    \n    # Create an AI agent with custom goal function\n    # iex> goal_fn = fn state -> Map.get(state, :performance, 0) end\n    # iex> Object.new(id: \"ai_agent\", subtype: :ai_agent, goal: goal_fn)\n    %Object{id: \"ai_agent\", subtype: :ai_agent, goal: #Function<...>, ...}\n    \n    # Create object with specific methods and parameters\n    # iex> Object.new(\n    ...>   id: \"coordinator\", \n    ...>   methods: [:coordinate, :allocate_resources, :monitor],\n    ...>   parameters: %{max_coordination_objects: 10}\n    ...> )\n    %Object{id: \"coordinator\", methods: [:coordinate, :allocate_resources, :monitor], ...}","ref":"Object.html#new/1-examples"},{"type":"function","title":"Performance Characteristics - Object.new/1","doc":"- Object creation: ~0.1ms for basic objects\n- Memory usage: ~1KB base + state size\n- Mailbox initialization: ~0.05ms\n- Meta-DSL setup: ~0.02ms","ref":"Object.html#new/1-performance-characteristics"},{"type":"type","title":"Object.object_id/0","doc":"Unique object identifier","ref":"Object.html#t:object_id/0"},{"type":"type","title":"Object.object_state/0","doc":"Object's internal state containing any key-value pairs","ref":"Object.html#t:object_state/0"},{"type":"type","title":"Object.object_subtype/0","doc":"Object subtype defining specialized behavior","ref":"Object.html#t:object_subtype/0"},{"type":"type","title":"Object.parameters_map/0","doc":"Configuration parameters for object behavior","ref":"Object.html#t:parameters_map/0"},{"type":"function","title":"Object.process_messages/1","doc":"Processes all messages in the object's mailbox.\n\nProcesses all pending messages in the inbox according to priority and type,\napplying appropriate message handlers and updating object state as needed.\nThis is typically called periodically by the object server.","ref":"Object.html#process_messages/1"},{"type":"function","title":"Parameters - Object.process_messages/1","doc":"- `object` - The object whose messages to process","ref":"Object.html#process_messages/1-parameters"},{"type":"function","title":"Returns - Object.process_messages/1","doc":"`{processed_messages, updated_object}` where:\n- `processed_messages` - List of processed messages with outcomes\n- `updated_object` - Object with updated state and cleared inbox","ref":"Object.html#process_messages/1-returns"},{"type":"function","title":"Processing Order - Object.process_messages/1","doc":"Messages are processed in priority order:\n1. `:critical` - System-critical messages\n2. `:high` - Important coordination messages\n3. `:medium` - Regular operational messages\n4. `:low` - Background and maintenance messages","ref":"Object.html#process_messages/1-processing-order"},{"type":"function","title":"Examples - Object.process_messages/1","doc":"# Process accumulated messages\n    # {processed, updated} = Object.process_messages(object)\n    # length(processed) == 3\n    # length(updated.mailbox.inbox) == 0\n    \n    # Check processing outcomes\n    # {[{msg1, result1}, {msg2, result2}], _obj} = Object.process_messages(object)\n    # result1 == {:coordination_received, %{action: :form_coalition}}","ref":"Object.html#process_messages/1-examples"},{"type":"function","title":"Message Handlers - Object.process_messages/1","doc":"Each message type has a specific handler:\n- `:state_update` → Update object state\n- `:coordination` → Process coordination request\n- `:learning_signal` → Apply learning update\n- `:heartbeat` → Update connection status\n- `:negotiation` → Handle negotiation step","ref":"Object.html#process_messages/1-message-handlers"},{"type":"function","title":"Performance - Object.process_messages/1","doc":"- Batch processing for efficiency\n- Priority-based ordering prevents starvation\n- Bounded processing time prevents blocking\n- Error isolation prevents cascade failures","ref":"Object.html#process_messages/1-performance"},{"type":"function","title":"Object.receive_message/2","doc":"Receives a message into the object's mailbox with error resilience.\n\nAccepts an incoming message into the object's mailbox with comprehensive\nvalidation, error recovery, and poison message handling. Messages are\nprocessed according to their type and priority.","ref":"Object.html#receive_message/2"},{"type":"function","title":"Parameters - Object.receive_message/2","doc":"- `object` - The receiving object\n- `message` - Message to receive with required fields:\n  - `:id` - Unique message identifier\n  - `:from` - Sender object ID\n  - `:to` - Recipient object ID (should match this object)\n  - `:type` - Message type (atom)\n  - `:content` - Message content\n  - `:timestamp` - Message timestamp","ref":"Object.html#receive_message/2-parameters"},{"type":"function","title":"Returns - Object.receive_message/2","doc":"- `{:ok, updated_object}` - Message received successfully\n- `{:error, reason}` - Message reception failed","ref":"Object.html#receive_message/2-returns"},{"type":"function","title":"Error Conditions - Object.receive_message/2","doc":"- `:malformed_message` - Message missing required fields\n- `:mailbox_full` - Mailbox capacity exceeded\n- `:invalid_timestamp` - Message timestamp invalid\n- `:poison_message` - Message failed validation multiple times","ref":"Object.html#receive_message/2-error-conditions"},{"type":"function","title":"Examples - Object.receive_message/2","doc":"# Receive a valid message\n    # iex> message = %{\n    ...>   id: \"msg_123\",\n    ...>   from: \"sender_1\",\n    ...>   to: object.id,\n    ...>   type: :coordination,\n    ...>   content: %{action: :join_coalition},\n    ...>   timestamp: DateTime.utc_now()\n    ...> }\n    # iex> {:ok, updated} = Object.receive_message(object, message)\n    # iex> length(updated.mailbox.inbox)\n    1\n    \n    # Invalid message format\n    # iex> bad_message = %{invalid: true}\n    # iex> Object.receive_message(object, bad_message)\n    {:error, {:malformed_message, {:missing_fields, [:id, :from, ...]}}}","ref":"Object.html#receive_message/2-examples"},{"type":"function","title":"Message Processing - Object.receive_message/2","doc":"- **Validation**: Format and field validation\n- **Deduplication**: Prevents duplicate message processing\n- **Priority Ordering**: High-priority messages processed first\n- **Acknowledgments**: Automatic ACK for messages requiring confirmation","ref":"Object.html#receive_message/2-message-processing"},{"type":"function","title":"Resilience Features - Object.receive_message/2","doc":"- Malformed messages sent to poison message queue\n- Transient errors trigger retry logic\n- Circuit breaker prevents mailbox overload\n- Graceful degradation under resource pressure","ref":"Object.html#receive_message/2-resilience-features"},{"type":"function","title":"Object.send_message/5","doc":"Sends a message to another object via the mailbox system with delivery guarantees.\n\nRoutes a message through the mailbox and message routing system with comprehensive\nerror handling, delivery guarantees, and dead letter queue fallback for failed\ndeliveries. All messages are tracked for debugging and performance analysis.","ref":"Object.html#send_message/5"},{"type":"function","title":"Parameters - Object.send_message/5","doc":"- `object` - The sending object\n- `to_object_id` - ID of the recipient object\n- `message_type` - Type of message (atom) for routing and handling\n- `content` - Message content (any term)\n- `opts` - Delivery options:\n  - `:priority` - Message priority (:low, :medium, :high, :critical)\n  - `:requires_ack` - Whether delivery confirmation is required\n  - `:ttl` - Time-to-live in seconds (default: 3600)\n  - `:retry_count` - Number of retry attempts on failure","ref":"Object.html#send_message/5-parameters"},{"type":"function","title":"Returns - Object.send_message/5","doc":"Updated object with message sent and mailbox updated.","ref":"Object.html#send_message/5-returns"},{"type":"function","title":"Message Types - Object.send_message/5","doc":"Common message types include:\n- `:state_update` - State change notification\n- `:coordination` - Coordination request/response\n- `:learning_signal` - Learning feedback or data\n- `:heartbeat` - Connectivity check\n- `:negotiation` - Negotiation protocol messages","ref":"Object.html#send_message/5-message-types"},{"type":"function","title":"Examples - Object.send_message/5","doc":"# Send a coordination request\n    # iex> updated = Object.send_message(object, \"coordinator_1\", \n    ...>   :coordination, %{action: :form_coalition},\n    ...>   priority: :high, requires_ack: true)\n    # iex> length(updated.mailbox.outbox)\n    1\n    \n    # Send learning signal with TTL\n    # iex> Object.send_message(object, \"learner_2\",\n    ...>   :learning_signal, %{reward: 1.0}, ttl: 300)\n    %Object{mailbox: %{outbox: [%{ttl: 300, ...}], ...}, ...}","ref":"Object.html#send_message/5-examples"},{"type":"function","title":"Delivery Guarantees - Object.send_message/5","doc":"- **At-least-once**: Messages with `requires_ack: true`\n- **Best-effort**: Regular messages (may be lost under extreme load)\n- **Dead letter queue**: Failed messages are queued for retry\n- **Circuit breaker**: Prevents cascade failures from unreachable objects","ref":"Object.html#send_message/5-delivery-guarantees"},{"type":"function","title":"Error Handling - Object.send_message/5","doc":"- Message validation before sending\n- Automatic retry with exponential backoff\n- Dead letter queue for persistent failures\n- Graceful degradation under resource pressure","ref":"Object.html#send_message/5-error-handling"},{"type":"function","title":"Object.similarity/2","doc":"Calculates similarity between two objects.\n\nComputes a similarity score between two objects based on their state,\nmethods, and goal functions. This is useful for clustering, coalition\nformation, and social learning partner selection.","ref":"Object.html#similarity/2"},{"type":"function","title":"Parameters - Object.similarity/2","doc":"- `obj1` - First object for comparison\n- `obj2` - Second object for comparison","ref":"Object.html#similarity/2-parameters"},{"type":"function","title":"Returns - Object.similarity/2","doc":"Similarity score between 0.0 (completely different) and 1.0 (identical).","ref":"Object.html#similarity/2-returns"},{"type":"function","title":"Similarity Metrics - Object.similarity/2","doc":"The overall similarity is the average of:\n- **State similarity**: Based on common state variables and their values\n- **Method similarity**: Jaccard similarity of method sets\n- **Goal similarity**: Functional similarity based on sample evaluations","ref":"Object.html#similarity/2-similarity-metrics"},{"type":"function","title":"Examples - Object.similarity/2","doc":"# Identical objects\n    # iex> obj1 = Object.new(state: %{x: 1})\n    # iex> obj2 = Object.new(state: %{x: 1})\n    # iex> Object.similarity(obj1, obj2)\n    1.0\n    \n    # Partially similar objects\n    # iex> sensor1 = Object.new(methods: [:sense, :transmit])\n    # iex> sensor2 = Object.new(methods: [:sense, :filter])\n    # iex> Object.similarity(sensor1, sensor2)  # 50% method overlap\n    0.67","ref":"Object.html#similarity/2-examples"},{"type":"function","title":"Use Cases - Object.similarity/2","doc":"- **Coalition Formation**: Find compatible partners\n- **Social Learning**: Identify good imitation targets\n- **Object Clustering**: Group similar objects\n- **Dyad Formation**: Assess interaction compatibility","ref":"Object.html#similarity/2-use-cases"},{"type":"type","title":"Object.t/0","doc":"Core Object type representing an autonomous agent in the AAOS system.","ref":"Object.html#t:t/0"},{"type":"type","title":"Fields - Object.t/0","doc":"- `id` - Unique identifier for the object (must be unique across the system)\n- `state` - Internal state map containing object's current state variables\n- `methods` - List of available methods this object can execute\n- `goal` - Objective function that evaluates state for goal achievement\n- `world_model` - Beliefs and knowledge about the environment\n- `interaction_history` - Complete history of interactions with other objects\n- `meta_dsl` - Meta-language constructs for self-reflection and modification\n- `parameters` - Configuration parameters for object behavior\n- `mailbox` - Communication mailbox for message passing\n- `subtype` - Specific object subtype (ai_agent, sensor_object, etc.)\n- `created_at` - Timestamp when object was created\n- `updated_at` - Timestamp of last modification","ref":"Object.html#t:t/0-fields"},{"type":"function","title":"Object.update_state/2","doc":"Updates the object's internal state with comprehensive error handling.\n\nPerforms a safe merge of the new state with the existing state, validating\nthe update before applying it. If validation fails, the original object\nis returned unchanged and an error is logged.","ref":"Object.html#update_state/2"},{"type":"function","title":"Parameters - Object.update_state/2","doc":"- `object` - The object to update\n- `new_state` - Map of state updates to merge into current state","ref":"Object.html#update_state/2-parameters"},{"type":"function","title":"Returns - Object.update_state/2","doc":"Updated object with merged state, or unchanged object if validation failed.","ref":"Object.html#update_state/2-returns"},{"type":"function","title":"Validation Rules - Object.update_state/2","doc":"- New state must be a map\n- State size cannot exceed 100 entries\n- Cannot contain forbidden keys (:__internal__, :__system__, :__meta__)","ref":"Object.html#update_state/2-validation-rules"},{"type":"function","title":"Examples - Object.update_state/2","doc":"# Update sensor readings\n    # iex> sensor = Object.new(id: \"temp_sensor\", state: %{temp: 20.0})\n    # iex> updated = Object.update_state(sensor, %{temp: 22.5, humidity: 65})\n    # iex> updated.state\n    %{temp: 22.5, humidity: 65}\n    \n    # Incremental updates preserve existing state\n    # iex> agent = Object.new(state: %{energy: 100, position: {0, 0}})\n    # iex> updated = Object.update_state(agent, %{energy: 95})\n    # iex> updated.state\n    %{energy: 95, position: {0, 0}}","ref":"Object.html#update_state/2-examples"},{"type":"function","title":"Error Handling - Object.update_state/2","doc":"- Invalid state formats are rejected and logged\n- State size limits prevent memory exhaustion\n- Forbidden keys are blocked to maintain system integrity\n- All errors are handled gracefully without crashing the object","ref":"Object.html#update_state/2-error-handling"},{"type":"function","title":"Object.update_world_model/2","doc":"Updates the object's world model based on observations.\n\nMerges new observations into the object's current beliefs about the world.\nThis is a fundamental operation for maintaining accurate environmental\nknowledge and enabling effective decision-making.","ref":"Object.html#update_world_model/2"},{"type":"function","title":"Parameters - Object.update_world_model/2","doc":"- `object` - The object whose world model to update\n- `observations` - Map of new observations to incorporate","ref":"Object.html#update_world_model/2-parameters"},{"type":"function","title":"Returns - Object.update_world_model/2","doc":"Updated object with modified world model.","ref":"Object.html#update_world_model/2-returns"},{"type":"function","title":"Examples - Object.update_world_model/2","doc":"# Update environmental observations\n    # iex> obs = %{temperature: 22.5, other_agents: [\"agent_2\", \"agent_3\"]}\n    # iex> updated = Object.update_world_model(object, obs)\n    # iex> updated.world_model.beliefs.temperature\n    22.5\n    \n    # Incremental belief updates\n    # iex> Object.update_world_model(object, %{light_level: :bright})\n    %Object{world_model: %{beliefs: %{light_level: :bright}, ...}, ...}","ref":"Object.html#update_world_model/2-examples"},{"type":"function","title":"World Model Structure - Object.update_world_model/2","doc":"The world model contains:\n- Current beliefs about environmental state\n- Uncertainty estimates for each belief\n- Historical observations for trend analysis","ref":"Object.html#update_world_model/2-world-model-structure"},{"type":"type","title":"Object.world_model/0","doc":"Object's beliefs and knowledge about its environment.\n\nContains:\n- `beliefs` - Current beliefs about the world state\n- `uncertainties` - Uncertainty estimates for beliefs","ref":"Object.html#t:world_model/0"},{"type":"module","title":"Object.AIReasoning","doc":"Advanced AI reasoning capabilities for AAOS objects using DSPy framework.\nProvides pre-built signatures for common object behaviors and interactions.","ref":"Object.AIReasoning.html"},{"type":"function","title":"Object.AIReasoning.adapt_behavior/5","doc":"Adapts object behavior based on performance feedback and environmental changes.","ref":"Object.AIReasoning.html#adapt_behavior/5"},{"type":"function","title":"Parameters - Object.AIReasoning.adapt_behavior/5","doc":"- `object_id`: The ID of the reasoning object\n- `current_behavior`: Description of current behavior patterns\n- `metrics`: Recent performance data and feedback\n- `environment`: Current environmental conditions\n- `goals`: Object's current goals and objectives","ref":"Object.AIReasoning.html#adapt_behavior/5-parameters"},{"type":"function","title":"Returns - Object.AIReasoning.adapt_behavior/5","doc":"Behavior adaptation recommendations with reasoning and risk assessment","ref":"Object.AIReasoning.html#adapt_behavior/5-returns"},{"type":"function","title":"Object.AIReasoning.analyze_message/4","doc":"Analyzes incoming messages using AI reasoning to determine intent, priority, and recommended actions.","ref":"Object.AIReasoning.html#analyze_message/4"},{"type":"function","title":"Parameters - Object.AIReasoning.analyze_message/4","doc":"- `object_id`: The ID of the reasoning object\n- `sender`: ID of the message sender\n- `content`: Message content to analyze\n- `context`: Current object state and interaction history","ref":"Object.AIReasoning.html#analyze_message/4-parameters"},{"type":"function","title":"Returns - Object.AIReasoning.analyze_message/4","doc":"AI analysis result containing intent, priority, suggested actions, and confidence score","ref":"Object.AIReasoning.html#analyze_message/4-returns"},{"type":"function","title":"Object.AIReasoning.get_reasoning_performance/1","doc":"Gets performance metrics for the reasoning system.","ref":"Object.AIReasoning.html#get_reasoning_performance/1"},{"type":"function","title":"Parameters - Object.AIReasoning.get_reasoning_performance/1","doc":"- `object_id`: The ID of the reasoning object","ref":"Object.AIReasoning.html#get_reasoning_performance/1-parameters"},{"type":"function","title":"Returns - Object.AIReasoning.get_reasoning_performance/1","doc":"Performance metrics including query count, cache hits, and average latency","ref":"Object.AIReasoning.html#get_reasoning_performance/1-returns"},{"type":"function","title":"Object.AIReasoning.initialize_object_reasoning/1","doc":"Initializes AI reasoning capabilities for an object by starting a DSPy bridge\nand registering common reasoning signatures.","ref":"Object.AIReasoning.html#initialize_object_reasoning/1"},{"type":"function","title":"Parameters - Object.AIReasoning.initialize_object_reasoning/1","doc":"- `object_id`: The ID of the object to initialize reasoning for","ref":"Object.AIReasoning.html#initialize_object_reasoning/1-parameters"},{"type":"function","title":"Returns - Object.AIReasoning.initialize_object_reasoning/1","doc":"- `{:ok, object_id}` on successful initialization\n- `{:error, reason}` if initialization fails","ref":"Object.AIReasoning.html#initialize_object_reasoning/1-returns"},{"type":"function","title":"Examples - Object.AIReasoning.initialize_object_reasoning/1","doc":"iex> Object.AIReasoning.initialize_object_reasoning(\"agent_1\")\n    {:ok, \"agent_1\"}","ref":"Object.AIReasoning.html#initialize_object_reasoning/1-examples"},{"type":"function","title":"Object.AIReasoning.plan_interaction/5","doc":"Plans optimal interaction strategies with other objects or agents.","ref":"Object.AIReasoning.html#plan_interaction/5"},{"type":"function","title":"Parameters - Object.AIReasoning.plan_interaction/5","doc":"- `object_id`: The ID of the reasoning object\n- `targets`: List of objects/agents to interact with\n- `goal`: Desired outcome of the interaction\n- `resources`: Resources available for the interaction\n- `constraints`: Any limitations or constraints to consider","ref":"Object.AIReasoning.html#plan_interaction/5-parameters"},{"type":"function","title":"Returns - Object.AIReasoning.plan_interaction/5","doc":"Interaction plan with strategy, timing, and fallback options","ref":"Object.AIReasoning.html#plan_interaction/5-returns"},{"type":"function","title":"Object.AIReasoning.register_custom_signature/3","doc":"Registers a custom DSPy signature for specific reasoning tasks.","ref":"Object.AIReasoning.html#register_custom_signature/3"},{"type":"function","title":"Parameters - Object.AIReasoning.register_custom_signature/3","doc":"- `object_id`: The ID of the reasoning object\n- `name`: Name for the custom signature\n- `signature_spec`: Specification of inputs, outputs, and instructions","ref":"Object.AIReasoning.html#register_custom_signature/3-parameters"},{"type":"function","title":"Returns - Object.AIReasoning.register_custom_signature/3","doc":"`:ok` on successful registration","ref":"Object.AIReasoning.html#register_custom_signature/3-returns"},{"type":"function","title":"Object.AIReasoning.solve_problem/5","doc":"Performs systematic problem-solving using chain-of-thought reasoning.","ref":"Object.AIReasoning.html#solve_problem/5"},{"type":"function","title":"Parameters - Object.AIReasoning.solve_problem/5","doc":"- `object_id`: The ID of the reasoning object\n- `problem`: Clear description of the problem to solve\n- `information`: All relevant information and data\n- `constraints`: Limitations and requirements to consider\n- `criteria`: How to measure successful resolution","ref":"Object.AIReasoning.html#solve_problem/5-parameters"},{"type":"function","title":"Returns - Object.AIReasoning.solve_problem/5","doc":"Problem analysis, solution approach, implementation plan, and verification method","ref":"Object.AIReasoning.html#solve_problem/5-returns"},{"type":"function","title":"Object.AIReasoning.synthesize_learning/5","doc":"Synthesizes learning from experiences and updates knowledge base.","ref":"Object.AIReasoning.html#synthesize_learning/5"},{"type":"function","title":"Parameters - Object.AIReasoning.synthesize_learning/5","doc":"- `object_id`: The ID of the reasoning object\n- `experiences`: Recent experiences and outcomes\n- `knowledge`: Current knowledge and beliefs\n- `feedback`: External feedback received\n- `context`: Environmental and situational context","ref":"Object.AIReasoning.html#synthesize_learning/5-parameters"},{"type":"function","title":"Returns - Object.AIReasoning.synthesize_learning/5","doc":"Key insights, knowledge updates, pattern recognition, and future applications","ref":"Object.AIReasoning.html#synthesize_learning/5-returns"},{"type":"module","title":"Object.Application","doc":"Main OTP Application for the AAOS Object system.\n\nThis module implements the main supervision tree and system initialization\nfor the Autonomous Agent Object Specification (AAOS) framework. It manages:\n\n- Core object supervision and lifecycle management\n- Message routing infrastructure\n- System-wide coordination services\n- Performance monitoring and telemetry\n- Demonstration system creation\n- Health monitoring and alerts\n\nThe application follows OTP principles with a hierarchical supervision\nstrategy that ensures fault tolerance and system resilience.","ref":"Object.Application.html"},{"type":"function","title":"Object.Application.create_demonstration_system/0","doc":"Creates a complete demonstration system with various object types.\n\nSets up a realistic demonstration environment including:\n- AI agents with different capabilities\n- Human client objects\n- Sensor and actuator objects\n- Coordinator objects\n- Interaction dyads between related objects\n- Coordination tasks and scenarios\n\nThis is useful for testing, demos, and understanding system behavior.","ref":"Object.Application.html#create_demonstration_system/0"},{"type":"function","title":"Returns - Object.Application.create_demonstration_system/0","doc":"Map containing:\n- `:objects_created` - Number of successfully created objects\n- `:total_objects` - Total objects attempted\n- `:results` - Detailed results for each object creation attempt","ref":"Object.Application.html#create_demonstration_system/0-returns"},{"type":"function","title":"Examples - Object.Application.create_demonstration_system/0","doc":"iex> Object.Application.create_demonstration_system()\n    %{\n      objects_created: 7,\n      total_objects: 7,\n      results: [{:ok, \"ai_agent_alpha\", #PID<0.789.0>}, ...]\n    }","ref":"Object.Application.html#create_demonstration_system/0-examples"},{"type":"function","title":"Object.Application.create_object/1","doc":"Creates a new object in the system.\n\nDynamically starts a new object server under the dynamic supervisor\nwith the provided specification.","ref":"Object.Application.html#create_object/1"},{"type":"function","title":"Parameters - Object.Application.create_object/1","doc":"- `object_spec` - Object specification struct with id, state, methods, etc.","ref":"Object.Application.html#create_object/1-parameters"},{"type":"function","title":"Returns - Object.Application.create_object/1","doc":"- `{:ok, pid}` - Success with the object's process PID\n- `{:error, reason}` - Failure reason","ref":"Object.Application.html#create_object/1-returns"},{"type":"function","title":"Examples - Object.Application.create_object/1","doc":"iex> spec = %Object{id: \"test_obj\", state: %{value: 1}}\n    iex> Object.Application.create_object(spec)\n    {:ok, #PID<0.456.0>}","ref":"Object.Application.html#create_object/1-examples"},{"type":"function","title":"Object.Application.get_system_status/0","doc":"Gets comprehensive system status information.\n\nReturns detailed metrics about system health, performance,\nand operational status across all subsystems.","ref":"Object.Application.html#get_system_status/0"},{"type":"function","title":"Returns - Object.Application.get_system_status/0","doc":"Map containing:\n- `:objects` - Object count and type information\n- `:performance` - System performance metrics\n- `:coordination` - Coordination service metrics\n- `:evolution` - Schema evolution metrics\n- `:message_routing` - Message routing statistics\n- `:uptime` - System uptime in milliseconds","ref":"Object.Application.html#get_system_status/0-returns"},{"type":"function","title":"Examples - Object.Application.get_system_status/0","doc":"iex> Object.Application.get_system_status()\n    %{\n      objects: %{total: 5, by_type: %{ai_agent: 2, sensor: 3}},\n      performance: %{avg_response_time: 12.5},\n      uptime: 3600000\n    }","ref":"Object.Application.html#get_system_status/0-examples"},{"type":"function","title":"Object.Application.handle_system_telemetry/4","doc":"","ref":"Object.Application.html#handle_system_telemetry/4"},{"type":"function","title":"Object.Application.list_objects/0","doc":"Lists all currently active objects in the system.","ref":"Object.Application.html#list_objects/0"},{"type":"function","title":"Returns - Object.Application.list_objects/0","doc":"- List of object IDs currently registered in the system","ref":"Object.Application.html#list_objects/0-returns"},{"type":"function","title":"Examples - Object.Application.list_objects/0","doc":"iex> Object.Application.list_objects()\n    [\"ai_agent_alpha\", \"sensor_1\", \"coordinator_main\"]","ref":"Object.Application.html#list_objects/0-examples"},{"type":"function","title":"Object.Application.start/2","doc":"Starts the AAOS Object System application.\n\nInitializes the complete supervision tree including:\n- Core object supervisor\n- Message routing subsystem\n- Telemetry configuration\n- Post-startup system initialization","ref":"Object.Application.html#start/2"},{"type":"function","title":"Parameters - Object.Application.start/2","doc":"- `_type` - Application start type (typically `:normal`)\n- `_args` - Application arguments (unused)","ref":"Object.Application.html#start/2-parameters"},{"type":"function","title":"Returns - Object.Application.start/2","doc":"- `{:ok, pid}` - Success with supervisor PID\n- `{:error, reason}` - Failure with error reason","ref":"Object.Application.html#start/2-returns"},{"type":"function","title":"Examples - Object.Application.start/2","doc":"iex> Object.Application.start(:normal, [])\n    {:ok, #PID<0.123.0>}","ref":"Object.Application.html#start/2-examples"},{"type":"function","title":"Object.Application.stop/1","doc":"Stops the AAOS Object System application.\n\nPerforms graceful shutdown including cleanup of system resources\nand orderly termination of all objects.","ref":"Object.Application.html#stop/1"},{"type":"function","title":"Parameters - Object.Application.stop/1","doc":"- `_state` - Application state (unused)","ref":"Object.Application.html#stop/1-parameters"},{"type":"function","title":"Returns - Object.Application.stop/1","doc":"- `:ok` - Always returns ok after cleanup","ref":"Object.Application.html#stop/1-returns"},{"type":"function","title":"Object.Application.stop_object/1","doc":"Stops an object by its ID.\n\nLooks up the object in the registry and terminates its process\nunder the dynamic supervisor.","ref":"Object.Application.html#stop_object/1"},{"type":"function","title":"Parameters - Object.Application.stop_object/1","doc":"- `object_id` - String identifier of the object to stop","ref":"Object.Application.html#stop_object/1-parameters"},{"type":"function","title":"Returns - Object.Application.stop_object/1","doc":"- `:ok` - Object stopped successfully\n- `{:error, :object_not_found}` - Object not found in registry\n- `{:error, reason}` - Other termination error","ref":"Object.Application.html#stop_object/1-returns"},{"type":"module","title":"Object.CoordinationService","doc":"Distributed coordination service for multi-object operations.\nUses consensus algorithms and conflict resolution for large-scale coordination.","ref":"Object.CoordinationService.html"},{"type":"function","title":"Object.CoordinationService.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.CoordinationService.html#child_spec/1"},{"type":"function","title":"Object.CoordinationService.coordinate_objects/2","doc":"Coordinates a task across multiple objects using consensus algorithms.","ref":"Object.CoordinationService.html#coordinate_objects/2"},{"type":"function","title":"Parameters - Object.CoordinationService.coordinate_objects/2","doc":"- `object_ids`: List of object IDs to coordinate\n- `coordination_task`: Task specification with type, objectives, and constraints","ref":"Object.CoordinationService.html#coordinate_objects/2-parameters"},{"type":"function","title":"Returns - Object.CoordinationService.coordinate_objects/2","doc":"`{:ok, session_id}` with the coordination session identifier","ref":"Object.CoordinationService.html#coordinate_objects/2-returns"},{"type":"function","title":"Examples - Object.CoordinationService.coordinate_objects/2","doc":"iex> Object.CoordinationService.coordinate_objects([\"obj1\", \"obj2\"], %{type: :optimization})\n    {:ok, \"session_abc123\"}","ref":"Object.CoordinationService.html#coordinate_objects/2-examples"},{"type":"function","title":"Object.CoordinationService.get_coordination_status/1","doc":"Gets the current status of a coordination session.","ref":"Object.CoordinationService.html#get_coordination_status/1"},{"type":"function","title":"Parameters - Object.CoordinationService.get_coordination_status/1","doc":"- `session_id`: ID of the coordination session","ref":"Object.CoordinationService.html#get_coordination_status/1-parameters"},{"type":"function","title":"Returns - Object.CoordinationService.get_coordination_status/1","doc":"`{:ok, status}` where status is `:voting`, `:in_progress`, `:completed`, or `:failed`","ref":"Object.CoordinationService.html#get_coordination_status/1-returns"},{"type":"function","title":"Object.CoordinationService.get_metrics/0","doc":"Gets performance metrics for the coordination service.","ref":"Object.CoordinationService.html#get_metrics/0"},{"type":"function","title":"Returns - Object.CoordinationService.get_metrics/0","doc":"Map with metrics including active sessions, completed sessions, and uptime","ref":"Object.CoordinationService.html#get_metrics/0-returns"},{"type":"function","title":"Object.CoordinationService.join_coordination/2","doc":"Adds an object to an existing coordination session.","ref":"Object.CoordinationService.html#join_coordination/2"},{"type":"function","title":"Parameters - Object.CoordinationService.join_coordination/2","doc":"- `session_id`: ID of the coordination session\n- `object_id`: ID of the object to add","ref":"Object.CoordinationService.html#join_coordination/2-parameters"},{"type":"function","title":"Returns - Object.CoordinationService.join_coordination/2","doc":"`:ok` on success, `{:error, reason}` on failure","ref":"Object.CoordinationService.html#join_coordination/2-returns"},{"type":"function","title":"Object.CoordinationService.leave_coordination/2","doc":"Removes an object from a coordination session.","ref":"Object.CoordinationService.html#leave_coordination/2"},{"type":"function","title":"Parameters - Object.CoordinationService.leave_coordination/2","doc":"- `session_id`: ID of the coordination session\n- `object_id`: ID of the object to remove","ref":"Object.CoordinationService.html#leave_coordination/2-parameters"},{"type":"function","title":"Returns - Object.CoordinationService.leave_coordination/2","doc":"`:ok` on success, `{:ok, :session_cancelled}` if last participant left","ref":"Object.CoordinationService.html#leave_coordination/2-returns"},{"type":"function","title":"Object.CoordinationService.resolve_conflict/1","doc":"Resolves conflicts between objects using configured resolution strategies.","ref":"Object.CoordinationService.html#resolve_conflict/1"},{"type":"function","title":"Parameters - Object.CoordinationService.resolve_conflict/1","doc":"- `conflict_context`: Context describing the conflict and involved parties","ref":"Object.CoordinationService.html#resolve_conflict/1-parameters"},{"type":"function","title":"Returns - Object.CoordinationService.resolve_conflict/1","doc":"Resolution result with method and outcome","ref":"Object.CoordinationService.html#resolve_conflict/1-returns"},{"type":"function","title":"Object.CoordinationService.start_link/1","doc":"Starts the coordination service GenServer.","ref":"Object.CoordinationService.html#start_link/1"},{"type":"function","title":"Returns - Object.CoordinationService.start_link/1","doc":"`{:ok, pid}` on successful startup","ref":"Object.CoordinationService.html#start_link/1-returns"},{"type":"module","title":"Object.DSPyBridge","doc":"Bridge module integrating DSPy framework with AAOS objects for advanced reasoning capabilities.\nEnables objects to use DSPy signatures and LM Studio inference for intelligent behavior.","ref":"Object.DSPyBridge.html"},{"type":"function","title":"Object.DSPyBridge.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.DSPyBridge.html#child_spec/1"},{"type":"function","title":"Object.DSPyBridge.execute_signature/2","doc":"Executes a DSPy signature directly with the provided specification.","ref":"Object.DSPyBridge.html#execute_signature/2"},{"type":"function","title":"Parameters - Object.DSPyBridge.execute_signature/2","doc":"- `object_id`: ID of the object\n- `signature`: Signature specification to execute","ref":"Object.DSPyBridge.html#execute_signature/2-parameters"},{"type":"function","title":"Returns - Object.DSPyBridge.execute_signature/2","doc":"`{:ok, result}` with structured output or `{:error, reason}`","ref":"Object.DSPyBridge.html#execute_signature/2-returns"},{"type":"function","title":"Object.DSPyBridge.get_reasoning_metrics/1","doc":"Gets performance metrics for the DSPy bridge.","ref":"Object.DSPyBridge.html#get_reasoning_metrics/1"},{"type":"function","title":"Parameters - Object.DSPyBridge.get_reasoning_metrics/1","doc":"- `object_id`: ID of the object","ref":"Object.DSPyBridge.html#get_reasoning_metrics/1-parameters"},{"type":"function","title":"Returns - Object.DSPyBridge.get_reasoning_metrics/1","doc":"Map with query count, cache hits, and average latency","ref":"Object.DSPyBridge.html#get_reasoning_metrics/1-returns"},{"type":"function","title":"Object.DSPyBridge.handle_continue/2","doc":"Callback implementation for  GenServer.handle_continue/2 .","ref":"Object.DSPyBridge.html#handle_continue/2"},{"type":"function","title":"Object.DSPyBridge.init/1","doc":"Callback implementation for  GenServer.init/1 .","ref":"Object.DSPyBridge.html#init/1"},{"type":"function","title":"Object.DSPyBridge.reason_with_signature/4","doc":"Executes reasoning using a registered DSPy signature.","ref":"Object.DSPyBridge.html#reason_with_signature/4"},{"type":"function","title":"Parameters - Object.DSPyBridge.reason_with_signature/4","doc":"- `object_id`: ID of the object\n- `signature_name`: Name of the signature to use\n- `inputs`: Input data for reasoning\n- `options`: Optional parameters like max_tokens, temperature","ref":"Object.DSPyBridge.html#reason_with_signature/4-parameters"},{"type":"function","title":"Returns - Object.DSPyBridge.reason_with_signature/4","doc":"`{:ok, result}` with structured reasoning output or `{:error, reason}`","ref":"Object.DSPyBridge.html#reason_with_signature/4-returns"},{"type":"function","title":"Examples - Object.DSPyBridge.reason_with_signature/4","doc":"iex> Object.DSPyBridge.reason_with_signature(\"obj1\", :message_analysis, %{content: \"Hello\"})\n    {:ok, %{intent: \"greeting\", confidence: 0.9}}","ref":"Object.DSPyBridge.html#reason_with_signature/4-examples"},{"type":"function","title":"Object.DSPyBridge.register_signature/3","doc":"Registers a new DSPy signature for an object.","ref":"Object.DSPyBridge.html#register_signature/3"},{"type":"function","title":"Parameters - Object.DSPyBridge.register_signature/3","doc":"- `object_id`: ID of the object\n- `signature_name`: Name for the signature\n- `signature_spec`: Specification with description, inputs, outputs, instructions","ref":"Object.DSPyBridge.html#register_signature/3-parameters"},{"type":"function","title":"Returns - Object.DSPyBridge.register_signature/3","doc":"`:ok` on successful registration","ref":"Object.DSPyBridge.html#register_signature/3-returns"},{"type":"function","title":"Object.DSPyBridge.start_link/1","doc":"Starts a DSPy bridge process for the given object.","ref":"Object.DSPyBridge.html#start_link/1"},{"type":"function","title":"Parameters - Object.DSPyBridge.start_link/1","doc":"- `object_id`: ID of the object to create bridge for","ref":"Object.DSPyBridge.html#start_link/1-parameters"},{"type":"function","title":"Returns - Object.DSPyBridge.start_link/1","doc":"`{:ok, pid}` on successful startup","ref":"Object.DSPyBridge.html#start_link/1-returns"},{"type":"function","title":"Object.DSPyBridge.via_registry/1","doc":"","ref":"Object.DSPyBridge.html#via_registry/1"},{"type":"module","title":"Object.DSPyBridge.MockLMStudio","doc":"Mock LM Studio client for testing and development.","ref":"Object.DSPyBridge.MockLMStudio.html"},{"type":"function","title":"Object.DSPyBridge.MockLMStudio.generate/2","doc":"","ref":"Object.DSPyBridge.MockLMStudio.html#generate/2"},{"type":"function","title":"Object.DSPyBridge.MockLMStudio.new/1","doc":"","ref":"Object.DSPyBridge.MockLMStudio.html#new/1"},{"type":"module","title":"Object.DemoRunner","doc":"High-performance demonstration runner using OTP principles.\nShows the full AAOS system in action with proper BEAM/OTP patterns.","ref":"Object.DemoRunner.html"},{"type":"function","title":"Object.DemoRunner.run_full_system_demo/0","doc":"Runs a comprehensive demonstration of the full AAOS system capabilities.\n\nDemonstrates:\n- Concurrent message passing with GenStage\n- Distributed coordination with consensus\n- Schema evolution with voting\n- Real-time performance monitoring\n- Fault tolerance and recovery\n- High-throughput load testing","ref":"Object.DemoRunner.html#run_full_system_demo/0"},{"type":"function","title":"Returns - Object.DemoRunner.run_full_system_demo/0","doc":"Map containing results from all demonstration components","ref":"Object.DemoRunner.html#run_full_system_demo/0-returns"},{"type":"function","title":"Examples - Object.DemoRunner.run_full_system_demo/0","doc":"iex> Object.DemoRunner.run_full_system_demo()\n    %{message_passing: %{throughput: 450.2}, coordination: %{status: :completed}, ...}","ref":"Object.DemoRunner.html#run_full_system_demo/0-examples"},{"type":"module","title":"Object.Exploration","doc":"Object-Oriented Exploration strategies for OORL framework.\n\nImplements novelty-based and uncertainty-based exploration as specified\nin AAOS section 10, enabling objects to discover novel interactions\nand configurations in their environment.\n\nKey exploration strategies:\n- Novelty-based exploration using state visitation counts\n- Uncertainty-based exploration using prediction confidence\n- Curiosity-driven exploration with information gain\n- Social exploration through interaction dyads\n- Meta-exploration for learning strategy optimization","ref":"Object.Exploration.html"},{"type":"function","title":"Object.Exploration.adapt_exploration_parameters/2","doc":"Adapts exploration parameters based on performance feedback.","ref":"Object.Exploration.html#adapt_exploration_parameters/2"},{"type":"function","title":"Parameters - Object.Exploration.adapt_exploration_parameters/2","doc":"- `explorer`: Exploration system struct\n- `performance_metrics`: Recent performance data","ref":"Object.Exploration.html#adapt_exploration_parameters/2-parameters"},{"type":"function","title":"Returns - Object.Exploration.adapt_exploration_parameters/2","doc":"Updated exploration system with adapted parameters","ref":"Object.Exploration.html#adapt_exploration_parameters/2-returns"},{"type":"type","title":"Object.Exploration.collaboration_record/0","doc":"","ref":"Object.Exploration.html#t:collaboration_record/0"},{"type":"function","title":"Object.Exploration.compute_exploration_bonus/3","doc":"Computes exploration bonus for a given state-action pair based on the exploration strategy.","ref":"Object.Exploration.html#compute_exploration_bonus/3"},{"type":"function","title":"Parameters - Object.Exploration.compute_exploration_bonus/3","doc":"- `explorer`: Exploration system struct\n- `state`: Current state\n- `action`: Action being considered","ref":"Object.Exploration.html#compute_exploration_bonus/3-parameters"},{"type":"function","title":"Returns - Object.Exploration.compute_exploration_bonus/3","doc":"Exploration bonus value (higher values encourage exploration)","ref":"Object.Exploration.html#compute_exploration_bonus/3-returns"},{"type":"type","title":"Object.Exploration.curiosity_model/0","doc":"","ref":"Object.Exploration.html#t:curiosity_model/0"},{"type":"function","title":"Object.Exploration.evaluate_exploration_effectiveness/1","doc":"Evaluates the effectiveness of the current exploration strategy.","ref":"Object.Exploration.html#evaluate_exploration_effectiveness/1"},{"type":"function","title":"Parameters - Object.Exploration.evaluate_exploration_effectiveness/1","doc":"- `explorer`: Exploration system struct","ref":"Object.Exploration.html#evaluate_exploration_effectiveness/1-parameters"},{"type":"function","title":"Returns - Object.Exploration.evaluate_exploration_effectiveness/1","doc":"Map with overall effectiveness score, detailed metrics, and recommendations","ref":"Object.Exploration.html#evaluate_exploration_effectiveness/1-returns"},{"type":"type","title":"Object.Exploration.exploration_params/0","doc":"","ref":"Object.Exploration.html#t:exploration_params/0"},{"type":"type","title":"Object.Exploration.exploration_record/0","doc":"","ref":"Object.Exploration.html#t:exploration_record/0"},{"type":"function","title":"Object.Exploration.identify_novel_interactions/2","doc":"Identifies novel interaction patterns and opportunities with other objects.","ref":"Object.Exploration.html#identify_novel_interactions/2"},{"type":"function","title":"Parameters - Object.Exploration.identify_novel_interactions/2","doc":"- `explorer`: Exploration system struct\n- `available_partners`: List of potential interaction partners","ref":"Object.Exploration.html#identify_novel_interactions/2-parameters"},{"type":"function","title":"Returns - Object.Exploration.identify_novel_interactions/2","doc":"Map with novel partners, recommendations, and expected information gain","ref":"Object.Exploration.html#identify_novel_interactions/2-returns"},{"type":"function","title":"Object.Exploration.new/3","doc":"Creates a new exploration system for an object.","ref":"Object.Exploration.html#new/3"},{"type":"function","title":"Parameters - Object.Exploration.new/3","doc":"- `object_id`: ID of the object\n- `strategy`: Exploration strategy (`:novelty_based`, `:uncertainty_based`, `:curiosity_driven`, `:hybrid`, `:social`)\n- `opts`: Optional configuration parameters","ref":"Object.Exploration.html#new/3-parameters"},{"type":"function","title":"Returns - Object.Exploration.new/3","doc":"New exploration system struct","ref":"Object.Exploration.html#new/3-returns"},{"type":"function","title":"Examples - Object.Exploration.new/3","doc":"iex> Object.Exploration.new(\"agent1\", :hybrid)\n    %Object.Exploration{object_id: \"agent1\", exploration_strategy: :hybrid, ...}","ref":"Object.Exploration.html#new/3-examples"},{"type":"type","title":"Object.Exploration.novelty_tracker/0","doc":"","ref":"Object.Exploration.html#t:novelty_tracker/0"},{"type":"type","title":"Object.Exploration.object_id/0","doc":"","ref":"Object.Exploration.html#t:object_id/0"},{"type":"function","title":"Object.Exploration.select_exploration_action/3","doc":"Selects an action based on exploration strategy and value estimates.","ref":"Object.Exploration.html#select_exploration_action/3"},{"type":"function","title":"Parameters - Object.Exploration.select_exploration_action/3","doc":"- `explorer`: Exploration system struct\n- `available_actions`: List of possible actions\n- `value_estimates`: Map of action -> estimated value","ref":"Object.Exploration.html#select_exploration_action/3-parameters"},{"type":"function","title":"Returns - Object.Exploration.select_exploration_action/3","doc":"Selected action that balances exploration and exploitation","ref":"Object.Exploration.html#select_exploration_action/3-returns"},{"type":"type","title":"Object.Exploration.social_exploration_state/0","doc":"","ref":"Object.Exploration.html#t:social_exploration_state/0"},{"type":"type","title":"Object.Exploration.state_key/0","doc":"","ref":"Object.Exploration.html#t:state_key/0"},{"type":"type","title":"Object.Exploration.strategy_type/0","doc":"","ref":"Object.Exploration.html#t:strategy_type/0"},{"type":"type","title":"Object.Exploration.t/0","doc":"","ref":"Object.Exploration.html#t:t/0"},{"type":"type","title":"Object.Exploration.uncertainty_estimator/0","doc":"","ref":"Object.Exploration.html#t:uncertainty_estimator/0"},{"type":"function","title":"Object.Exploration.update_exploration_state/4","doc":"Updates exploration state based on observed outcome.","ref":"Object.Exploration.html#update_exploration_state/4"},{"type":"function","title":"Parameters - Object.Exploration.update_exploration_state/4","doc":"- `explorer`: Exploration system struct\n- `state`: State where action was taken\n- `action`: Action that was executed\n- `outcome`: Observed outcome/result","ref":"Object.Exploration.html#update_exploration_state/4-parameters"},{"type":"function","title":"Returns - Object.Exploration.update_exploration_state/4","doc":"Updated exploration system with recorded experience","ref":"Object.Exploration.html#update_exploration_state/4-returns"},{"type":"module","title":"Object.FunctionCalling","doc":"LLM-powered function calling system for Object self-organization.\n\nThis module enables Objects to:\n1. Dynamically discover and call functions on other Objects\n2. Use LLM reasoning to select appropriate functions and parameters\n3. Compose complex workflows through chained function calls\n4. Adapt function calling strategies based on outcomes\n5. Self-organize through coordinated function execution\n\nThe system treats each Object method as a callable function that can be\ninvoked remotely with LLM-generated parameters and context.","ref":"Object.FunctionCalling.html"},{"type":"function","title":"Object.FunctionCalling.adapt_execution_strategy/3","doc":"Adapts function calling strategies based on execution outcomes.","ref":"Object.FunctionCalling.html#adapt_execution_strategy/3"},{"type":"function","title":"Object.FunctionCalling.collaborative_function_execution/4","doc":"Enables collaborative function calling between multiple Objects.","ref":"Object.FunctionCalling.html#collaborative_function_execution/4"},{"type":"function","title":"Object.FunctionCalling.discover_function_composition/4","doc":"Discovers and suggests optimal function calls for achieving a goal.","ref":"Object.FunctionCalling.html#discover_function_composition/4"},{"type":"function","title":"Object.FunctionCalling.execute_function_composition/3","doc":"Executes a composed workflow of function calls with dependency management.","ref":"Object.FunctionCalling.html#execute_function_composition/3"},{"type":"function","title":"Object.FunctionCalling.execute_llm_function_call/5","doc":"Executes a function call using LLM reasoning to determine parameters.","ref":"Object.FunctionCalling.html#execute_llm_function_call/5"},{"type":"type","title":"Object.FunctionCalling.execution_record/0","doc":"","ref":"Object.FunctionCalling.html#t:execution_record/0"},{"type":"function","title":"Object.FunctionCalling.new/1","doc":"Initializes the function calling system.","ref":"Object.FunctionCalling.html#new/1"},{"type":"type","title":"Object.FunctionCalling.policy/0","doc":"","ref":"Object.FunctionCalling.html#t:policy/0"},{"type":"function","title":"Object.FunctionCalling.register_object/2","doc":"Registers an Object and its callable functions in the system.","ref":"Object.FunctionCalling.html#register_object/2"},{"type":"type","title":"Object.FunctionCalling.t/0","doc":"","ref":"Object.FunctionCalling.html#t:t/0"},{"type":"module","title":"Object.Hierarchy","doc":"Hierarchical Object Composition and Decomposition for OORL framework.\n\nImplements hierarchical planning and object aggregation/decomposition\nas specified in AAOS section 9. This module enables sophisticated\nmulti-level organization of autonomous objects for complex problem solving.","ref":"Object.Hierarchy.html"},{"type":"module","title":"Core Capabilities - Object.Hierarchy","doc":"- **Dynamic Composition**: Combine multiple objects into higher-level aggregates\n- **Strategic Decomposition**: Break complex objects into manageable components\n- **Hierarchical Planning**: Multi-level planning from abstract to concrete\n- **Emergent Behavior**: Collective capabilities exceeding individual object abilities\n- **Adaptive Organization**: Dynamic restructuring based on performance feedback","ref":"Object.Hierarchy.html#module-core-capabilities"},{"type":"module","title":"Hierarchy Levels - Object.Hierarchy","doc":"Objects are organized in abstraction levels:\n\n- **Level 0**: Concrete objects with direct environment interaction\n- **Level 1**: Basic compositions of 2-3 objects\n- **Level 2**: Complex aggregates with specialized roles\n- **Level N**: Abstract organizational structures","ref":"Object.Hierarchy.html#module-hierarchy-levels"},{"type":"module","title":"Composition Strategies - Object.Hierarchy","doc":"","ref":"Object.Hierarchy.html#module-composition-strategies"},{"type":"module","title":"Automatic Composition - Object.Hierarchy","doc":"- Rule-based object combination\n- Compatibility scoring and optimization\n- Synergy detection and maximization","ref":"Object.Hierarchy.html#module-automatic-composition"},{"type":"module","title":"Guided Composition - Object.Hierarchy","doc":"- Interactive composition with options\n- User-specified requirements and constraints\n- Performance-driven selection","ref":"Object.Hierarchy.html#module-guided-composition"},{"type":"module","title":"Forced Composition - Object.Hierarchy","doc":"- Override compatibility rules when needed\n- Emergency or experimental combinations\n- Rapid prototyping of new structures","ref":"Object.Hierarchy.html#module-forced-composition"},{"type":"module","title":"Decomposition Strategies - Object.Hierarchy","doc":"","ref":"Object.Hierarchy.html#module-decomposition-strategies"},{"type":"module","title":"Capability-Based - Object.Hierarchy","doc":"- Separate by individual capabilities\n- Maintain functional coherence\n- Enable capability specialization","ref":"Object.Hierarchy.html#module-capability-based"},{"type":"module","title":"Functional Decomposition - Object.Hierarchy","doc":"- Organize by functional requirements\n- Optimize for task efficiency\n- Support modular development","ref":"Object.Hierarchy.html#module-functional-decomposition"},{"type":"module","title":"Resource-Based - Object.Hierarchy","doc":"- Separate by resource usage patterns\n- Optimize resource allocation\n- Enable load balancing","ref":"Object.Hierarchy.html#module-resource-based"},{"type":"module","title":"Temporal Decomposition - Object.Hierarchy","doc":"- Organize by temporal behavior phases\n- Enable pipeline processing\n- Support workflow optimization","ref":"Object.Hierarchy.html#module-temporal-decomposition"},{"type":"module","title":"Planning Capabilities - Object.Hierarchy","doc":"Hierarchical planning enables:\n- **Multi-Scale Reasoning**: Plan at appropriate abstraction levels\n- **Efficient Search**: Reduce complexity through abstraction\n- **Robust Execution**: Graceful degradation across levels\n- **Adaptive Refinement**: Dynamic plan adjustment during execution","ref":"Object.Hierarchy.html#module-planning-capabilities"},{"type":"module","title":"Performance Benefits - Object.Hierarchy","doc":"- **Scalability**: Handle systems with hundreds of objects\n- **Efficiency**: 10-100x faster planning through abstraction\n- **Robustness**: Fault tolerance through hierarchical redundancy\n- **Maintainability**: Modular structure enables easy modification","ref":"Object.Hierarchy.html#module-performance-benefits"},{"type":"module","title":"Example Usage - Object.Hierarchy","doc":"# Create hierarchy with root object\n    hierarchy = Object.Hierarchy.new(\"system_coordinator\")\n    \n    # Compose sensor-actuator system\n    {:ok, updated_hierarchy, composed_spec} = \n      Object.Hierarchy.compose_objects(hierarchy, \n        [\"temp_sensor\", \"motor_actuator\"], :automatic)\n    \n    # Decompose complex AI agent\n    {:ok, hierarchy, components} = \n      Object.Hierarchy.decompose_object(hierarchy, \n        \"complex_ai_agent\", :capability_based)\n    \n    # Perform hierarchical planning\n    {:ok, plan} = Object.Hierarchy.hierarchical_planning(\n      hierarchy, goal, current_state)","ref":"Object.Hierarchy.html#module-example-usage"},{"type":"type","title":"Object.Hierarchy.abstraction_level/0","doc":"Abstraction level number (higher = more abstract)","ref":"Object.Hierarchy.html#t:abstraction_level/0"},{"type":"function","title":"Object.Hierarchy.adapt_hierarchy/2","doc":"Dynamically adapts the hierarchical structure based on performance.\n\nAnalyzes performance feedback and automatically restructures or\noptimizes the hierarchy to improve overall system performance.","ref":"Object.Hierarchy.html#adapt_hierarchy/2"},{"type":"function","title":"Parameters - Object.Hierarchy.adapt_hierarchy/2","doc":"- `hierarchy` - Current hierarchy structure\n- `performance_feedback` - Performance metrics and observations","ref":"Object.Hierarchy.html#adapt_hierarchy/2-parameters"},{"type":"function","title":"Returns - Object.Hierarchy.adapt_hierarchy/2","doc":"- `{:ok, adapted_hierarchy}` - Successfully adapted hierarchy\n- `{:error, {:adaptation_failed, reason}}` - Adaptation failed","ref":"Object.Hierarchy.html#adapt_hierarchy/2-returns"},{"type":"function","title":"Adaptation Types - Object.Hierarchy.adapt_hierarchy/2","doc":"- **Restructuring**: Major changes to hierarchy organization\n- **Optimization**: Fine-tuning of existing structure\n- **No Change**: Structure is already optimal","ref":"Object.Hierarchy.html#adapt_hierarchy/2-adaptation-types"},{"type":"function","title":"Object.Hierarchy.compose_objects/3","doc":"Composes multiple objects into a higher-level aggregate object.\n\nCombines multiple objects into a single composite object using the\nspecified composition strategy. The composition can be automatic\n(rule-based), forced (ignore rules), or guided (interactive).","ref":"Object.Hierarchy.html#compose_objects/3"},{"type":"function","title":"Parameters - Object.Hierarchy.compose_objects/3","doc":"- `hierarchy` - The hierarchy structure\n- `object_ids` - List of object IDs to compose\n- `composition_type` - Composition strategy:\n  - `:automatic` - Use composition rules to find best match\n  - `:forced` - Force composition regardless of rules\n  - `:guided` - Interactive composition with options","ref":"Object.Hierarchy.html#compose_objects/3-parameters"},{"type":"function","title":"Returns - Object.Hierarchy.compose_objects/3","doc":"- `{:ok, updated_hierarchy, composed_spec}` - Success with new composite object\n- `{:error, reason}` - Composition failed","ref":"Object.Hierarchy.html#compose_objects/3-returns"},{"type":"function","title":"Examples - Object.Hierarchy.compose_objects/3","doc":"iex> Object.Hierarchy.compose_objects(hierarchy, [\"sensor1\", \"actuator1\"], :automatic)\n    {:ok, updated_hierarchy, %{id: \"composed_123\", type: :sensor_actuator_system}}","ref":"Object.Hierarchy.html#compose_objects/3-examples"},{"type":"type","title":"Object.Hierarchy.composition_rule/0","doc":"Rule for automatically composing objects into higher-level structures.","ref":"Object.Hierarchy.html#t:composition_rule/0"},{"type":"type","title":"Fields - Object.Hierarchy.composition_rule/0","doc":"- `pattern` - List of object types that can be composed together\n- `result_type` - Type of the resulting composed object\n- `synergy_bonus` - Performance bonus from this composition (0.0-1.0)\n- `conditions` - Additional conditions that must be met for composition","ref":"Object.Hierarchy.html#t:composition_rule/0-fields"},{"type":"type","title":"Example - Object.Hierarchy.composition_rule/0","doc":"%{\n      pattern: [:sensor, :actuator],\n      result_type: :sensor_actuator_system,\n      synergy_bonus: 0.3,\n      conditions: [&compatible_interfaces?/1]\n    }","ref":"Object.Hierarchy.html#t:composition_rule/0-example"},{"type":"type","title":"Object.Hierarchy.condition/0","doc":"Condition function for composition rules","ref":"Object.Hierarchy.html#t:condition/0"},{"type":"function","title":"Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"Manages coordination between objects at different hierarchy levels.\n\nIdentifies and executes coordination tasks needed between objects\nat different abstraction levels to maintain system coherence and\noptimal performance. This is essential for multi-level organization.","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2"},{"type":"function","title":"Parameters - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- `hierarchy` - The hierarchy structure with all levels and objects\n- `coordination_context` - Context information for coordination needs:\n  - `:coordination_type` - Type of coordination needed\n  - `:affected_levels` - Hierarchy levels involved\n  - `:urgency` - Priority level for coordination\n  - `:constraints` - Constraints on coordination solutions\n  - `:performance_requirements` - Expected performance outcomes","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-parameters"},{"type":"function","title":"Returns - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- `{:ok, coordination_results}` - Successful coordination outcomes:\n  - `:coordination_actions` - Actions taken for coordination\n  - `:affected_objects` - Objects involved in coordination\n  - `:performance_impact` - Impact on system performance\n  - `:resource_usage` - Resources consumed by coordination\n  - `:synchronization_points` - Time points for level synchronization\n- `{:error, reason}` - Coordination failed:\n  - `:conflicting_objectives` - Irreconcilable goal conflicts\n  - `:resource_deadlock` - Circular resource dependencies\n  - `:communication_failure` - Inter-level communication failed\n  - `:timeout` - Coordination took too long","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-returns"},{"type":"function","title":"Coordination Types - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-coordination-types"},{"type":"function","title":"Synchronization Coordination - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- **Temporal Sync**: Align timing across hierarchy levels\n- **State Sync**: Ensure consistent state across levels\n- **Decision Sync**: Coordinate decision-making processes","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-synchronization-coordination"},{"type":"function","title":"Resource Coordination - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- **Allocation**: Distribute resources across levels\n- **Optimization**: Optimize resource usage system-wide\n- **Conflict Resolution**: Resolve resource conflicts","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-resource-coordination"},{"type":"function","title":"Information Coordination - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- **Flow Management**: Control information propagation\n- **Aggregation**: Combine information from lower levels\n- **Dissemination**: Distribute decisions to lower levels","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-information-coordination"},{"type":"function","title":"Objective Coordination - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- **Goal Alignment**: Align objectives across levels\n- **Priority Resolution**: Resolve conflicting priorities\n- **Performance Optimization**: Optimize collective performance","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-objective-coordination"},{"type":"function","title":"Examples - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"# Resource allocation coordination\n    iex> context = %{\n    ...>   coordination_type: :resource_allocation,\n    ...>   affected_levels: [0, 1, 2],\n    ...>   urgency: :high,\n    ...>   constraints: %{max_disruption: 0.1},\n    ...>   performance_requirements: %{efficiency: 0.9}\n    ...> }\n    iex> {:ok, results} = Object.Hierarchy.coordinate_hierarchy_levels(\n    ...>   hierarchy, context\n    ...> )\n    iex> length(results.coordination_actions)\n    5\n    iex> results.performance_impact.efficiency_gain\n    0.15\n    \n    # Conflict resolution coordination\n    iex> conflict_context = %{\n    ...>   coordination_type: :conflict_resolution,\n    ...>   affected_levels: [1, 2],\n    ...>   urgency: :critical,\n    ...>   constraints: %{maintain_safety: true}\n    ...> }\n    iex> {:ok, results} = Object.Hierarchy.coordinate_hierarchy_levels(\n    ...>   hierarchy, conflict_context\n    ...> )\n    iex> results.affected_objects\n    [\"coordinator_1\", \"team_alpha\", \"team_beta\"]","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-examples"},{"type":"function","title":"Coordination Algorithms - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"Different algorithms for different coordination types:","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-coordination-algorithms"},{"type":"function","title":"Consensus-Based - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- Democratic decision making across levels\n- Suitable for collaborative environments\n- Higher coordination overhead but better buy-in","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-consensus-based"},{"type":"function","title":"Hierarchical Command - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- Top-down decision propagation\n- Fast coordination but less flexibility\n- Suitable for time-critical situations","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-hierarchical-command"},{"type":"function","title":"Market-Based - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- Auction-based resource allocation\n- Efficient resource utilization\n- Suitable for resource-constrained environments","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-market-based"},{"type":"function","title":"Negotiation-Based - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"- Bilateral and multilateral negotiations\n- Flexible conflict resolution\n- Suitable for autonomous object coordination","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-negotiation-based"},{"type":"function","title":"Performance Optimization - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"Coordination is optimized for:\n- **Minimal Disruption**: Reduce impact on ongoing operations\n- **Fast Convergence**: Achieve coordination quickly\n- **Robust Solutions**: Maintain coordination despite failures\n- **Resource Efficiency**: Minimize coordination overhead","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-performance-optimization"},{"type":"function","title":"Quality Metrics - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"Coordination quality measured by:\n- **Convergence Time**: How quickly coordination is achieved\n- **Solution Quality**: Optimality of coordination solution\n- **Stability**: Persistence of coordination over time\n- **Adaptability**: Ability to adjust to changing conditions","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-quality-metrics"},{"type":"function","title":"Error Recovery - Object.Hierarchy.coordinate_hierarchy_levels/2","doc":"Coordination failures are handled through:\n- **Fallback Protocols**: Alternative coordination methods\n- **Partial Coordination**: Coordinate subsets of objects\n- **Graceful Degradation**: Maintain partial functionality\n- **Retry Mechanisms**: Attempt coordination with modified parameters","ref":"Object.Hierarchy.html#coordinate_hierarchy_levels/2-error-recovery"},{"type":"function","title":"Object.Hierarchy.decompose_object/3","doc":"Decomposes a complex object into simpler component objects.\n\nBreaks down a complex object into its constituent parts using the\nspecified decomposition strategy.","ref":"Object.Hierarchy.html#decompose_object/3"},{"type":"function","title":"Parameters - Object.Hierarchy.decompose_object/3","doc":"- `hierarchy` - The hierarchy structure\n- `object_id` - ID of object to decompose\n- `decomposition_strategy` - Strategy to use:\n  - `:capability_based` - Decompose by individual capabilities\n  - `:functional` - Decompose by functional requirements\n  - `:resource_based` - Decompose by resource usage patterns\n  - `:temporal` - Decompose by temporal behavior phases","ref":"Object.Hierarchy.html#decompose_object/3-parameters"},{"type":"function","title":"Returns - Object.Hierarchy.decompose_object/3","doc":"- `{:ok, updated_hierarchy, component_specs}` - Success with component objects\n- `{:error, reason}` - Decomposition failed","ref":"Object.Hierarchy.html#decompose_object/3-returns"},{"type":"function","title":"Examples - Object.Hierarchy.decompose_object/3","doc":"iex> Object.Hierarchy.decompose_object(hierarchy, \"complex_ai\", :capability_based)\n    {:ok, updated_hierarchy, [%{id: \"ai_reasoning\"}, %{id: \"ai_perception\"}]}","ref":"Object.Hierarchy.html#decompose_object/3-examples"},{"type":"type","title":"Object.Hierarchy.decomposition_strategy/0","doc":"Strategy for decomposing complex objects into simpler components.","ref":"Object.Hierarchy.html#t:decomposition_strategy/0"},{"type":"type","title":"Fields - Object.Hierarchy.decomposition_strategy/0","doc":"- `target_type` - Type of object this strategy can decompose\n- `components` - Types of components produced by decomposition\n- `decomposition_cost` - Computational cost of decomposition (0.0-1.0)\n- `success_probability` - Likelihood of successful decomposition (0.0-1.0)","ref":"Object.Hierarchy.html#t:decomposition_strategy/0-fields"},{"type":"type","title":"Example - Object.Hierarchy.decomposition_strategy/0","doc":"%{\n      target_type: :complex_agent,\n      components: [:reasoning_module, :action_module, :perception_module],\n      decomposition_cost: 0.2,\n      success_probability: 0.8\n    }","ref":"Object.Hierarchy.html#t:decomposition_strategy/0-example"},{"type":"function","title":"Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"Evaluates the effectiveness of current hierarchical structure.\n\nAnalyzes multiple dimensions of hierarchy performance to assess\nhow well the current structure supports system objectives. This\ncomprehensive evaluation guides optimization and restructuring decisions.","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1"},{"type":"function","title":"Parameters - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"- `hierarchy` - The hierarchy to evaluate with all levels and objects","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-parameters"},{"type":"function","title":"Returns - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"Comprehensive evaluation map containing:\n- `:overall_effectiveness` - Aggregate effectiveness score (0.0-1.0)\n- `:detailed_metrics` - Breakdown by specific performance dimensions\n- `:recommendations` - Prioritized list of improvement suggestions\n- `:trend_analysis` - Performance trends over time\n- `:bottleneck_identification` - Performance limiting factors\n- `:optimization_opportunities` - Specific areas for improvement","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-returns"},{"type":"function","title":"Detailed Metrics - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-detailed-metrics"},{"type":"function","title":"Composition Efficiency (0.0-1.0) - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"Measures how well objects work together:\n- **Synergy Utilization**: Actual vs potential synergies\n- **Resource Sharing**: Efficiency of resource utilization\n- **Communication Overhead**: Cost of inter-object communication\n- **Task Distribution**: Balance of workload across objects","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-composition-efficiency-0-0-1-0"},{"type":"function","title":"Coordination Overhead (0.0-1.0, lower is better) - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"Measures the cost of maintaining coordination:\n- **Message Volume**: Communication required for coordination\n- **Decision Latency**: Time to reach coordinated decisions\n- **Conflict Resolution**: Effort to resolve conflicts\n- **Synchronization Cost**: Overhead of maintaining synchronization","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-coordination-overhead-0-0-1-0-lower-is-better"},{"type":"function","title":"Emergent Capabilities (list of capabilities) - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"Identifies capabilities that emerge from object composition:\n- **Novel Behaviors**: Behaviors not present in individual objects\n- **Enhanced Performance**: Performance exceeding sum of parts\n- **Robustness Gains**: Improved fault tolerance through composition\n- **Scalability Benefits**: Better scaling characteristics","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-emergent-capabilities-list-of-capabilities"},{"type":"function","title":"Abstraction Quality (0.0-1.0) - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"Evaluates the quality of hierarchical abstraction:\n- **Level Coherence**: Consistency within each abstraction level\n- **Separation Clarity**: Clear distinction between levels\n- **Information Flow**: Efficiency of information across levels\n- **Decision Appropriateness**: Right decisions at right levels","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-abstraction-quality-0-0-1-0"},{"type":"function","title":"Planning Effectiveness (0.0-1.0) - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"Measures planning system performance:\n- **Plan Quality**: Optimality of generated plans\n- **Planning Speed**: Time to generate executable plans\n- **Adaptation Rate**: Speed of replanning when needed\n- **Success Rate**: Percentage of plans executed successfully","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-planning-effectiveness-0-0-1-0"},{"type":"function","title":"Examples - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"# Evaluate well-performing hierarchy\n    iex> evaluation = Object.Hierarchy.evaluate_hierarchy_effectiveness(hierarchy)\n    iex> evaluation.overall_effectiveness\n    0.85\n    iex> evaluation.detailed_metrics.composition_efficiency\n    0.9\n    iex> evaluation.emergent_capabilities\n    [:collective_problem_solving, :distributed_resilience, :adaptive_coordination]\n    \n    # Identify performance issues\n    iex> troubled_hierarchy = create_poorly_structured_hierarchy()\n    iex> evaluation = Object.Hierarchy.evaluate_hierarchy_effectiveness(troubled_hierarchy)\n    iex> evaluation.overall_effectiveness\n    0.45\n    iex> evaluation.recommendations\n    [\n      \"Reduce coordination overhead by optimizing communication patterns\",\n      \"Improve abstraction quality by consolidating similar functions\",\n      \"Address bottleneck at level 2 coordinator object\"\n    ]","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-examples"},{"type":"function","title":"Recommendation Categories - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-recommendation-categories"},{"type":"function","title":"Structural Improvements - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"- **Hierarchy Reorganization**: Restructure levels for better performance\n- **Object Redistribution**: Move objects between levels\n- **Composition Optimization**: Form better object combinations\n- **Decomposition Adjustments**: Break down ineffective compositions","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-structural-improvements"},{"type":"function","title":"Process Improvements - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"- **Coordination Protocol Updates**: Improve coordination efficiency\n- **Planning Algorithm Optimization**: Enhance planning performance\n- **Communication Pattern Optimization**: Reduce message overhead\n- **Resource Allocation Improvements**: Better resource distribution","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-process-improvements"},{"type":"function","title":"Performance Tuning - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"- **Parameter Adjustments**: Fine-tune system parameters\n- **Load Balancing**: Distribute workload more evenly\n- **Caching Strategies**: Reduce computational overhead\n- **Parallel Processing**: Increase concurrency where beneficial","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-performance-tuning"},{"type":"function","title":"Evaluation Methodology - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"The evaluation process:\n1. **Data Collection**: Gather performance metrics from all levels\n2. **Metric Calculation**: Compute individual performance dimensions\n3. **Trend Analysis**: Identify performance trends over time\n4. **Bottleneck Detection**: Find performance limiting factors\n5. **Recommendation Generation**: Suggest specific improvements\n6. **Priority Ranking**: Order recommendations by impact and feasibility","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-evaluation-methodology"},{"type":"function","title":"Performance Benchmarks - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-performance-benchmarks"},{"type":"function","title":"Excellent Performance (0.8-1.0) - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"- High composition efficiency\n- Low coordination overhead\n- Strong emergent capabilities\n- Clear abstraction levels","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-excellent-performance-0-8-1-0"},{"type":"function","title":"Good Performance (0.6-0.8) - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"- Adequate composition efficiency\n- Moderate coordination overhead\n- Some emergent capabilities\n- Generally clear abstractions","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-good-performance-0-6-0-8"},{"type":"function","title":"Poor Performance (0.0-0.6) - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"- Low composition efficiency\n- High coordination overhead\n- Limited emergent capabilities\n- Confused abstraction levels","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-poor-performance-0-0-0-6"},{"type":"function","title":"Continuous Monitoring - Object.Hierarchy.evaluate_hierarchy_effectiveness/1","doc":"Regular evaluation enables:\n- **Performance Tracking**: Monitor effectiveness over time\n- **Early Problem Detection**: Identify issues before they become critical\n- **Optimization Opportunities**: Find ways to improve performance\n- **Structural Evolution**: Guide hierarchy evolution decisions","ref":"Object.Hierarchy.html#evaluate_hierarchy_effectiveness/1-continuous-monitoring"},{"type":"function","title":"Object.Hierarchy.hierarchical_planning/3","doc":"Performs hierarchical planning across abstraction levels.\n\nCreates a multi-level plan starting from abstract goals and refining\ndown to concrete executable actions. This enables efficient planning\nfor complex scenarios by working at appropriate abstraction levels.\nThe planning process uses hierarchical decomposition to manage complexity.","ref":"Object.Hierarchy.html#hierarchical_planning/3"},{"type":"function","title":"Parameters - Object.Hierarchy.hierarchical_planning/3","doc":"- `hierarchy` - The hierarchy structure containing organized objects\n- `goal` - High-level goal specification to achieve:\n  - Can be a simple goal description (string/atom)\n  - Or detailed goal map with constraints and preferences\n- `current_state` - Current system state:\n  - Object states and positions\n  - Resource availability\n  - Environmental conditions","ref":"Object.Hierarchy.html#hierarchical_planning/3-parameters"},{"type":"function","title":"Returns - Object.Hierarchy.hierarchical_planning/3","doc":"- `{:ok, executable_plan}` - Complete executable plan\n- `{:error, {:planning_failed, reason}}` - Planning failed due to:\n  - `:goal_unreachable` - Goal cannot be achieved with current resources\n  - `:insufficient_objects` - Not enough objects to complete plan\n  - `:resource_constraints` - Insufficient resources for execution\n  - `:time_limit_exceeded` - Planning took too long","ref":"Object.Hierarchy.html#hierarchical_planning/3-returns"},{"type":"function","title":"Planning Process - Object.Hierarchy.hierarchical_planning/3","doc":"1. **Abstract Planning**: Create high-level plan at top abstraction level\n2. **Iterative Refinement**: Refine plan down through abstraction levels\n3. **Concrete Actions**: Generate executable actions at level 0\n4. **Schedule Creation**: Determine timing and coordination requirements\n5. **Resource Allocation**: Assign resources to plan steps","ref":"Object.Hierarchy.html#hierarchical_planning/3-planning-process"},{"type":"function","title":"Plan Structure - Object.Hierarchy.hierarchical_planning/3","doc":"The returned executable plan contains:\n- `:executable_actions` - Sequence of concrete actions for objects\n- `:execution_schedule` - Timing and coordination information\n- `:resource_requirements` - Required computational and physical resources\n- `:success_probability` - Estimated probability of successful completion\n- `:contingency_plans` - Alternative plans for failure scenarios\n- `:coordination_points` - Synchronization points between objects","ref":"Object.Hierarchy.html#hierarchical_planning/3-plan-structure"},{"type":"function","title":"Examples - Object.Hierarchy.hierarchical_planning/3","doc":"# Simple goal planning\n    iex> goal = \"optimize system performance\"\n    iex> current_state = %{system_load: 0.7, available_objects: 5}\n    iex> {:ok, plan} = Object.Hierarchy.hierarchical_planning(\n    ...>   hierarchy, goal, current_state\n    ...> )\n    iex> length(plan.executable_actions)\n    12\n    iex> plan.success_probability\n    0.85\n    \n    # Complex goal with constraints\n    iex> complex_goal = %{\n    ...>   objective: \"coordinate rescue operation\",\n    ...>   constraints: %{max_time: 300, min_success_rate: 0.9},\n    ...>   preferences: %{minimize_risk: true, maximize_coverage: true}\n    ...> }\n    iex> {:ok, plan} = Object.Hierarchy.hierarchical_planning(\n    ...>   hierarchy, complex_goal, current_state\n    ...> )\n    iex> plan.execution_schedule.total_duration\n    285","ref":"Object.Hierarchy.html#hierarchical_planning/3-examples"},{"type":"function","title":"Hierarchical Benefits - Object.Hierarchy.hierarchical_planning/3","doc":"Hierarchical planning provides:","ref":"Object.Hierarchy.html#hierarchical_planning/3-hierarchical-benefits"},{"type":"function","title":"Computational Efficiency - Object.Hierarchy.hierarchical_planning/3","doc":"- **Reduced Search Space**: Abstract levels prune irrelevant branches\n- **Faster Convergence**: High-level structure guides detailed planning\n- **Scalable Complexity**: Handle large systems efficiently","ref":"Object.Hierarchy.html#hierarchical_planning/3-computational-efficiency"},{"type":"function","title":"Plan Quality - Object.Hierarchy.hierarchical_planning/3","doc":"- **Global Optimization**: Consider system-wide objectives\n- **Local Efficiency**: Optimize detailed execution at each level\n- **Robust Solutions**: Multiple abstraction levels provide fallbacks","ref":"Object.Hierarchy.html#hierarchical_planning/3-plan-quality"},{"type":"function","title":"Adaptive Execution - Object.Hierarchy.hierarchical_planning/3","doc":"- **Real-time Refinement**: Adjust plans during execution\n- **Graceful Degradation**: Maintain functionality despite failures\n- **Dynamic Replanning**: Respond to changing conditions","ref":"Object.Hierarchy.html#hierarchical_planning/3-adaptive-execution"},{"type":"function","title":"Planning Algorithms - Object.Hierarchy.hierarchical_planning/3","doc":"The planning process uses:\n- **Hierarchical Task Networks (HTN)**: Decompose abstract tasks\n- **Forward Search**: Explore action sequences from current state\n- **Constraint Satisfaction**: Respect resource and timing constraints\n- **Multi-Objective Optimization**: Balance competing objectives","ref":"Object.Hierarchy.html#hierarchical_planning/3-planning-algorithms"},{"type":"function","title":"Performance Characteristics - Object.Hierarchy.hierarchical_planning/3","doc":"- **Planning Time**: O(b^(d/k)) where b=branching, d=depth, k=abstraction factor\n- **Memory Usage**: Linear with hierarchy size\n- **Success Rate**: 80-95% for well-structured hierarchies\n- **Scalability**: Handles 100+ objects across 5+ abstraction levels","ref":"Object.Hierarchy.html#hierarchical_planning/3-performance-characteristics"},{"type":"function","title":"Object.Hierarchy.new/2","doc":"Creates a new hierarchical structure with the given root object.\n\nInitializes a hierarchy with the specified object as the root node,\nsetting up default composition rules, decomposition strategies,\nand coordination protocols.","ref":"Object.Hierarchy.html#new/2"},{"type":"function","title":"Parameters - Object.Hierarchy.new/2","doc":"- `root_object_id` - ID of the object to serve as hierarchy root\n- `opts` - Optional configuration:\n  - `:composition_rules` - Rules for object composition\n  - `:decomposition_strategies` - Strategies for object decomposition\n  - `:planning_horizon` - Planning time horizon (default 10)\n  - `:protocols` - Coordination protocols (default [:consensus, :delegation, :auction])","ref":"Object.Hierarchy.html#new/2-parameters"},{"type":"function","title":"Returns - Object.Hierarchy.new/2","doc":"New hierarchy structure","ref":"Object.Hierarchy.html#new/2-returns"},{"type":"function","title":"Examples - Object.Hierarchy.new/2","doc":"iex> Object.Hierarchy.new(\"root_obj\", planning_horizon: 20)\n    %Object.Hierarchy{root_object_id: \"root_obj\", planning_horizon: 20, ...}","ref":"Object.Hierarchy.html#new/2-examples"},{"type":"type","title":"Object.Hierarchy.object_id/0","doc":"Unique object identifier string","ref":"Object.Hierarchy.html#t:object_id/0"},{"type":"type","title":"Object.Hierarchy.object_spec/0","doc":"Specification for an object within the hierarchy.","ref":"Object.Hierarchy.html#t:object_spec/0"},{"type":"type","title":"Fields - Object.Hierarchy.object_spec/0","doc":"- `id` - Unique object identifier\n- `type` - Object type/category for composition matching\n- `capabilities` - List of capabilities this object provides\n- `dependencies` - List of other objects this object depends on\n- `composition_weight` - Weight for composition optimization (0.0-1.0)","ref":"Object.Hierarchy.html#t:object_spec/0-fields"},{"type":"type","title":"Object.Hierarchy.protocol/0","doc":"Coordination protocol identifier","ref":"Object.Hierarchy.html#t:protocol/0"},{"type":"type","title":"Object.Hierarchy.t/0","doc":"Hierarchical structure containing all levels and organization rules.","ref":"Object.Hierarchy.html#t:t/0"},{"type":"type","title":"Fields - Object.Hierarchy.t/0","doc":"- `root_object_id` - ID of the root object at the top of the hierarchy\n- `hierarchy_levels` - Map from level number to objects at that level\n- `composition_rules` - Rules for automatically combining objects\n- `decomposition_strategies` - Strategies for breaking down complex objects\n- `abstraction_mappings` - Map from object ID to its abstraction level\n- `planning_horizon` - Time horizon for hierarchical planning\n- `coordination_protocols` - Protocols for inter-level coordination","ref":"Object.Hierarchy.html#t:t/0-fields"},{"type":"type","title":"Level Organization - Object.Hierarchy.t/0","doc":"- Higher numbers = more abstract levels\n- Level 0 = concrete objects\n- Root object typically at highest level","ref":"Object.Hierarchy.html#t:t/0-level-organization"},{"type":"module","title":"Object.InteractionPatterns","doc":"Defines and manages interaction patterns between Objects for self-organization.\n\nThis module implements various interaction patterns that enable emergent behaviors:\n1. Peer-to-peer negotiation and consensus building\n2. Hierarchical coordination and delegation\n3. Swarm intelligence and collective decision making\n4. Market-based resource allocation\n5. Gossip protocols for information dissemination\n6. Adaptive coalition formation\n\nEach pattern is implemented as a composable interaction protocol that Objects\ncan dynamically adopt based on their context and objectives.","ref":"Object.InteractionPatterns.html"},{"type":"function","title":"Object.InteractionPatterns.adaptive_routing/3","doc":"Adaptive routing pattern for dynamic message and task routing.","ref":"Object.InteractionPatterns.html#adaptive_routing/3"},{"type":"function","title":"Object.InteractionPatterns.coalition_formation/3","doc":"Coalition formation pattern for dynamic team assembly.","ref":"Object.InteractionPatterns.html#coalition_formation/3"},{"type":"function","title":"Object.InteractionPatterns.collaborative_learning/3","doc":"Collaborative learning pattern for knowledge sharing and joint improvement.","ref":"Object.InteractionPatterns.html#collaborative_learning/3"},{"type":"function","title":"Object.InteractionPatterns.gossip_propagation/3","doc":"Gossip propagation pattern for distributed information sharing.","ref":"Object.InteractionPatterns.html#gossip_propagation/3"},{"type":"function","title":"Object.InteractionPatterns.hierarchical_delegation/3","doc":"Hierarchical delegation pattern for top-down task distribution.","ref":"Object.InteractionPatterns.html#hierarchical_delegation/3"},{"type":"function","title":"Object.InteractionPatterns.initiate_pattern/4","doc":"Initiates a specific interaction pattern between objects.","ref":"Object.InteractionPatterns.html#initiate_pattern/4"},{"type":"function","title":"Object.InteractionPatterns.market_auction/3","doc":"Market auction pattern for resource allocation through bidding.","ref":"Object.InteractionPatterns.html#market_auction/3"},{"type":"function","title":"Object.InteractionPatterns.peer_negotiation/3","doc":"Peer negotiation pattern for bilateral or multilateral agreements.","ref":"Object.InteractionPatterns.html#peer_negotiation/3"},{"type":"function","title":"Object.InteractionPatterns.swarm_consensus/3","doc":"Swarm consensus pattern for collective decision making.","ref":"Object.InteractionPatterns.html#swarm_consensus/3"},{"type":"module","title":"Object.LLMIntegration","doc":"Enhanced LLM integration for AAOS objects using DSPy.\n\nThis module enables objects to:\n1. Respond to messages using LLM-powered natural language\n2. Generate contextual responses based on object state and history\n3. Adapt their communication style based on interaction patterns\n4. Use structured reasoning for complex decisions\n\nUsage Examples:\n\n    # Basic LLM response generation\n    {:ok, response} = Object.LLMIntegration.generate_response(object, incoming_message)\n    \n    # Contextual conversation\n    {:ok, response} = Object.LLMIntegration.conversational_response(object, message, conversation_history)\n    \n    # Goal-oriented reasoning\n    {:ok, plan} = Object.LLMIntegration.reason_about_goal(object, goal, current_situation)","ref":"Object.LLMIntegration.html"},{"type":"function","title":"Object.LLMIntegration.collaborative_reasoning/3","doc":"Enables objects to engage in collaborative reasoning with other objects.","ref":"Object.LLMIntegration.html#collaborative_reasoning/3"},{"type":"function","title":"Parameters - Object.LLMIntegration.collaborative_reasoning/3","doc":"- `objects`: List of objects participating in reasoning\n- `shared_problem`: Problem to solve collaboratively\n- `collaboration_type`: Type of collaboration (`:consensus`, `:negotiation`, etc.)","ref":"Object.LLMIntegration.html#collaborative_reasoning/3-parameters"},{"type":"function","title":"Returns - Object.LLMIntegration.collaborative_reasoning/3","doc":"`{:ok, collaboration_result}` with synthesized solution and role assignments","ref":"Object.LLMIntegration.html#collaborative_reasoning/3-returns"},{"type":"function","title":"Object.LLMIntegration.conversational_response/3","doc":"Generates contextual conversation responses maintaining conversation state.","ref":"Object.LLMIntegration.html#conversational_response/3"},{"type":"function","title":"Parameters - Object.LLMIntegration.conversational_response/3","doc":"- `object`: The object in conversation\n- `message`: Current message to respond to\n- `conversation_history`: Previous messages in conversation (default: [])","ref":"Object.LLMIntegration.html#conversational_response/3-parameters"},{"type":"function","title":"Returns - Object.LLMIntegration.conversational_response/3","doc":"`{:ok, response, updated_object}` with conversational response","ref":"Object.LLMIntegration.html#conversational_response/3-returns"},{"type":"function","title":"Object.LLMIntegration.create_custom_signature/5","doc":"Creates a custom DSPy signature for specific object interactions.","ref":"Object.LLMIntegration.html#create_custom_signature/5"},{"type":"function","title":"Parameters - Object.LLMIntegration.create_custom_signature/5","doc":"- `name`: Name for the signature\n- `description`: Description of what the signature does\n- `inputs`: List of input fields\n- `outputs`: List of output fields\n- `instructions`: Instructions for the LLM","ref":"Object.LLMIntegration.html#create_custom_signature/5-parameters"},{"type":"function","title":"Returns - Object.LLMIntegration.create_custom_signature/5","doc":"Signature specification map","ref":"Object.LLMIntegration.html#create_custom_signature/5-returns"},{"type":"function","title":"Object.LLMIntegration.generate_response/3","doc":"Generates an LLM-powered response to an incoming message.","ref":"Object.LLMIntegration.html#generate_response/3"},{"type":"function","title":"Parameters - Object.LLMIntegration.generate_response/3","doc":"- `object`: The object generating the response\n- `message`: Incoming message to respond to\n- `opts`: Options like `:style`, `:max_length`","ref":"Object.LLMIntegration.html#generate_response/3-parameters"},{"type":"function","title":"Returns - Object.LLMIntegration.generate_response/3","doc":"`{:ok, response, updated_object}` with generated response and updated object state","ref":"Object.LLMIntegration.html#generate_response/3-returns"},{"type":"function","title":"Examples - Object.LLMIntegration.generate_response/3","doc":"iex> Object.LLMIntegration.generate_response(object, message)\n    {:ok, %{content: \"I understand your request...\", tone: \"helpful\"}, updated_object}","ref":"Object.LLMIntegration.html#generate_response/3-examples"},{"type":"function","title":"Object.LLMIntegration.reason_about_goal/4","doc":"Uses LLM reasoning for complex goal-oriented decisions.","ref":"Object.LLMIntegration.html#reason_about_goal/4"},{"type":"function","title":"Parameters - Object.LLMIntegration.reason_about_goal/4","doc":"- `object`: The reasoning object\n- `goal`: Goal to reason about\n- `current_situation`: Current state and context\n- `constraints`: Limitations to consider (default: [])","ref":"Object.LLMIntegration.html#reason_about_goal/4-parameters"},{"type":"function","title":"Returns - Object.LLMIntegration.reason_about_goal/4","doc":"`{:ok, reasoning_result, updated_object}` with detailed reasoning analysis","ref":"Object.LLMIntegration.html#reason_about_goal/4-returns"},{"type":"function","title":"Object.LLMIntegration.register_signature/1","doc":"Registers a custom signature for reuse across objects.","ref":"Object.LLMIntegration.html#register_signature/1"},{"type":"function","title":"Parameters - Object.LLMIntegration.register_signature/1","doc":"- `signature`: Signature specification to register","ref":"Object.LLMIntegration.html#register_signature/1-parameters"},{"type":"function","title":"Returns - Object.LLMIntegration.register_signature/1","doc":"`{:ok, signature_name}` on successful registration","ref":"Object.LLMIntegration.html#register_signature/1-returns"},{"type":"module","title":"Object.Mailbox","doc":"Object-Oriented Reinforcement Learning (OORL) Mailbox implementation\nbased on AAOS Section 4 - Object Interactions.\n\nImplements a comprehensive message-passing protocol with interaction dyads,\npriority-based message processing, and communication mechanisms for autonomous\nobjects. The mailbox provides reliable, efficient communication between objects\nin the AAOS system.","ref":"Object.Mailbox.html"},{"type":"module","title":"Core Features - Object.Mailbox","doc":"- **Message Passing**: Reliable message delivery with acknowledgments\n- **Interaction Dyads**: Bidirectional communication relationships\n- **Priority Processing**: Priority-based message ordering\n- **Protocol Handlers**: Extensible message type handling\n- **Message History**: Bounded history for debugging and analysis\n- **Routing Tables**: Efficient message routing information\n- **Delivery Confirmations**: Acknowledgment tracking system","ref":"Object.Mailbox.html#module-core-features"},{"type":"module","title":"Message Types - Object.Mailbox","doc":"The mailbox supports various message types for different communication patterns:\n\n- `:state_update` - Object state change notifications\n- `:goal_update` - Goal function modifications\n- `:belief_update` - World model belief updates\n- `:learning_signal` - Learning data and feedback\n- `:coordination` - Multi-object coordination protocols\n- `:negotiation` - Multi-step negotiation processes\n- `:acknowledgment` - Delivery confirmations\n- `:heartbeat` - Connection health monitoring","ref":"Object.Mailbox.html#module-message-types"},{"type":"module","title":"Interaction Dyads - Object.Mailbox","doc":"Dyads are bidirectional relationships between objects that enable:\n- Enhanced communication efficiency\n- Social learning and knowledge transfer\n- Coordinated behavior and cooperation\n- Trust and reputation building","ref":"Object.Mailbox.html#module-interaction-dyads"},{"type":"module","title":"Performance Characteristics - Object.Mailbox","doc":"- **Message Throughput**: ~1000 messages/second per mailbox\n- **Latency**: <1ms for local message processing\n- **Memory Usage**: ~100 bytes per message + content size\n- **History Retention**: Configurable bounded queue (default: 1000 messages)\n- **Scalability**: Efficient O(1) message insertion and O(log n) priority sorting","ref":"Object.Mailbox.html#module-performance-characteristics"},{"type":"module","title":"Error Handling - Object.Mailbox","doc":"- Message validation prevents malformed messages\n- Acknowledgment system ensures reliable delivery\n- Dead letter handling for undeliverable messages\n- Circuit breaker protection against message storms\n- Graceful degradation under resource pressure","ref":"Object.Mailbox.html#module-error-handling"},{"type":"module","title":"Example Usage - Object.Mailbox","doc":"# Create a new mailbox\n    mailbox = Object.Mailbox.new(\"agent_1\")\n    \n    # Send a coordination message\n    updated_mailbox = Object.Mailbox.send_message(\n      mailbox, \"agent_2\", :coordination,\n      %{action: :form_coalition}, [priority: :high]\n    )\n    \n    # Form an interaction dyad\n    dyad_mailbox = Object.Mailbox.form_dyad(mailbox, \"partner_agent\", 0.8)\n    \n    # Process incoming messages\n    {processed, final_mailbox} = Object.Mailbox.process_inbox(dyad_mailbox)","ref":"Object.Mailbox.html#module-example-usage"},{"type":"function","title":"Object.Mailbox.dissolve_dyad/2","doc":"Dissolves an interaction dyad.\n\nMarks an existing interaction dyad as inactive, effectively ending\nthe enhanced communication relationship while preserving historical\ninteraction data for analysis.","ref":"Object.Mailbox.html#dissolve_dyad/2"},{"type":"function","title":"Parameters - Object.Mailbox.dissolve_dyad/2","doc":"- `mailbox` - Mailbox struct containing the dyad\n- `other_object_id` - ID of the other object in the dyad to dissolve","ref":"Object.Mailbox.html#dissolve_dyad/2-parameters"},{"type":"function","title":"Returns - Object.Mailbox.dissolve_dyad/2","doc":"Updated mailbox with dyad marked as inactive (not removed).","ref":"Object.Mailbox.html#dissolve_dyad/2-returns"},{"type":"function","title":"Dissolution vs Removal - Object.Mailbox.dissolve_dyad/2","doc":"Dyads are marked inactive rather than deleted to:\n- Preserve interaction history for analysis\n- Enable potential reactivation in the future\n- Maintain social learning data\n- Support reputation and trust calculations","ref":"Object.Mailbox.html#dissolve_dyad/2-dissolution-vs-removal"},{"type":"function","title":"Examples - Object.Mailbox.dissolve_dyad/2","doc":"# Dissolve existing dyad\n    iex> dissolved = Object.Mailbox.dissolve_dyad(mailbox, \"partner_agent\")\n    iex> dyad = dissolved.interaction_dyads[\"agent_1-partner_agent\"]\n    iex> dyad.active\n    false\n    \n    # Dyad data preserved\n    iex> dyad.interaction_count\n    25\n    iex> dyad.formation_time\n    ~D[2024-01-15 10:30:00]","ref":"Object.Mailbox.html#dissolve_dyad/2-examples"},{"type":"function","title":"Common Dissolution Triggers - Object.Mailbox.dissolve_dyad/2","doc":"- **Poor Performance**: Low utility scores over time\n- **Compatibility Issues**: Repeated coordination failures\n- **Resource Constraints**: Too many active dyads\n- **Task Completion**: Project-specific partnerships ending\n- **Manual Override**: Explicit dissolution requests","ref":"Object.Mailbox.html#dissolve_dyad/2-common-dissolution-triggers"},{"type":"function","title":"Effects of Dissolution - Object.Mailbox.dissolve_dyad/2","doc":"Once dissolved, the dyad:\n- No longer provides priority message routing\n- Stops contributing to social learning\n- Removes coordination benefits\n- Preserves historical interaction data\n- Can be reactivated if needed","ref":"Object.Mailbox.html#dissolve_dyad/2-effects-of-dissolution"},{"type":"function","title":"Reactivation - Object.Mailbox.dissolve_dyad/2","doc":"Inactive dyads can be reactivated by:\n- Calling `form_dyad/3` again with the same partner\n- Automatic reactivation on successful interactions\n- Manual reactivation through administrative tools","ref":"Object.Mailbox.html#dissolve_dyad/2-reactivation"},{"type":"function","title":"Performance - Object.Mailbox.dissolve_dyad/2","doc":"- Dissolution time: ~0.05ms\n- Memory preserved: Historical data retained\n- No immediate cleanup: Background garbage collection","ref":"Object.Mailbox.html#dissolve_dyad/2-performance"},{"type":"function","title":"Object.Mailbox.form_dyad/3","doc":"Forms an interaction dyad between two objects.\n\nCreates a bidirectional interaction relationship between the mailbox\nowner and another object, enabling enhanced communication, coordination,\nand social learning capabilities.","ref":"Object.Mailbox.html#form_dyad/3"},{"type":"function","title":"Parameters - Object.Mailbox.form_dyad/3","doc":"- `mailbox` - Mailbox struct to add dyad to\n- `other_object_id` - ID of the other object in the dyad\n- `compatibility_score` - Initial compatibility assessment (0.0-1.0, default: 0.5)","ref":"Object.Mailbox.html#form_dyad/3-parameters"},{"type":"function","title":"Returns - Object.Mailbox.form_dyad/3","doc":"Updated mailbox with new dyad added to interaction_dyads map.","ref":"Object.Mailbox.html#form_dyad/3-returns"},{"type":"function","title":"Dyad Structure - Object.Mailbox.form_dyad/3","doc":"Created dyads include:\n- **Participants**: Tuple of both object IDs\n- **Formation Time**: Timestamp of dyad creation\n- **Interaction Count**: Initial count of 0\n- **Compatibility Score**: Initial assessment\n- **Utility Score**: Calculated benefit metric (starts at 0.0)\n- **Active Status**: Set to true for new dyads","ref":"Object.Mailbox.html#form_dyad/3-dyad-structure"},{"type":"function","title":"Compatibility Guidelines - Object.Mailbox.form_dyad/3","doc":"- `0.0-0.3` - Low compatibility, limited benefits\n- `0.3-0.7` - Moderate compatibility, task-specific benefits\n- `0.7-1.0` - High compatibility, excellent collaboration","ref":"Object.Mailbox.html#form_dyad/3-compatibility-guidelines"},{"type":"function","title":"Examples - Object.Mailbox.form_dyad/3","doc":"# Form high-compatibility dyad\n    iex> updated = Object.Mailbox.form_dyad(mailbox, \"partner_agent\", 0.8)\n    iex> dyads = Object.Mailbox.get_active_dyads(updated)\n    iex> map_size(dyads)\n    1\n    \n    # Default compatibility\n    iex> mailbox = Object.Mailbox.form_dyad(mailbox, \"sensor_1\")\n    iex> dyad = mailbox.interaction_dyads[\"agent_1-sensor_1\"]\n    iex> dyad.compatibility_score\n    0.5","ref":"Object.Mailbox.html#form_dyad/3-examples"},{"type":"function","title":"Dyad Benefits - Object.Mailbox.form_dyad/3","doc":"Once formed, dyads provide:","ref":"Object.Mailbox.html#form_dyad/3-dyad-benefits"},{"type":"function","title":"Enhanced Communication - Object.Mailbox.form_dyad/3","doc":"- Priority message routing between dyad partners\n- Reduced message latency and overhead\n- Dedicated communication channels","ref":"Object.Mailbox.html#form_dyad/3-enhanced-communication"},{"type":"function","title":"Social Learning - Object.Mailbox.form_dyad/3","doc":"- Shared experience and knowledge transfer\n- Collaborative problem solving\n- Behavioral imitation and adaptation","ref":"Object.Mailbox.html#form_dyad/3-social-learning"},{"type":"function","title":"Coordination - Object.Mailbox.form_dyad/3","doc":"- Simplified cooperation protocols\n- Joint action planning and execution\n- Resource sharing and allocation","ref":"Object.Mailbox.html#form_dyad/3-coordination"},{"type":"function","title":"Trust Building - Object.Mailbox.form_dyad/3","doc":"- Reputation tracking and assessment\n- Reliability and performance monitoring\n- Long-term relationship maintenance","ref":"Object.Mailbox.html#form_dyad/3-trust-building"},{"type":"function","title":"Dyad Evolution - Object.Mailbox.form_dyad/3","doc":"Dyads evolve over time through:\n1. **Interaction**: Message exchanges update interaction count\n2. **Utility Calculation**: Performance-based utility scoring\n3. **Compatibility Adjustment**: Adaptation based on outcomes\n4. **Activity Management**: Automatic activation/deactivation","ref":"Object.Mailbox.html#form_dyad/3-dyad-evolution"},{"type":"function","title":"Performance - Object.Mailbox.form_dyad/3","doc":"- Formation time: ~0.1ms\n- Memory overhead: ~200 bytes per dyad\n- Lookup performance: O(1) by dyad ID\n- Maximum recommended dyads: 50 per object","ref":"Object.Mailbox.html#form_dyad/3-performance"},{"type":"function","title":"Object.Mailbox.get_active_dyads/1","doc":"Gets all active interaction dyads.\n\nRetrieves all currently active interaction dyads from the mailbox,\nfiltering out inactive dyads and returning only those that provide\nactive communication and coordination benefits.","ref":"Object.Mailbox.html#get_active_dyads/1"},{"type":"function","title":"Parameters - Object.Mailbox.get_active_dyads/1","doc":"- `mailbox` - Mailbox struct to query","ref":"Object.Mailbox.html#get_active_dyads/1-parameters"},{"type":"function","title":"Returns - Object.Mailbox.get_active_dyads/1","doc":"Map of dyad_id → interaction_dyad for all active dyads.","ref":"Object.Mailbox.html#get_active_dyads/1-returns"},{"type":"function","title":"Examples - Object.Mailbox.get_active_dyads/1","doc":"# Get active dyads\n    iex> active_dyads = Object.Mailbox.get_active_dyads(mailbox)\n    iex> map_size(active_dyads)\n    3\n    \n    # Check specific dyad activity\n    iex> dyads = Object.Mailbox.get_active_dyads(mailbox)\n    iex> Map.has_key?(dyads, \"agent_1-partner_2\")\n    true\n    \n    # Examine dyad details\n    iex> dyads = Object.Mailbox.get_active_dyads(mailbox)\n    iex> dyad = dyads[\"agent_1-coordinator_1\"]\n    iex> dyad.utility_score\n    0.75\n    iex> dyad.interaction_count\n    42","ref":"Object.Mailbox.html#get_active_dyads/1-examples"},{"type":"function","title":"Use Cases - Object.Mailbox.get_active_dyads/1","doc":"Active dyad information is useful for:","ref":"Object.Mailbox.html#get_active_dyads/1-use-cases"},{"type":"function","title":"Communication Optimization - Object.Mailbox.get_active_dyads/1","doc":"- Priority routing decisions\n- Load balancing across partners\n- Connection health monitoring","ref":"Object.Mailbox.html#get_active_dyads/1-communication-optimization"},{"type":"function","title":"Social Learning - Object.Mailbox.get_active_dyads/1","doc":"- Partner selection for knowledge transfer\n- Imitation target identification\n- Collaborative learning opportunities","ref":"Object.Mailbox.html#get_active_dyads/1-social-learning"},{"type":"function","title":"Coordination - Object.Mailbox.get_active_dyads/1","doc":"- Coalition formation decisions\n- Task assignment optimization\n- Resource sharing partnerships","ref":"Object.Mailbox.html#get_active_dyads/1-coordination"},{"type":"function","title":"Performance Analysis - Object.Mailbox.get_active_dyads/1","doc":"- Dyad effectiveness measurement\n- Social network analysis\n- Interaction pattern identification","ref":"Object.Mailbox.html#get_active_dyads/1-performance-analysis"},{"type":"function","title":"Dyad Activity - Object.Mailbox.get_active_dyads/1","doc":"Dyads are considered active when:\n- `active` field is `true`\n- Recent interaction activity (implementation dependent)\n- Both participants are still available\n- Utility score above minimum threshold","ref":"Object.Mailbox.html#get_active_dyads/1-dyad-activity"},{"type":"function","title":"Performance - Object.Mailbox.get_active_dyads/1","doc":"- Query time: O(n) where n is total dyad count\n- Typical response: ~0.1ms for <50 dyads\n- Memory usage: New map creation, ~100 bytes overhead\n- No side effects: Read-only operation","ref":"Object.Mailbox.html#get_active_dyads/1-performance"},{"type":"function","title":"Filtering Criteria - Object.Mailbox.get_active_dyads/1","doc":"Only dyads matching these criteria are returned:\n- `dyad.active == true`\n- Dyad record is not nil\n- Both participants are valid object IDs","ref":"Object.Mailbox.html#get_active_dyads/1-filtering-criteria"},{"type":"function","title":"Object.Mailbox.get_stats/1","doc":"Gets comprehensive mailbox statistics.\n\nRetrieves detailed statistics about the mailbox's communication patterns,\nperformance metrics, and operational status. Useful for monitoring,\ndebugging, and performance optimization.","ref":"Object.Mailbox.html#get_stats/1"},{"type":"function","title":"Parameters - Object.Mailbox.get_stats/1","doc":"- `mailbox` - Mailbox struct to analyze","ref":"Object.Mailbox.html#get_stats/1-parameters"},{"type":"function","title":"Returns - Object.Mailbox.get_stats/1","doc":"Map containing comprehensive statistics:\n- `:total_messages_sent` - Number of messages sent by this mailbox\n- `:total_messages_received` - Number of messages received\n- `:pending_inbox` - Current unprocessed inbox messages\n- `:pending_outbox` - Current unsent outbox messages\n- `:active_dyads` - Number of currently active interaction dyads\n- `:total_dyads` - Total dyads ever formed (including inactive)\n- `:history_size` - Current message history queue size\n- `:history_limit` - Maximum history size limit\n- `:uptime` - Mailbox uptime in seconds","ref":"Object.Mailbox.html#get_stats/1-returns"},{"type":"function","title":"Examples - Object.Mailbox.get_stats/1","doc":"# Get basic statistics\n    iex> stats = Object.Mailbox.get_stats(mailbox)\n    iex> stats.total_messages_sent\n    127\n    iex> stats.active_dyads\n    5\n    \n    # Calculate performance metrics\n    iex> stats = Object.Mailbox.get_stats(mailbox)\n    iex> message_rate = (stats.total_messages_sent + stats.total_messages_received) / stats.uptime\n    iex> dyad_efficiency = stats.active_dyads / max(1, stats.total_dyads)","ref":"Object.Mailbox.html#get_stats/1-examples"},{"type":"function","title":"Performance Indicators - Object.Mailbox.get_stats/1","doc":"","ref":"Object.Mailbox.html#get_stats/1-performance-indicators"},{"type":"function","title":"Message Volume - Object.Mailbox.get_stats/1","doc":"- **High Volume** (>100 msg/min): Active hub or coordinator\n- **Medium Volume** (10-100 msg/min): Regular operational object\n- **Low Volume** (<10 msg/min): Peripheral or specialized object","ref":"Object.Mailbox.html#get_stats/1-message-volume"},{"type":"function","title":"Processing Health - Object.Mailbox.get_stats/1","doc":"- **Pending Inbox**: Should be near 0 for healthy processing\n- **Pending Outbox**: Indicates delivery bottlenecks if high\n- **History Usage**: `history_size / history_limit` ratio","ref":"Object.Mailbox.html#get_stats/1-processing-health"},{"type":"function","title":"Social Connectivity - Object.Mailbox.get_stats/1","doc":"- **Active Dyads**: Number of active partnerships\n- **Dyad Efficiency**: `active_dyads / total_dyads` ratio\n- **Interaction Density**: Messages per dyad","ref":"Object.Mailbox.html#get_stats/1-social-connectivity"},{"type":"function","title":"Monitoring Applications - Object.Mailbox.get_stats/1","doc":"","ref":"Object.Mailbox.html#get_stats/1-monitoring-applications"},{"type":"function","title":"Performance Monitoring - Object.Mailbox.get_stats/1","doc":"- Message throughput analysis\n- Processing bottleneck identification\n- Resource usage tracking","ref":"Object.Mailbox.html#get_stats/1-performance-monitoring"},{"type":"function","title":"Health Monitoring - Object.Mailbox.get_stats/1","doc":"- Communication failures detection\n- Overload condition identification\n- System degradation alerts","ref":"Object.Mailbox.html#get_stats/1-health-monitoring"},{"type":"function","title":"Social Analysis - Object.Mailbox.get_stats/1","doc":"- Interaction pattern analysis\n- Network connectivity assessment\n- Partner effectiveness evaluation","ref":"Object.Mailbox.html#get_stats/1-social-analysis"},{"type":"function","title":"Debugging - Object.Mailbox.get_stats/1","doc":"- Message flow tracing\n- Delivery failure analysis\n- Performance regression investigation","ref":"Object.Mailbox.html#get_stats/1-debugging"},{"type":"function","title":"Statistical Calculations - Object.Mailbox.get_stats/1","doc":"The statistics are computed as follows:\n\n```elixir\n# Message counts from history\nsent = Enum.count(history, &(&1.from == object_id))\nreceived = Enum.count(history, &(&1.to == object_id))\n\n# Current queue sizes\npending_in = length(inbox)\npending_out = length(outbox)\n\n# Dyad metrics\nactive = count_active_dyads(interaction_dyads)\ntotal = map_size(interaction_dyads)\n\n# Temporal metrics\nuptime = DateTime.diff(DateTime.utc_now(), created_at, :second)\n```","ref":"Object.Mailbox.html#get_stats/1-statistical-calculations"},{"type":"function","title":"Performance - Object.Mailbox.get_stats/1","doc":"- Calculation time: ~0.5-2ms depending on history size\n- Memory overhead: Temporary iteration over message history\n- No side effects: Read-only operation\n- Caching: Statistics can be cached for frequent access","ref":"Object.Mailbox.html#get_stats/1-performance"},{"type":"type","title":"Object.Mailbox.interaction_dyad/0","doc":"Interaction dyad representing a bidirectional relationship between two objects.","ref":"Object.Mailbox.html#t:interaction_dyad/0"},{"type":"type","title":"Fields - Object.Mailbox.interaction_dyad/0","doc":"- `participants` - Tuple of the two object IDs in the dyad\n- `formation_time` - When the dyad was first established\n- `interaction_count` - Number of interactions through this dyad\n- `compatibility_score` - Initial compatibility assessment (0.0-1.0)\n- `utility_score` - Calculated utility based on interaction success\n- `active` - Whether the dyad is currently active","ref":"Object.Mailbox.html#t:interaction_dyad/0-fields"},{"type":"type","title":"Utility Calculation - Object.Mailbox.interaction_dyad/0","doc":"Utility score is computed as:\n```\nutility = min(interaction_count / 100.0, 1.0) * compatibility_score\n```\n\nThis rewards both frequent interaction and initial compatibility.","ref":"Object.Mailbox.html#t:interaction_dyad/0-utility-calculation"},{"type":"type","title":"Object.Mailbox.message/0","doc":"Message structure for inter-object communication.","ref":"Object.Mailbox.html#t:message/0"},{"type":"type","title":"Fields - Object.Mailbox.message/0","doc":"- `id` - Unique message identifier for tracking and deduplication\n- `from` - Sender object ID\n- `to` - Recipient object ID\n- `type` - Message type atom for routing and handling\n- `content` - Message payload (any serializable term)\n- `timestamp` - Message creation timestamp\n- `priority` - Processing priority level\n- `requires_ack` - Whether delivery confirmation is required\n- `ttl` - Time-to-live in seconds before message expires","ref":"Object.Mailbox.html#t:message/0-fields"},{"type":"type","title":"Object.Mailbox.message_type/0","doc":"Message type for routing and protocol handling","ref":"Object.Mailbox.html#t:message_type/0"},{"type":"function","title":"Object.Mailbox.new/2","doc":"Creates a new mailbox for an object.\n\nInitializes a complete mailbox with all necessary components for\ninter-object communication, including message queues, protocol handlers,\nand interaction tracking.","ref":"Object.Mailbox.html#new/2"},{"type":"function","title":"Parameters - Object.Mailbox.new/2","doc":"- `object_id` - ID of the object this mailbox belongs to\n- `opts` - Optional configuration:\n  - `:history_size_limit` - Maximum message history size (default: 1000)","ref":"Object.Mailbox.html#new/2-parameters"},{"type":"function","title":"Returns - Object.Mailbox.new/2","doc":"New mailbox struct with initialized state and default protocol handlers.","ref":"Object.Mailbox.html#new/2-returns"},{"type":"function","title":"Default Protocol Handlers - Object.Mailbox.new/2","doc":"The mailbox is created with handlers for common message types:\n- `:state_update` - Process object state updates\n- `:goal_update` - Handle goal function changes\n- `:belief_update` - Update world model beliefs\n- `:learning_signal` - Process learning data\n- `:coordination` - Handle coordination protocols\n- `:negotiation` - Process negotiation messages\n- `:acknowledgment` - Handle delivery confirmations\n- `:heartbeat` - Process connectivity checks","ref":"Object.Mailbox.html#new/2-default-protocol-handlers"},{"type":"function","title":"Examples - Object.Mailbox.new/2","doc":"# Create basic mailbox\n    iex> mailbox = Object.Mailbox.new(\"agent_1\")\n    iex> mailbox.object_id\n    \"agent_1\"\n    iex> length(mailbox.inbox)\n    0\n    \n    # Create with custom history limit\n    iex> mailbox = Object.Mailbox.new(\"sensor_1\", history_size_limit: 500)\n    iex> mailbox.history_size_limit\n    500","ref":"Object.Mailbox.html#new/2-examples"},{"type":"function","title":"Performance - Object.Mailbox.new/2","doc":"- Creation time: ~0.1ms\n- Memory usage: ~1KB base + message storage\n- History queue: Efficient FIFO operations\n- Protocol handlers: Fast O(1) lookup","ref":"Object.Mailbox.html#new/2-performance"},{"type":"type","title":"Object.Mailbox.priority_level/0","doc":"Message processing priority level","ref":"Object.Mailbox.html#t:priority_level/0"},{"type":"function","title":"Object.Mailbox.process_inbox/1","doc":"Processes messages in the inbox based on type and priority.\n\nProcesses all pending messages in the inbox according to priority order,\napplying appropriate protocol handlers and generating results. This is\nthe core message processing function that drives object communication.","ref":"Object.Mailbox.html#process_inbox/1"},{"type":"function","title":"Parameters - Object.Mailbox.process_inbox/1","doc":"- `mailbox` - Mailbox struct with messages to process","ref":"Object.Mailbox.html#process_inbox/1-parameters"},{"type":"function","title":"Returns - Object.Mailbox.process_inbox/1","doc":"`{processed_messages, updated_mailbox}` where:\n- `processed_messages` - List of `{message, result}` tuples\n- `updated_mailbox` - Mailbox with cleared inbox and updated state","ref":"Object.Mailbox.html#process_inbox/1-returns"},{"type":"function","title":"Processing Priority - Object.Mailbox.process_inbox/1","doc":"Messages are processed in strict priority order:\n1. `:critical` - System-critical messages (emergency stops, failures)\n2. `:high` - Important coordination and control messages\n3. `:medium` - Regular operational messages (default)\n4. `:low` - Background tasks and maintenance messages\n\nWithin each priority level, messages are processed by timestamp (FIFO).","ref":"Object.Mailbox.html#process_inbox/1-processing-priority"},{"type":"function","title":"Protocol Handlers - Object.Mailbox.process_inbox/1","doc":"Each message type has a dedicated handler:\n\n- `:state_update` → Update object state\n- `:goal_update` → Modify goal function\n- `:belief_update` → Update world model beliefs\n- `:learning_signal` → Process learning data\n- `:coordination` → Handle coordination protocols\n- `:negotiation` → Process negotiation steps\n- `:acknowledgment` → Handle delivery confirmations\n- `:heartbeat` → Update connection status","ref":"Object.Mailbox.html#process_inbox/1-protocol-handlers"},{"type":"function","title":"Examples - Object.Mailbox.process_inbox/1","doc":"# Process accumulated messages\n    iex> {processed, updated} = Object.Mailbox.process_inbox(mailbox)\n    iex> length(processed)\n    3\n    iex> length(updated.inbox)\n    0\n    \n    # Examine processing results\n    iex> {[{msg1, result1}, {msg2, result2}], _} = Object.Mailbox.process_inbox(mailbox)\n    iex> result1\n    {:coordination_received, %{action: :form_coalition}}\n    iex> result2\n    {:state_updated, %{energy: 95}}","ref":"Object.Mailbox.html#process_inbox/1-examples"},{"type":"function","title":"Error Handling - Object.Mailbox.process_inbox/1","doc":"- Handler errors are caught and returned as `{:error, reason}`\n- Unknown message types return `{:error, :no_handler}`\n- Processing continues despite individual message failures\n- Failed messages are logged for debugging","ref":"Object.Mailbox.html#process_inbox/1-error-handling"},{"type":"function","title":"Performance - Object.Mailbox.process_inbox/1","doc":"- Processing rate: ~100-500 messages/second depending on complexity\n- Priority sorting: O(n log n) where n is inbox size\n- Handler execution: Varies by message type and content\n- Memory usage: Temporary overhead during processing","ref":"Object.Mailbox.html#process_inbox/1-performance"},{"type":"function","title":"Batch Processing - Object.Mailbox.process_inbox/1","doc":"- All inbox messages processed in single operation\n- Atomic inbox clearing prevents message loss\n- Efficient sorting reduces processing overhead\n- Results collected for analysis and debugging","ref":"Object.Mailbox.html#process_inbox/1-batch-processing"},{"type":"function","title":"Object.Mailbox.receive_message/2","doc":"Receives a message into the inbox.\n\nValidates and accepts an incoming message into the mailbox inbox,\nupdating interaction dyads and handling acknowledgments as needed.\nInvalid messages are rejected with appropriate error codes.","ref":"Object.Mailbox.html#receive_message/2"},{"type":"function","title":"Parameters - Object.Mailbox.receive_message/2","doc":"- `mailbox` - Mailbox struct to receive into\n- `message` - Message to receive (must include required fields)","ref":"Object.Mailbox.html#receive_message/2-parameters"},{"type":"function","title":"Returns - Object.Mailbox.receive_message/2","doc":"- Updated mailbox with message added to inbox\n- `{:error, reason}` if message validation fails","ref":"Object.Mailbox.html#receive_message/2-returns"},{"type":"function","title":"Message Validation - Object.Mailbox.receive_message/2","doc":"Required fields for valid messages:\n- `:id` - Unique message identifier\n- `:from` - Sender object ID\n- `:to` - Recipient object ID (should match mailbox owner)\n- `:type` - Message type for routing\n- `:content` - Message payload\n- `:timestamp` - Message creation time","ref":"Object.Mailbox.html#receive_message/2-message-validation"},{"type":"function","title":"Processing Steps - Object.Mailbox.receive_message/2","doc":"1. **Validation**: Check message format and required fields\n2. **Inbox Addition**: Add to inbox for processing\n3. **History Recording**: Add to message history\n4. **Dyad Update**: Update interaction dyad with sender\n5. **Acknowledgment**: Send ACK if required by message","ref":"Object.Mailbox.html#receive_message/2-processing-steps"},{"type":"function","title":"Examples - Object.Mailbox.receive_message/2","doc":"# Receive valid coordination message\n    iex> message = %{\n    ...>   id: \"msg_123\",\n    ...>   from: \"agent_2\",\n    ...>   to: \"agent_1\",\n    ...>   type: :coordination,\n    ...>   content: %{action: :form_coalition},\n    ...>   timestamp: DateTime.utc_now(),\n    ...>   priority: :high,\n    ...>   requires_ack: true,\n    ...>   ttl: 3600\n    ...> }\n    iex> updated = Object.Mailbox.receive_message(mailbox, message)\n    iex> length(updated.inbox)\n    1\n    \n    # Invalid message format\n    iex> bad_message = %{invalid: true}\n    iex> Object.Mailbox.receive_message(mailbox, bad_message)\n    {:error, :invalid_message_format}","ref":"Object.Mailbox.html#receive_message/2-examples"},{"type":"function","title":"Acknowledgments - Object.Mailbox.receive_message/2","doc":"When `requires_ack: true`:\n- Automatic acknowledgment message is sent back to sender\n- ACK contains original message ID for correlation\n- High priority for timely delivery confirmation","ref":"Object.Mailbox.html#receive_message/2-acknowledgments"},{"type":"function","title":"Error Conditions - Object.Mailbox.receive_message/2","doc":"- `:invalid_message_format` - Missing required fields\n- `:malformed_content` - Content structure invalid\n- `:expired_message` - Message TTL exceeded\n- `:duplicate_message` - Message ID already processed","ref":"Object.Mailbox.html#receive_message/2-error-conditions"},{"type":"function","title":"Performance - Object.Mailbox.receive_message/2","doc":"- Validation time: ~0.05ms per message\n- Inbox insertion: O(1) operation\n- History maintenance: Bounded queue operations\n- Dyad updates: O(1) lookup and modification","ref":"Object.Mailbox.html#receive_message/2-performance"},{"type":"function","title":"Object.Mailbox.register_handler/3","doc":"Registers a protocol handler for specific message types.","ref":"Object.Mailbox.html#register_handler/3"},{"type":"function","title":"Parameters - Object.Mailbox.register_handler/3","doc":"- `mailbox`: Mailbox struct\n- `message_type`: Type of message to handle\n- `handler_fn`: Function to handle messages of this type","ref":"Object.Mailbox.html#register_handler/3-parameters"},{"type":"function","title":"Returns - Object.Mailbox.register_handler/3","doc":"Updated mailbox with new handler registered","ref":"Object.Mailbox.html#register_handler/3-returns"},{"type":"function","title":"Object.Mailbox.send_message/5","doc":"Sends a message to another object.\n\nCreates and queues a message for delivery to another object, updating\nthe mailbox state and interaction dyad information. Messages are\nvalidated and assigned unique IDs for tracking.","ref":"Object.Mailbox.html#send_message/5"},{"type":"function","title":"Parameters - Object.Mailbox.send_message/5","doc":"- `mailbox` - Mailbox struct to send from\n- `to_object_id` - ID of the recipient object\n- `message_type` - Type of message for routing and handling\n- `content` - Message content (any serializable term)\n- `opts` - Optional message configuration:\n  - `:priority` - Message priority (:low, :medium, :high, :critical)\n  - `:requires_ack` - Whether delivery confirmation is required\n  - `:ttl` - Time-to-live in seconds (default: 3600)","ref":"Object.Mailbox.html#send_message/5-parameters"},{"type":"function","title":"Returns - Object.Mailbox.send_message/5","doc":"Updated mailbox with:\n- Message added to outbox\n- Message recorded in history\n- Interaction dyad updated or created\n- Updated timestamp","ref":"Object.Mailbox.html#send_message/5-returns"},{"type":"function","title":"Message Processing - Object.Mailbox.send_message/5","doc":"1. **Message Creation**: Generate unique ID and timestamp\n2. **Validation**: Ensure required fields are present\n3. **Outbox Addition**: Add to outbox for delivery\n4. **History Recording**: Add to bounded message history\n5. **Dyad Update**: Update or create interaction dyad","ref":"Object.Mailbox.html#send_message/5-message-processing"},{"type":"function","title":"Examples - Object.Mailbox.send_message/5","doc":"# Send coordination message\n    iex> updated = Object.Mailbox.send_message(\n    ...>   mailbox, \"coordinator_1\", :coordination,\n    ...>   %{action: :join_coalition},\n    ...>   [priority: :high, requires_ack: true]\n    ...> )\n    iex> length(updated.outbox)\n    1\n    \n    # Send learning signal with TTL\n    iex> Object.Mailbox.send_message(\n    ...>   mailbox, \"learner_2\", :learning_signal,\n    ...>   %{reward: 1.0, experience: %{action: :explore}},\n    ...>   [ttl: 300]\n    ...> )\n    %Object.Mailbox{outbox: [%{ttl: 300, ...}], ...}","ref":"Object.Mailbox.html#send_message/5-examples"},{"type":"function","title":"Interaction Dyads - Object.Mailbox.send_message/5","doc":"Sending messages automatically:\n- Creates new dyads if they don't exist\n- Updates interaction count for existing dyads\n- Calculates utility scores based on interaction frequency\n- Maintains dyad metadata for social learning","ref":"Object.Mailbox.html#send_message/5-interaction-dyads"},{"type":"function","title":"Performance - Object.Mailbox.send_message/5","doc":"- Message creation: ~0.1ms\n- History bounded at configurable limit\n- Dyad updates: O(1) lookup and update\n- Memory usage: ~100 bytes + content size per message","ref":"Object.Mailbox.html#send_message/5-performance"},{"type":"type","title":"Object.Mailbox.t/0","doc":"Mailbox structure for an object's communication system.","ref":"Object.Mailbox.html#t:t/0"},{"type":"type","title":"Fields - Object.Mailbox.t/0","doc":"- `object_id` - ID of the object this mailbox belongs to\n- `inbox` - List of incoming messages awaiting processing\n- `outbox` - List of outgoing messages awaiting delivery\n- `interaction_dyads` - Map of dyad_id to interaction_dyad structures\n- `message_history` - Bounded queue of message history for debugging\n- `routing_table` - Routing information for efficient message delivery\n- `protocol_handlers` - Map of message_type to handler functions\n- `delivery_confirmations` - Map tracking message delivery confirmations\n- `created_at` - Mailbox creation timestamp\n- `updated_at` - Last modification timestamp\n- `history_size_limit` - Maximum number of messages to retain in history","ref":"Object.Mailbox.html#t:t/0-fields"},{"type":"function","title":"Object.Mailbox.update_routing/3","doc":"Updates routing table for message delivery.","ref":"Object.Mailbox.html#update_routing/3"},{"type":"function","title":"Parameters - Object.Mailbox.update_routing/3","doc":"- `mailbox`: Mailbox struct\n- `object_id`: Object to update routing for\n- `route_info`: Routing information","ref":"Object.Mailbox.html#update_routing/3-parameters"},{"type":"function","title":"Returns - Object.Mailbox.update_routing/3","doc":"Updated mailbox with new routing information","ref":"Object.Mailbox.html#update_routing/3-returns"},{"type":"module","title":"Object.MessageConsumer","doc":"GenStage consumer for processing messages from the MessageRouter.\nHandles actual message delivery to target objects.","ref":"Object.MessageConsumer.html"},{"type":"function","title":"Object.MessageConsumer.start_link/1","doc":"","ref":"Object.MessageConsumer.html#start_link/1"},{"type":"module","title":"Object.MessageRouter","doc":"High-performance message routing service using GenStage for backpressure.\nHandles message delivery between objects with priority queuing and load balancing.","ref":"Object.MessageRouter.html"},{"type":"function","title":"Object.MessageRouter.get_routing_stats/0","doc":"Gets performance statistics for the message router.","ref":"Object.MessageRouter.html#get_routing_stats/0"},{"type":"function","title":"Returns - Object.MessageRouter.get_routing_stats/0","doc":"Map with pending messages, delivery rate, success/failure counts","ref":"Object.MessageRouter.html#get_routing_stats/0-returns"},{"type":"function","title":"Object.MessageRouter.route_message/1","doc":"Routes a message through the system with priority queuing.","ref":"Object.MessageRouter.html#route_message/1"},{"type":"function","title":"Parameters - Object.MessageRouter.route_message/1","doc":"- `message`: Message struct with routing information","ref":"Object.MessageRouter.html#route_message/1-parameters"},{"type":"function","title":"Returns - Object.MessageRouter.route_message/1","doc":"`:ok` - message is queued for delivery","ref":"Object.MessageRouter.html#route_message/1-returns"},{"type":"function","title":"Examples - Object.MessageRouter.route_message/1","doc":"iex> message = %{id: \"msg1\", from: \"obj1\", to: \"obj2\", ...}\n    iex> Object.MessageRouter.route_message(message)\n    :ok","ref":"Object.MessageRouter.html#route_message/1-examples"},{"type":"function","title":"Object.MessageRouter.start_link/1","doc":"Starts the message router GenStage producer.","ref":"Object.MessageRouter.html#start_link/1"},{"type":"function","title":"Returns - Object.MessageRouter.start_link/1","doc":"`{:ok, pid}` on successful startup","ref":"Object.MessageRouter.html#start_link/1-returns"},{"type":"module","title":"Object.MessageRouterSupervisor","doc":"Supervisor for the message routing system with multiple consumers.","ref":"Object.MessageRouterSupervisor.html"},{"type":"function","title":"Object.MessageRouterSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.MessageRouterSupervisor.html#child_spec/1"},{"type":"function","title":"Object.MessageRouterSupervisor.start_link/1","doc":"","ref":"Object.MessageRouterSupervisor.html#start_link/1"},{"type":"module","title":"Object.MetaDSL","doc":"Self-Reflective Meta-DSL implementation based on AAOS specification.\n\nProvides primitives and constructs for objects to reason about and modify\ntheir own learning process, enabling \"learning to learn\" capabilities.\n\nCore constructs include:\n- DEFINE: Define new attributes, methods, or sub-objects\n- GOAL: Query or modify the object's goal function\n- BELIEF: Update or query the object's beliefs about the environment\n- INFER: Perform probabilistic inference using the world model\n- DECIDE: Make decisions based on current state and goals\n- LEARN: Update learning parameters or strategies\n- REFINE: Meta-learning to improve learning efficiency","ref":"Object.MetaDSL.html"},{"type":"function","title":"Object.MetaDSL.belief/3","doc":"BELIEF construct: Update or query the object's beliefs about the environment.","ref":"Object.MetaDSL.html#belief/3"},{"type":"function","title":"Parameters - Object.MetaDSL.belief/3","doc":"- `meta_dsl`: Meta-DSL system struct\n- `object`: Object to operate on\n- `operation`: `:query`, `{:update, key, value}`, or `{:uncertainty, key, uncertainty}`","ref":"Object.MetaDSL.html#belief/3-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.belief/3","doc":"`{:ok, result, updated_meta_dsl}` with beliefs or updated object","ref":"Object.MetaDSL.html#belief/3-returns"},{"type":"function","title":"Object.MetaDSL.decide/3","doc":"DECIDE construct: Make decisions based on current state and goals.","ref":"Object.MetaDSL.html#decide/3"},{"type":"function","title":"Parameters - Object.MetaDSL.decide/3","doc":"- `meta_dsl` - Meta-DSL system struct\n- `object` - Object making the decision\n- `decision_context` - Decision context:\n  - `{:action_selection, available_actions}` - Choose optimal action\n  - `{:resource_allocation, resources, tasks}` - Allocate resources\n  - `{:coalition_formation, potential_partners}` - Form coalitions","ref":"Object.MetaDSL.html#decide/3-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.decide/3","doc":"`{:ok, decision_result, updated_meta_dsl}` with decision outcome","ref":"Object.MetaDSL.html#decide/3-returns"},{"type":"function","title":"Object.MetaDSL.define/3","doc":"DEFINE construct: Defines new attributes, methods, or sub-objects.","ref":"Object.MetaDSL.html#define/3"},{"type":"function","title":"Parameters - Object.MetaDSL.define/3","doc":"- `meta_dsl`: Meta-DSL system struct\n- `object`: Object to modify\n- `definition`: Definition tuple like `{:attribute, name, value}` or `{:method, name, impl}`","ref":"Object.MetaDSL.html#define/3-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.define/3","doc":"`{:ok, updated_object, updated_meta_dsl}` on success","ref":"Object.MetaDSL.html#define/3-returns"},{"type":"function","title":"Object.MetaDSL.evaluate_adaptation_triggers/3","doc":"Evaluates adaptation triggers and executes automatic adaptations.","ref":"Object.MetaDSL.html#evaluate_adaptation_triggers/3"},{"type":"function","title":"Parameters - Object.MetaDSL.evaluate_adaptation_triggers/3","doc":"- `meta_dsl`: Meta-DSL system struct\n- `object`: Object to evaluate triggers for\n- `performance_metrics`: Current performance data","ref":"Object.MetaDSL.html#evaluate_adaptation_triggers/3-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.evaluate_adaptation_triggers/3","doc":"`{:ok, updated_object, updated_meta_dsl}` with any triggered adaptations applied","ref":"Object.MetaDSL.html#evaluate_adaptation_triggers/3-returns"},{"type":"function","title":"Object.MetaDSL.execute/4","doc":"Executes a meta-DSL construct with the given arguments.","ref":"Object.MetaDSL.html#execute/4"},{"type":"function","title":"Parameters - Object.MetaDSL.execute/4","doc":"- `meta_dsl`: Meta-DSL system struct\n- `construct`: Construct to execute (`:define`, `:goal`, `:belief`, `:infer`, `:decide`, `:learn`, `:refine`)\n- `object`: Object to apply construct to\n- `args`: Arguments for the construct","ref":"Object.MetaDSL.html#execute/4-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.execute/4","doc":"`{:ok, result, updated_meta_dsl}` on success, `{:error, reason}` on failure","ref":"Object.MetaDSL.html#execute/4-returns"},{"type":"function","title":"Object.MetaDSL.goal/3","doc":"GOAL construct: Query or modify the object's goal function.","ref":"Object.MetaDSL.html#goal/3"},{"type":"function","title":"Parameters - Object.MetaDSL.goal/3","doc":"- `meta_dsl`: Meta-DSL system struct\n- `object`: Object to operate on\n- `operation`: `:query`, `{:modify, new_goal}`, or `{:compose, goal_functions}`","ref":"Object.MetaDSL.html#goal/3-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.goal/3","doc":"`{:ok, result, updated_meta_dsl}` where result depends on operation","ref":"Object.MetaDSL.html#goal/3-returns"},{"type":"function","title":"Object.MetaDSL.infer/3","doc":"INFER construct: Perform probabilistic inference using the world model.","ref":"Object.MetaDSL.html#infer/3"},{"type":"function","title":"Parameters - Object.MetaDSL.infer/3","doc":"- `meta_dsl` - Meta-DSL system struct\n- `object` - Object to perform inference on\n- `inference_query` - Query specification:\n  - `{:bayesian_update, evidence}` - Bayesian belief update\n  - `{:predict, state, horizon}` - State prediction\n  - `{:causal, cause, effect}` - Causal inference","ref":"Object.MetaDSL.html#infer/3-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.infer/3","doc":"`{:ok, inference_result, updated_meta_dsl}` with inference results","ref":"Object.MetaDSL.html#infer/3-returns"},{"type":"function","title":"Object.MetaDSL.learn/3","doc":"LEARN construct: Update learning parameters or strategies.","ref":"Object.MetaDSL.html#learn/3"},{"type":"function","title":"Parameters - Object.MetaDSL.learn/3","doc":"- `meta_dsl` - Meta-DSL system struct\n- `object` - Object updating learning\n- `learning_operation` - Learning operation:\n  - `{:update_parameters, new_params}` - Update learning parameters\n  - `{:adapt_strategy, performance_feedback}` - Adapt learning strategy\n  - `{:transfer_knowledge, source_domain, target_domain}` - Transfer knowledge","ref":"Object.MetaDSL.html#learn/3-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.learn/3","doc":"`{:ok, learning_result, updated_meta_dsl}` with learning updates","ref":"Object.MetaDSL.html#learn/3-returns"},{"type":"type","title":"Object.MetaDSL.modification_record/0","doc":"","ref":"Object.MetaDSL.html#t:modification_record/0"},{"type":"function","title":"Object.MetaDSL.new/1","doc":"Creates a new Meta-DSL instance with default constructs and parameters.","ref":"Object.MetaDSL.html#new/1"},{"type":"function","title":"Parameters - Object.MetaDSL.new/1","doc":"- `opts`: Optional configuration with `:constructs`, `:execution_context`, `:learning_parameters`","ref":"Object.MetaDSL.html#new/1-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.new/1","doc":"New Meta-DSL struct with initialized constructs","ref":"Object.MetaDSL.html#new/1-returns"},{"type":"function","title":"Examples - Object.MetaDSL.new/1","doc":"iex> Object.MetaDSL.new()\n    %Object.MetaDSL{constructs: [:define, :goal, :belief, :infer, ...], ...}","ref":"Object.MetaDSL.html#new/1-examples"},{"type":"function","title":"Object.MetaDSL.refine/3","doc":"REFINE construct: Meta-learning to improve learning efficiency.","ref":"Object.MetaDSL.html#refine/3"},{"type":"function","title":"Parameters - Object.MetaDSL.refine/3","doc":"- `meta_dsl` - Meta-DSL system struct\n- `object` - Object being refined\n- `refinement_target` - Target for refinement:\n  - `:exploration_strategy` - Improve exploration approach\n  - `:reward_function` - Refine reward function\n  - `:world_model` - Improve world model accuracy\n  - `:meta_parameters` - Adjust meta-learning parameters","ref":"Object.MetaDSL.html#refine/3-parameters"},{"type":"function","title":"Returns - Object.MetaDSL.refine/3","doc":"`{:ok, refinement_result, updated_meta_dsl}` with refinement updates","ref":"Object.MetaDSL.html#refine/3-returns"},{"type":"type","title":"Object.MetaDSL.t/0","doc":"","ref":"Object.MetaDSL.html#t:t/0"},{"type":"type","title":"Object.MetaDSL.trigger/0","doc":"","ref":"Object.MetaDSL.html#t:trigger/0"},{"type":"module","title":"Object.PerformanceMonitor","doc":"Real-time performance monitoring and metrics collection for the AAOS system.\nUses telemetry and ETS for high-performance metrics aggregation.","ref":"Object.PerformanceMonitor.html"},{"type":"function","title":"Object.PerformanceMonitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.PerformanceMonitor.html#child_spec/1"},{"type":"function","title":"Object.PerformanceMonitor.get_metrics/3","doc":"Gets metrics for an object and metric type within a time range.","ref":"Object.PerformanceMonitor.html#get_metrics/3"},{"type":"function","title":"Parameters - Object.PerformanceMonitor.get_metrics/3","doc":"- `object_id` - ID of the object\n- `metric_type` - Type of metric to retrieve\n- `time_range` - Time range in milliseconds (default: 5 minutes)","ref":"Object.PerformanceMonitor.html#get_metrics/3-parameters"},{"type":"function","title":"Returns - Object.PerformanceMonitor.get_metrics/3","doc":"List of metric entries with timestamps, values, and metadata","ref":"Object.PerformanceMonitor.html#get_metrics/3-returns"},{"type":"function","title":"Object.PerformanceMonitor.get_object_performance/1","doc":"Gets comprehensive performance analysis for a specific object.","ref":"Object.PerformanceMonitor.html#get_object_performance/1"},{"type":"function","title":"Parameters - Object.PerformanceMonitor.get_object_performance/1","doc":"- `object_id` - ID of the object to analyze","ref":"Object.PerformanceMonitor.html#get_object_performance/1-parameters"},{"type":"function","title":"Returns - Object.PerformanceMonitor.get_object_performance/1","doc":"Map with overall performance score, detailed metrics, and analysis","ref":"Object.PerformanceMonitor.html#get_object_performance/1-returns"},{"type":"function","title":"Object.PerformanceMonitor.get_performance_alerts/0","doc":"Gets all current performance alerts.","ref":"Object.PerformanceMonitor.html#get_performance_alerts/0"},{"type":"function","title":"Returns - Object.PerformanceMonitor.get_performance_alerts/0","doc":"List of active performance alerts with severity levels","ref":"Object.PerformanceMonitor.html#get_performance_alerts/0-returns"},{"type":"function","title":"Object.PerformanceMonitor.get_performance_report/1","doc":"Generates a comprehensive performance report.","ref":"Object.PerformanceMonitor.html#get_performance_report/1"},{"type":"function","title":"Parameters - Object.PerformanceMonitor.get_performance_report/1","doc":"- `time_range` - Time range for the report in milliseconds (default: 1 hour)","ref":"Object.PerformanceMonitor.html#get_performance_report/1-parameters"},{"type":"function","title":"Returns - Object.PerformanceMonitor.get_performance_report/1","doc":"Map with detailed performance analysis, summaries, and recommendations","ref":"Object.PerformanceMonitor.html#get_performance_report/1-returns"},{"type":"function","title":"Object.PerformanceMonitor.get_system_metrics/0","doc":"Gets aggregated system-wide performance metrics.","ref":"Object.PerformanceMonitor.html#get_system_metrics/0"},{"type":"function","title":"Returns - Object.PerformanceMonitor.get_system_metrics/0","doc":"Map with system-level performance statistics","ref":"Object.PerformanceMonitor.html#get_system_metrics/0-returns"},{"type":"function","title":"Object.PerformanceMonitor.record_metric/4","doc":"Records a performance metric for an object.\n\nHigh-performance metric recording using ETS tables. Automatically\nchecks for performance alerts based on configured thresholds.","ref":"Object.PerformanceMonitor.html#record_metric/4"},{"type":"function","title":"Parameters - Object.PerformanceMonitor.record_metric/4","doc":"- `object_id` - ID of the object\n- `metric_type` - Type of metric (atom)\n- `value` - Metric value (number)\n- `metadata` - Additional metadata (default: %{})","ref":"Object.PerformanceMonitor.html#record_metric/4-parameters"},{"type":"function","title":"Examples - Object.PerformanceMonitor.record_metric/4","doc":"iex> Object.PerformanceMonitor.record_metric(\"obj1\", :response_time, 50.0)\n    :ok","ref":"Object.PerformanceMonitor.html#record_metric/4-examples"},{"type":"function","title":"Object.PerformanceMonitor.set_performance_threshold/2","doc":"Sets performance thresholds for a metric type.","ref":"Object.PerformanceMonitor.html#set_performance_threshold/2"},{"type":"function","title":"Parameters - Object.PerformanceMonitor.set_performance_threshold/2","doc":"- `metric_type` - Type of metric to configure\n- `threshold_config` - Map with :warning, :critical, and :low_warning thresholds","ref":"Object.PerformanceMonitor.html#set_performance_threshold/2-parameters"},{"type":"function","title":"Examples - Object.PerformanceMonitor.set_performance_threshold/2","doc":"iex> Object.PerformanceMonitor.set_performance_threshold(:response_time, %{warning: 100, critical: 500})\n    :ok","ref":"Object.PerformanceMonitor.html#set_performance_threshold/2-examples"},{"type":"function","title":"Object.PerformanceMonitor.start_link/1","doc":"Starts the performance monitor GenServer.\n\nInitializes ETS tables for high-performance metrics storage,\nsets up telemetry handlers, and starts periodic aggregation tasks.","ref":"Object.PerformanceMonitor.html#start_link/1"},{"type":"function","title":"Returns - Object.PerformanceMonitor.start_link/1","doc":"- `{:ok, pid}` - Successfully started performance monitor","ref":"Object.PerformanceMonitor.html#start_link/1-returns"},{"type":"module","title":"Object.ResourceManager","doc":"Manages system resources including memory, CPU, network, and storage limits.\nProvides graceful degradation and emergency shutdown capabilities.","ref":"Object.ResourceManager.html"},{"type":"function","title":"Object.ResourceManager.allocate_resource/3","doc":"","ref":"Object.ResourceManager.html#allocate_resource/3"},{"type":"function","title":"Object.ResourceManager.check_resource_usage/1","doc":"","ref":"Object.ResourceManager.html#check_resource_usage/1"},{"type":"function","title":"Object.ResourceManager.deallocate_resource/3","doc":"","ref":"Object.ResourceManager.html#deallocate_resource/3"},{"type":"function","title":"Object.ResourceManager.get_memory_pressure/1","doc":"","ref":"Object.ResourceManager.html#get_memory_pressure/1"},{"type":"function","title":"Object.ResourceManager.new/1","doc":"","ref":"Object.ResourceManager.html#new/1"},{"type":"module","title":"Object.SchemaEvolutionManager","doc":"Manages schema evolution and self-modification across the object system.\nImplements distributed consensus for schema changes and evolution tracking.","ref":"Object.SchemaEvolutionManager.html"},{"type":"function","title":"Object.SchemaEvolutionManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.SchemaEvolutionManager.html#child_spec/1"},{"type":"function","title":"Object.SchemaEvolutionManager.get_evolution_history/1","doc":"Gets the evolution history for an object.","ref":"Object.SchemaEvolutionManager.html#get_evolution_history/1"},{"type":"function","title":"Parameters - Object.SchemaEvolutionManager.get_evolution_history/1","doc":"- `object_id` - ID of the object","ref":"Object.SchemaEvolutionManager.html#get_evolution_history/1-parameters"},{"type":"function","title":"Returns - Object.SchemaEvolutionManager.get_evolution_history/1","doc":"Evolution history from the schema registry","ref":"Object.SchemaEvolutionManager.html#get_evolution_history/1-returns"},{"type":"function","title":"Object.SchemaEvolutionManager.get_evolution_metrics/0","doc":"Gets evolution performance metrics.","ref":"Object.SchemaEvolutionManager.html#get_evolution_metrics/0"},{"type":"function","title":"Returns - Object.SchemaEvolutionManager.get_evolution_metrics/0","doc":"Map with evolution statistics and performance data","ref":"Object.SchemaEvolutionManager.html#get_evolution_metrics/0-returns"},{"type":"function","title":"Object.SchemaEvolutionManager.get_evolution_status/1","doc":"Gets the current status of an evolution proposal.","ref":"Object.SchemaEvolutionManager.html#get_evolution_status/1"},{"type":"function","title":"Parameters - Object.SchemaEvolutionManager.get_evolution_status/1","doc":"- `proposal_id` - ID of the evolution proposal","ref":"Object.SchemaEvolutionManager.html#get_evolution_status/1-parameters"},{"type":"function","title":"Returns - Object.SchemaEvolutionManager.get_evolution_status/1","doc":"- `{:ok, status}` - Current proposal status\n- `{:error, :proposal_not_found}` - Proposal not found","ref":"Object.SchemaEvolutionManager.html#get_evolution_status/1-returns"},{"type":"function","title":"Object.SchemaEvolutionManager.propose_evolution/2","doc":"Proposes a schema evolution for an object.\n\nCreates an evolution proposal and initiates the voting process\namong eligible objects.","ref":"Object.SchemaEvolutionManager.html#propose_evolution/2"},{"type":"function","title":"Parameters - Object.SchemaEvolutionManager.propose_evolution/2","doc":"- `object_id` - ID of the object to evolve\n- `evolution_spec` - Specification of the proposed evolution","ref":"Object.SchemaEvolutionManager.html#propose_evolution/2-parameters"},{"type":"function","title":"Returns - Object.SchemaEvolutionManager.propose_evolution/2","doc":"- `{:ok, proposal_id}` - Evolution proposal created successfully","ref":"Object.SchemaEvolutionManager.html#propose_evolution/2-returns"},{"type":"function","title":"Object.SchemaEvolutionManager.start_link/1","doc":"Starts the schema evolution manager GenServer.\n\nInitializes the evolution state and starts periodic evolution analysis.","ref":"Object.SchemaEvolutionManager.html#start_link/1"},{"type":"function","title":"Returns - Object.SchemaEvolutionManager.start_link/1","doc":"- `{:ok, pid}` - Successfully started evolution manager","ref":"Object.SchemaEvolutionManager.html#start_link/1-returns"},{"type":"function","title":"Object.SchemaEvolutionManager.trigger_system_evolution/2","doc":"Triggers a system-wide evolution.","ref":"Object.SchemaEvolutionManager.html#trigger_system_evolution/2"},{"type":"function","title":"Parameters - Object.SchemaEvolutionManager.trigger_system_evolution/2","doc":"- `evolution_type` - Type of system evolution\n- `parameters` - Evolution parameters","ref":"Object.SchemaEvolutionManager.html#trigger_system_evolution/2-parameters"},{"type":"function","title":"Returns - Object.SchemaEvolutionManager.trigger_system_evolution/2","doc":"- `{:ok, evolution_id}` - System evolution initiated","ref":"Object.SchemaEvolutionManager.html#trigger_system_evolution/2-returns"},{"type":"function","title":"Object.SchemaEvolutionManager.vote_on_evolution/3","doc":"Casts a vote on an evolution proposal.","ref":"Object.SchemaEvolutionManager.html#vote_on_evolution/3"},{"type":"function","title":"Parameters - Object.SchemaEvolutionManager.vote_on_evolution/3","doc":"- `proposal_id` - ID of the evolution proposal\n- `object_id` - ID of the voting object\n- `vote` - Vote (`:approve` or `:reject`)","ref":"Object.SchemaEvolutionManager.html#vote_on_evolution/3-parameters"},{"type":"function","title":"Returns - Object.SchemaEvolutionManager.vote_on_evolution/3","doc":"- `:ok` - Vote recorded successfully","ref":"Object.SchemaEvolutionManager.html#vote_on_evolution/3-returns"},{"type":"module","title":"Object.SchemaRegistry","doc":"ETS-based registry for tracking object schemas and evolution.\nProvides fast lookup and atomic updates for the object schema space.","ref":"Object.SchemaRegistry.html"},{"type":"function","title":"Object.SchemaRegistry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.SchemaRegistry.html#child_spec/1"},{"type":"function","title":"Object.SchemaRegistry.find_compatible_objects/2","doc":"Finds objects compatible with the specified object.","ref":"Object.SchemaRegistry.html#find_compatible_objects/2"},{"type":"function","title":"Parameters - Object.SchemaRegistry.find_compatible_objects/2","doc":"- `object_id` - ID of the reference object\n- `compatibility_threshold` - Minimum compatibility score (default: 0.7)","ref":"Object.SchemaRegistry.html#find_compatible_objects/2-parameters"},{"type":"function","title":"Returns - Object.SchemaRegistry.find_compatible_objects/2","doc":"- `{:ok, compatible_objects}` - List of compatible objects with scores\n- `{:error, reason}` - Object not found or other error","ref":"Object.SchemaRegistry.html#find_compatible_objects/2-returns"},{"type":"function","title":"Object.SchemaRegistry.get_all_schemas/0","doc":"Gets all object schemas as a map.","ref":"Object.SchemaRegistry.html#get_all_schemas/0"},{"type":"function","title":"Returns - Object.SchemaRegistry.get_all_schemas/0","doc":"Map of object IDs to schemas","ref":"Object.SchemaRegistry.html#get_all_schemas/0-returns"},{"type":"function","title":"Object.SchemaRegistry.get_object_schema/1","doc":"Gets the schema for a specific object.","ref":"Object.SchemaRegistry.html#get_object_schema/1"},{"type":"function","title":"Parameters - Object.SchemaRegistry.get_object_schema/1","doc":"- `object_id` - ID of the object","ref":"Object.SchemaRegistry.html#get_object_schema/1-parameters"},{"type":"function","title":"Returns - Object.SchemaRegistry.get_object_schema/1","doc":"- `{:ok, schema}` - Object schema found\n- `{:error, :not_found}` - Object not found","ref":"Object.SchemaRegistry.html#get_object_schema/1-returns"},{"type":"function","title":"Object.SchemaRegistry.get_schema_evolution_history/1","doc":"Gets the schema evolution history for an object.","ref":"Object.SchemaRegistry.html#get_schema_evolution_history/1"},{"type":"function","title":"Parameters - Object.SchemaRegistry.get_schema_evolution_history/1","doc":"- `object_id` - ID of the object","ref":"Object.SchemaRegistry.html#get_schema_evolution_history/1-parameters"},{"type":"function","title":"Returns - Object.SchemaRegistry.get_schema_evolution_history/1","doc":"- `{:ok, history}` - Evolution history list","ref":"Object.SchemaRegistry.html#get_schema_evolution_history/1-returns"},{"type":"function","title":"Object.SchemaRegistry.list_objects/0","doc":"Lists all registered objects and their schemas.","ref":"Object.SchemaRegistry.html#list_objects/0"},{"type":"function","title":"Returns - Object.SchemaRegistry.list_objects/0","doc":"List of tuples with object IDs and schemas","ref":"Object.SchemaRegistry.html#list_objects/0-returns"},{"type":"function","title":"Object.SchemaRegistry.list_objects_by_type/1","doc":"Lists objects filtered by subtype.","ref":"Object.SchemaRegistry.html#list_objects_by_type/1"},{"type":"function","title":"Parameters - Object.SchemaRegistry.list_objects_by_type/1","doc":"- `object_type` - Object subtype to filter by","ref":"Object.SchemaRegistry.html#list_objects_by_type/1-parameters"},{"type":"function","title":"Returns - Object.SchemaRegistry.list_objects_by_type/1","doc":"List of objects matching the specified type","ref":"Object.SchemaRegistry.html#list_objects_by_type/1-returns"},{"type":"function","title":"Object.SchemaRegistry.register_object/1","doc":"Registers an object's schema in the registry.","ref":"Object.SchemaRegistry.html#register_object/1"},{"type":"function","title":"Parameters - Object.SchemaRegistry.register_object/1","doc":"- `object` - Object struct to register","ref":"Object.SchemaRegistry.html#register_object/1-parameters"},{"type":"function","title":"Returns - Object.SchemaRegistry.register_object/1","doc":"- `:ok` - Object schema registered successfully","ref":"Object.SchemaRegistry.html#register_object/1-returns"},{"type":"function","title":"Object.SchemaRegistry.start_link/1","doc":"Starts the schema registry GenServer.\n\nCreates ETS tables for fast schema lookup and evolution tracking.","ref":"Object.SchemaRegistry.html#start_link/1"},{"type":"function","title":"Returns - Object.SchemaRegistry.start_link/1","doc":"- `{:ok, pid}` - Successfully started schema registry","ref":"Object.SchemaRegistry.html#start_link/1-returns"},{"type":"function","title":"Object.SchemaRegistry.unregister_object/1","doc":"Unregisters an object from the schema registry.","ref":"Object.SchemaRegistry.html#unregister_object/1"},{"type":"function","title":"Parameters - Object.SchemaRegistry.unregister_object/1","doc":"- `object_id` - ID of the object to unregister","ref":"Object.SchemaRegistry.html#unregister_object/1-parameters"},{"type":"function","title":"Returns - Object.SchemaRegistry.unregister_object/1","doc":"- `:ok` - Object unregistered successfully","ref":"Object.SchemaRegistry.html#unregister_object/1-returns"},{"type":"function","title":"Object.SchemaRegistry.update_object_schema/2","doc":"Updates an object's schema and records the evolution.","ref":"Object.SchemaRegistry.html#update_object_schema/2"},{"type":"function","title":"Parameters - Object.SchemaRegistry.update_object_schema/2","doc":"- `object_id` - ID of the object to update\n- `schema_updates` - Schema changes to apply","ref":"Object.SchemaRegistry.html#update_object_schema/2-parameters"},{"type":"function","title":"Returns - Object.SchemaRegistry.update_object_schema/2","doc":"- `:ok` - Schema updated successfully\n- `{:error, :object_not_found}` - Object not found","ref":"Object.SchemaRegistry.html#update_object_schema/2-returns"},{"type":"module","title":"Object.SelfOrganizationDemo","doc":"Demonstration of the complete self-organizing Object system.\n\nThis module showcases how Objects can:\n1. Discover each other and form networks\n2. Use LLM reasoning to coordinate activities\n3. Self-organize into optimal configurations\n4. Adapt to changing conditions\n5. Execute complex workflows through function calling\n\nRun this demo to see the full system in action.","ref":"Object.SelfOrganizationDemo.html"},{"type":"function","title":"Object.SelfOrganizationDemo.create_demo_objects/0","doc":"Creates a set of diverse Objects for demonstration.","ref":"Object.SelfOrganizationDemo.html#create_demo_objects/0"},{"type":"function","title":"Object.SelfOrganizationDemo.meta_learning_demo/0","doc":"Demonstrates meta-learning and adaptation.","ref":"Object.SelfOrganizationDemo.html#meta_learning_demo/0"},{"type":"function","title":"Object.SelfOrganizationDemo.run_full_demo/0","doc":"Runs a complete self-organization demonstration.","ref":"Object.SelfOrganizationDemo.html#run_full_demo/0"},{"type":"function","title":"Object.SelfOrganizationDemo.simple_interaction_demo/0","doc":"Runs a simple demonstration of object interaction.","ref":"Object.SelfOrganizationDemo.html#simple_interaction_demo/0"},{"type":"module","title":"Object.Server","doc":"GenServer implementation for individual AAOS objects.\n\nEach object runs as a separate process with its own state and mailbox,\nimplementing the Actor model with message-passing for true concurrency.","ref":"Object.Server.html"},{"type":"module","title":"Features - Object.Server","doc":"- Individual process per object for isolation and fault tolerance\n- AI-enhanced reasoning and learning capabilities\n- Periodic message processing and learning updates\n- Heartbeat system for dyad maintenance\n- Integration with schema registry and message routing\n- Support for meta-DSL constructs and method execution","ref":"Object.Server.html#module-features"},{"type":"module","title":"Process Lifecycle - Object.Server","doc":"1. **Initialization**: Register with schema registry, initialize AI reasoning\n2. **Active Phase**: Handle calls/casts, process messages, perform learning\n3. **Periodic Tasks**: Heartbeats, message processing, learning updates\n4. **Termination**: Cleanup and unregister from schema registry\n\nObjects communicate through structured messages routed via the message\nrouting system, with support for interaction dyads and social learning.","ref":"Object.Server.html#module-process-lifecycle"},{"type":"function","title":"Object.Server.apply_meta_dsl/3","doc":"Applies a meta-DSL construct to an object.\n\nExecutes meta-language constructs for self-reflection and modification,\nenabling objects to reason about and modify their own behavior, goals,\nand knowledge structures.","ref":"Object.Server.html#apply_meta_dsl/3"},{"type":"function","title":"Parameters - Object.Server.apply_meta_dsl/3","doc":"- `object_id` - Object identifier (must be registered)\n- `construct` - Meta-DSL construct to execute:\n  - `:define` - Define new attributes or capabilities\n  - `:goal` - Modify objective functions\n  - `:belief` - Update world model beliefs\n  - `:infer` - Perform inference on current knowledge\n  - `:decide` - Make decisions based on current state\n  - `:learn` - Process learning experiences\n  - `:refine` - Adjust learning parameters\n- `args` - Arguments specific to the construct","ref":"Object.Server.html#apply_meta_dsl/3-parameters"},{"type":"function","title":"Returns - Object.Server.apply_meta_dsl/3","doc":"Result map containing updates to be applied:\n- `:state_updates` - Updates to object state\n- `:world_model_updates` - Updates to world model\n- `:goal_update` - New goal function\n- `:meta_dsl_updates` - Updates to meta-DSL state","ref":"Object.Server.html#apply_meta_dsl/3-returns"},{"type":"function","title":"Meta-DSL Constructs - Object.Server.apply_meta_dsl/3","doc":"","ref":"Object.Server.html#apply_meta_dsl/3-meta-dsl-constructs"},{"type":"function","title":"DEFINE - Create New Capabilities - Object.Server.apply_meta_dsl/3","doc":"```elixir\nObject.Server.apply_meta_dsl(\"agent_1\", :define, {:confidence, 0.8})\n# => %{state_updates: %{confidence: 0.8}}\n```","ref":"Object.Server.html#apply_meta_dsl/3-define-create-new-capabilities"},{"type":"function","title":"INFER - Bayesian Reasoning - Object.Server.apply_meta_dsl/3","doc":"```elixir\ninference_data = %{observations: [%{light: :on}], priors: %{light: :off}}\nObject.Server.apply_meta_dsl(\"agent_1\", :infer, inference_data)\n# => %{world_model_updates: %{beliefs: %{light: :on}}}\n```","ref":"Object.Server.html#apply_meta_dsl/3-infer-bayesian-reasoning"},{"type":"function","title":"DECIDE - Goal-Directed Choice - Object.Server.apply_meta_dsl/3","doc":"```elixir\ncontext = %{options: [:explore, :exploit], current_reward: 0.5}\nObject.Server.apply_meta_dsl(\"agent_1\", :decide, context)\n# => %{state_updates: %{last_action: :explore}}\n```","ref":"Object.Server.html#apply_meta_dsl/3-decide-goal-directed-choice"},{"type":"function","title":"REFINE - Meta-Learning - Object.Server.apply_meta_dsl/3","doc":"```elixir\nrefinement = %{performance: 0.8, learning_rate: 0.01}\nObject.Server.apply_meta_dsl(\"agent_1\", :refine, refinement)\n# => %{meta_dsl_updates: %{learning_parameters: %{...}}}\n```","ref":"Object.Server.html#apply_meta_dsl/3-refine-meta-learning"},{"type":"function","title":"Examples - Object.Server.apply_meta_dsl/3","doc":"# Define new attribute\n    iex> result = Object.Server.apply_meta_dsl(\"agent_1\", :define, {:trust, 0.9})\n    iex> result.state_updates\n    %{trust: 0.9}\n    \n    # Update beliefs through inference\n    iex> inference = %{evidence: %{sensor_reading: 22.5}}\n    iex> Object.Server.apply_meta_dsl(\"agent_1\", :infer, inference)\n    %{world_model_updates: %{beliefs: %{temperature: 22.5}}}","ref":"Object.Server.html#apply_meta_dsl/3-examples"},{"type":"function","title":"Self-Modification - Object.Server.apply_meta_dsl/3","doc":"Meta-DSL enables powerful self-modification:\n- **Behavioral Adaptation**: Change response patterns\n- **Goal Evolution**: Modify objectives based on experience\n- **Knowledge Integration**: Update beliefs through reasoning\n- **Parameter Tuning**: Optimize learning parameters","ref":"Object.Server.html#apply_meta_dsl/3-self-modification"},{"type":"function","title":"Safety - Object.Server.apply_meta_dsl/3","doc":"- Construct validation prevents invalid modifications\n- Bounded update sizes prevent resource exhaustion\n- Rollback capability for failed modifications\n- Audit trail for all self-modifications","ref":"Object.Server.html#apply_meta_dsl/3-safety"},{"type":"function","title":"Object.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.Server.html#child_spec/1"},{"type":"function","title":"Object.Server.execute_method/3","doc":"Executes a method on an object.\n\nCalls the specified method with given arguments on the target object\nwith comprehensive error handling, resource protection, and performance\nmonitoring. Methods are executed within the object's process context.","ref":"Object.Server.html#execute_method/3"},{"type":"function","title":"Parameters - Object.Server.execute_method/3","doc":"- `object_id` - Object identifier (must be registered)\n- `method` - Method name (atom, must be in object's methods list)\n- `args` - Method arguments list (default: [])","ref":"Object.Server.html#execute_method/3-parameters"},{"type":"function","title":"Returns - Object.Server.execute_method/3","doc":"- `:ok` - Method executed successfully\n- `{:error, reason}` - Execution failed:\n  - `:object_not_found` - Object not registered\n  - `:method_not_available` - Method not in object's methods list\n  - `:timeout` - Method execution exceeded time limit\n  - `:resource_exhausted` - Insufficient system resources\n  - `:method_error` - Method execution failed internally","ref":"Object.Server.html#execute_method/3-returns"},{"type":"function","title":"Built-in Methods - Object.Server.execute_method/3","doc":"Common methods available on most objects:\n- `:update_state` - Update internal state\n- `:interact` - Process interaction with environment\n- `:learn` - Apply learning from experience\n- `:evaluate_goal` - Compute goal satisfaction\n\nSubtype-specific methods:\n- AI Agents: `:reason`, `:plan`, `:adapt`\n- Sensors: `:sense`, `:calibrate`, `:filter_noise`\n- Actuators: `:execute_action`, `:queue_action`\n- Coordinators: `:coordinate`, `:allocate_resources`","ref":"Object.Server.html#execute_method/3-built-in-methods"},{"type":"function","title":"Examples - Object.Server.execute_method/3","doc":"# Execute learning method\n    iex> experience = %{reward: 1.0, action: :explore, state: %{x: 1}}\n    iex> Object.Server.execute_method(\"agent_1\", :learn, [experience])\n    :ok\n    \n    # Execute sensor calibration\n    iex> Object.Server.execute_method(\"temp_sensor_1\", :calibrate, [])\n    :ok\n    \n    # Error: Method not available\n    iex> Object.Server.execute_method(\"sensor_1\", :fly, [])\n    {:error, :method_not_available}","ref":"Object.Server.html#execute_method/3-examples"},{"type":"function","title":"Resource Protection - Object.Server.execute_method/3","doc":"- Resource permission checked before execution\n- Circuit breakers prevent system overload\n- Execution timeouts prevent runaway methods\n- Performance monitoring tracks method efficiency","ref":"Object.Server.html#execute_method/3-resource-protection"},{"type":"function","title":"Performance - Object.Server.execute_method/3","doc":"- Method latency: ~1-10ms depending on complexity\n- Timeout: 30 seconds default\n- Retry logic: 3 attempts with exponential backoff\n- Monitoring: Execution time and success rate tracked","ref":"Object.Server.html#execute_method/3-performance"},{"type":"function","title":"Object.Server.form_dyad/3","doc":"Forms an interaction dyad with another object.\n\nCreates a bidirectional communication relationship between two objects\nwith the specified compatibility score. Dyads enable enhanced communication,\ncoordination, and social learning between object pairs.","ref":"Object.Server.html#form_dyad/3"},{"type":"function","title":"Parameters - Object.Server.form_dyad/3","doc":"- `object_id` - First object ID (must be registered)\n- `other_object_id` - Second object ID (must be registered)\n- `compatibility_score` - Initial compatibility assessment (0.0-1.0, default 0.5)","ref":"Object.Server.html#form_dyad/3-parameters"},{"type":"function","title":"Returns - Object.Server.form_dyad/3","doc":"- `:ok` - Dyad formed successfully\n- `{:error, reason}` - Formation failed:\n  - `:object_not_found` - One or both objects not registered\n  - `:self_dyad_not_allowed` - Cannot form dyad with self\n  - `:dyad_already_exists` - Dyad already established\n  - `:compatibility_too_low` - Compatibility below minimum threshold","ref":"Object.Server.html#form_dyad/3-returns"},{"type":"function","title":"Compatibility Guidelines - Object.Server.form_dyad/3","doc":"- `0.0-0.3` - Low compatibility, limited interaction benefit\n- `0.3-0.7` - Moderate compatibility, good for specific tasks\n- `0.7-1.0` - High compatibility, excellent collaboration potential","ref":"Object.Server.html#form_dyad/3-compatibility-guidelines"},{"type":"function","title":"Examples - Object.Server.form_dyad/3","doc":"# Form high-compatibility dyad\n    iex> Object.Server.form_dyad(\"ai_agent_1\", \"ai_agent_2\", 0.8)\n    :ok\n    \n    # Form sensor-coordinator dyad\n    iex> Object.Server.form_dyad(\"temp_sensor_1\", \"coordinator_1\", 0.6)\n    :ok\n    \n    # Error: Self-dyad not allowed\n    iex> Object.Server.form_dyad(\"agent_1\", \"agent_1\")\n    {:error, :self_dyad_not_allowed}","ref":"Object.Server.html#form_dyad/3-examples"},{"type":"function","title":"Dyad Benefits - Object.Server.form_dyad/3","doc":"- **Priority Messaging**: Dyad partners get message priority\n- **Social Learning**: Shared experiences and knowledge transfer\n- **Coordination**: Simplified cooperation protocols\n- **Trust Building**: Reputation and reliability tracking\n- **Performance**: Reduced coordination overhead","ref":"Object.Server.html#form_dyad/3-dyad-benefits"},{"type":"function","title":"Lifecycle Management - Object.Server.form_dyad/3","doc":"Dyads evolve over time:\n1. **Formation**: Initial creation with compatibility score\n2. **Interaction**: Regular communication and coordination\n3. **Adaptation**: Compatibility adjustment based on outcomes\n4. **Maintenance**: Heartbeat and health monitoring\n5. **Dissolution**: Automatic or manual termination","ref":"Object.Server.html#form_dyad/3-lifecycle-management"},{"type":"function","title":"Performance - Object.Server.form_dyad/3","doc":"- Formation time: ~1-3ms\n- Memory overhead: ~200 bytes per dyad\n- Maximum dyads per object: 50 (configurable)\n- Automatic cleanup of inactive dyads","ref":"Object.Server.html#form_dyad/3-performance"},{"type":"function","title":"Object.Server.get_state/1","doc":"Gets the current state of an object.\n\nRetrieves the complete current state of the specified object.\nThis is a synchronous operation that returns the state at the\ntime of the call.","ref":"Object.Server.html#get_state/1"},{"type":"function","title":"Parameters - Object.Server.get_state/1","doc":"- `object_id` - Object identifier (must be registered)","ref":"Object.Server.html#get_state/1-parameters"},{"type":"function","title":"Returns - Object.Server.get_state/1","doc":"- Object's current state map\n- May raise if object not found or unresponsive","ref":"Object.Server.html#get_state/1-returns"},{"type":"function","title":"Examples - Object.Server.get_state/1","doc":"# Get state of a sensor object\n    iex> state = Object.Server.get_state(\"temp_sensor_1\")\n    iex> state.temperature\n    22.5\n    \n    # Check AI agent state\n    iex> Object.Server.get_state(\"ai_agent_alpha\")\n    %{intelligence_level: :advanced, current_task: :learning}","ref":"Object.Server.html#get_state/1-examples"},{"type":"function","title":"Error Handling - Object.Server.get_state/1","doc":"- Raises `:noproc` if object process not found\n- Raises `:timeout` if object unresponsive (default: 5 seconds)\n- State is read-only snapshot at call time","ref":"Object.Server.html#get_state/1-error-handling"},{"type":"function","title":"Performance - Object.Server.get_state/1","doc":"- Operation time: ~0.1-1ms for local objects\n- No side effects on object state\n- Thread-safe read operation","ref":"Object.Server.html#get_state/1-performance"},{"type":"function","title":"Object.Server.get_stats/1","doc":"Gets communication statistics for an object.\n\nReturns comprehensive metrics about the object's messaging patterns,\ninteraction history, and communication performance. Useful for monitoring,\ndebugging, and performance optimization.","ref":"Object.Server.html#get_stats/1"},{"type":"function","title":"Parameters - Object.Server.get_stats/1","doc":"- `object_id` - Object identifier (must be registered)","ref":"Object.Server.html#get_stats/1-parameters"},{"type":"function","title":"Returns - Object.Server.get_stats/1","doc":"Statistics map containing:\n- `:total_messages_sent` - Number of messages sent by this object\n- `:total_messages_received` - Number of messages received\n- `:pending_inbox` - Current unprocessed inbox messages\n- `:pending_outbox` - Current unsent outbox messages\n- `:active_dyads` - Number of currently active interaction dyads\n- `:total_dyads` - Total dyads ever formed (including inactive)\n- `:history_size` - Current message history size\n- `:uptime` - Object uptime in seconds since creation\n- `:message_rate` - Messages per second (sent + received)\n- `:dyad_efficiency` - Ratio of active to total dyads","ref":"Object.Server.html#get_stats/1-returns"},{"type":"function","title":"Examples - Object.Server.get_stats/1","doc":"# Get basic communication stats\n    iex> stats = Object.Server.get_stats(\"agent_1\")\n    iex> stats.total_messages_sent\n    42\n    iex> stats.active_dyads\n    3\n    \n    # Calculate performance metrics\n    iex> stats = Object.Server.get_stats(\"coordinator_1\")\n    iex> stats.message_rate\n    2.5  # messages per second\n    iex> stats.dyad_efficiency\n    0.75  # 75% of dyads are active","ref":"Object.Server.html#get_stats/1-examples"},{"type":"function","title":"Performance Indicators - Object.Server.get_stats/1","doc":"Key metrics for monitoring:","ref":"Object.Server.html#get_stats/1-performance-indicators"},{"type":"function","title":"Communication Volume - Object.Server.get_stats/1","doc":"- **High volume** (>100 msg/min): Active coordinator or hub object\n- **Medium volume** (10-100 msg/min): Regular operational object\n- **Low volume** (<10 msg/min): Peripheral or specialized object","ref":"Object.Server.html#get_stats/1-communication-volume"},{"type":"function","title":"Dyad Health - Object.Server.get_stats/1","doc":"- **High efficiency** (>0.8): Well-connected, active collaboration\n- **Medium efficiency** (0.5-0.8): Selective partnerships\n- **Low efficiency** (<0.5): Poor partner selection or inactive","ref":"Object.Server.html#get_stats/1-dyad-health"},{"type":"function","title":"Processing Performance - Object.Server.get_stats/1","doc":"- **Low pending**: Efficient message processing\n- **High pending**: Processing bottleneck or overload","ref":"Object.Server.html#get_stats/1-processing-performance"},{"type":"function","title":"Monitoring Uses - Object.Server.get_stats/1","doc":"- **Performance Tuning**: Identify communication bottlenecks\n- **Health Monitoring**: Detect failed or overloaded objects\n- **Social Analysis**: Understand interaction patterns\n- **Debugging**: Trace message flow and delivery issues\n- **Capacity Planning**: Plan for system scaling","ref":"Object.Server.html#get_stats/1-monitoring-uses"},{"type":"function","title":"Historical Trends - Object.Server.get_stats/1","doc":"Statistics can be sampled over time to identify:\n- Communication pattern changes\n- Performance degradation\n- Social network evolution\n- Seasonal or cyclical behaviors","ref":"Object.Server.html#get_stats/1-historical-trends"},{"type":"function","title":"Object.Server.send_message/5","doc":"Sends a message from one object to another.\n\nRoutes a message through the message routing system with specified\ntype, content, and delivery options. Messages are processed asynchronously\nwith comprehensive error handling and delivery guarantees.","ref":"Object.Server.html#send_message/5"},{"type":"function","title":"Parameters - Object.Server.send_message/5","doc":"- `object_id` - Sender object ID (must be registered)\n- `to_object_id` - Recipient object ID\n- `message_type` - Type of message for routing and handling:\n  - `:state_update` - State change notification\n  - `:coordination` - Coordination request/response\n  - `:learning_signal` - Learning data or feedback\n  - `:heartbeat` - Connection health check\n  - `:negotiation` - Multi-step negotiation protocol\n- `content` - Message content (any serializable term)\n- `opts` - Delivery options:\n  - `:priority` - `:low | :medium | :high | :critical` (default: `:medium`)\n  - `:ttl` - Time-to-live in seconds (default: 3600)\n  - `:requires_ack` - Delivery confirmation required (default: false)\n  - `:retry_count` - Maximum retry attempts (default: 3)","ref":"Object.Server.html#send_message/5-parameters"},{"type":"function","title":"Returns - Object.Server.send_message/5","doc":"- `:ok` - Message sent successfully\n- `{:error, reason}` - Send failure:\n  - `:object_not_found` - Sender object not registered\n  - `:throttled` - System under load, message delayed\n  - `:invalid_recipient` - Recipient object invalid\n  - `:message_too_large` - Content exceeds size limits","ref":"Object.Server.html#send_message/5-returns"},{"type":"function","title":"Examples - Object.Server.send_message/5","doc":"# Send coordination request\n    iex> Object.Server.send_message(\n    ...>   \"agent_1\", \"coordinator_1\", :coordination,\n    ...>   %{action: :join_coalition, priority: :high},\n    ...>   [priority: :high, requires_ack: true]\n    ...> )\n    :ok\n    \n    # Send learning signal with TTL\n    iex> Object.Server.send_message(\n    ...>   \"learner_1\", \"teacher_1\", :learning_signal,\n    ...>   %{reward: 1.0, experience: %{action: :explore}},\n    ...>   [ttl: 300, priority: :medium]\n    ...> )\n    :ok\n    \n    # Error: Object not found\n    iex> Object.Server.send_message(\n    ...>   \"nonexistent\", \"agent_2\", :hello, %{}\n    ...> )\n    {:error, :object_not_found}","ref":"Object.Server.html#send_message/5-examples"},{"type":"function","title":"Delivery Guarantees - Object.Server.send_message/5","doc":"- **Best Effort**: Default delivery without acknowledgment\n- **At Least Once**: With `requires_ack: true`\n- **Circuit Breaker**: Prevents cascade failures\n- **Dead Letter Queue**: Failed messages queued for retry","ref":"Object.Server.html#send_message/5-delivery-guarantees"},{"type":"function","title":"Performance - Object.Server.send_message/5","doc":"- Message latency: ~1-5ms for local objects\n- Throughput: ~1000 messages/sec per object\n- Backpressure: Automatic throttling under load\n- Resource usage: ~100 bytes per message overhead","ref":"Object.Server.html#send_message/5-performance"},{"type":"function","title":"Object.Server.start_link/1","doc":"Starts a new object server process.\n\nCreates a new GenServer process for the object and registers it\nin the object registry for lookup by ID. The server handles all\nobject lifecycle management including initialization, message\nprocessing, and graceful shutdown.","ref":"Object.Server.html#start_link/1"},{"type":"function","title":"Parameters - Object.Server.start_link/1","doc":"- `object_spec` - Object struct containing:\n  - `:id` - Unique object identifier\n  - `:state` - Initial object state\n  - `:methods` - Available methods\n  - `:goal` - Objective function\n  - Additional Object.t() fields","ref":"Object.Server.html#start_link/1-parameters"},{"type":"function","title":"Returns - Object.Server.start_link/1","doc":"- `{:ok, pid}` - Success with process PID\n- `{:error, reason}` - Startup failure reasons:\n  - `:registration_failed` - Object ID already in use\n  - `:init_error` - Initialization failure\n  - `:resource_exhausted` - System resource limits","ref":"Object.Server.html#start_link/1-returns"},{"type":"function","title":"Process Lifecycle - Object.Server.start_link/1","doc":"1. **Registration**: Register in schema registry and object registry\n2. **Initialization**: Set up AI reasoning, health monitoring\n3. **Scheduling**: Start periodic tasks (heartbeat, message processing)\n4. **Ready**: Process incoming calls and casts","ref":"Object.Server.html#start_link/1-process-lifecycle"},{"type":"function","title":"Examples - Object.Server.start_link/1","doc":"# Start a basic object server\n    iex> object = Object.new(id: \"test_obj\", state: %{value: 1})\n    iex> {:ok, pid} = Object.Server.start_link(object)\n    iex> Process.alive?(pid)\n    true\n    \n    # Start with registry lookup\n    iex> {:ok, _pid} = Object.Server.start_link(object)\n    iex> [{found_pid, _}] = Registry.lookup(Object.Registry, \"test_obj\")\n    iex> Process.alive?(found_pid)\n    true","ref":"Object.Server.html#start_link/1-examples"},{"type":"function","title":"Error Handling - Object.Server.start_link/1","doc":"- Duplicate object IDs are rejected\n- Initialization failures are logged and reported\n- Resource exhaustion triggers graceful degradation\n- Process crashes are handled by the supervisor","ref":"Object.Server.html#start_link/1-error-handling"},{"type":"function","title":"Performance - Object.Server.start_link/1","doc":"- Startup time: ~5-10ms including registration\n- Memory usage: ~2KB base + object state size\n- Registry lookup: O(1) by object ID","ref":"Object.Server.html#start_link/1-performance"},{"type":"function","title":"Object.Server.update_state/2","doc":"Updates an object's internal state.\n\nMerges the provided updates into the object's current state with\nvalidation and error handling. The update is atomic and will either\ncompletely succeed or leave the state unchanged.","ref":"Object.Server.html#update_state/2"},{"type":"function","title":"Parameters - Object.Server.update_state/2","doc":"- `object_id` - Object identifier (must be registered)\n- `state_updates` - Map of state updates to merge with current state","ref":"Object.Server.html#update_state/2-parameters"},{"type":"function","title":"Returns - Object.Server.update_state/2","doc":"- `:ok` - Update successful\n- `{:error, reason}` - Update failed:\n  - `:object_not_found` - Object not registered\n  - `:invalid_state` - State update validation failed\n  - `:state_too_large` - Update would exceed size limits\n  - `:forbidden_keys` - Update contains forbidden keys","ref":"Object.Server.html#update_state/2-returns"},{"type":"function","title":"Validation Rules - Object.Server.update_state/2","doc":"- State updates must be maps\n- Combined state cannot exceed 100 entries\n- Cannot update system keys (:__internal__, :__system__, :__meta__)\n- Numeric values must be finite numbers","ref":"Object.Server.html#update_state/2-validation-rules"},{"type":"function","title":"Examples - Object.Server.update_state/2","doc":"# Update sensor readings\n    iex> Object.Server.update_state(\"temp_sensor_1\", %{\n    ...>   temperature: 23.5,\n    ...>   humidity: 68,\n    ...>   last_reading: DateTime.utc_now()\n    ...> })\n    :ok\n    \n    # Incremental energy update\n    iex> Object.Server.update_state(\"robot_1\", %{energy: 95})\n    :ok\n    \n    # Error: Forbidden key\n    iex> Object.Server.update_state(\"agent_1\", %{__system__: \"hack\"})\n    {:error, :forbidden_keys}","ref":"Object.Server.html#update_state/2-examples"},{"type":"function","title":"Atomicity - Object.Server.update_state/2","doc":"- Updates are applied atomically (all or nothing)\n- Concurrent updates are serialized\n- No partial state corruption possible\n- Original state preserved on validation failure","ref":"Object.Server.html#update_state/2-atomicity"},{"type":"function","title":"Performance - Object.Server.update_state/2","doc":"- Update time: ~0.5-2ms depending on state size\n- Memory overhead: Temporary copy during validation\n- Throughput: ~500 updates/sec per object","ref":"Object.Server.html#update_state/2-performance"},{"type":"module","title":"Object.Subtypes","doc":"Object subtypes implementation based on AAOS specification.\nDefines specialized object types: AI Agents, Human Clients, Sensor Objects,\nActuator Objects, and Coordinator Objects.","ref":"Object.Subtypes.html"},{"type":"module","title":"Object.Subtypes.AIAgent","doc":"Autonomous AI Agent with advanced learning and reasoning capabilities.\nImplements full OORL capabilities including meta-learning and self-modification.","ref":"Object.Subtypes.AIAgent.html"},{"type":"function","title":"Object.Subtypes.AIAgent.execute_advanced_reasoning/2","doc":"Executes advanced multi-step reasoning process for complex problems.\n\nPerforms systematic problem-solving using analyze, plan, execute, evaluate,\nand adapt phases. Updates performance metrics based on reasoning outcomes.","ref":"Object.Subtypes.AIAgent.html#execute_advanced_reasoning/2"},{"type":"function","title":"Parameters - Object.Subtypes.AIAgent.execute_advanced_reasoning/2","doc":"- `agent` - AI Agent struct\n- `problem_context` - Context information about the problem to solve","ref":"Object.Subtypes.AIAgent.html#execute_advanced_reasoning/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.AIAgent.execute_advanced_reasoning/2","doc":"Tuple with updated agent and list of reasoning step results","ref":"Object.Subtypes.AIAgent.html#execute_advanced_reasoning/2-returns"},{"type":"function","title":"Examples - Object.Subtypes.AIAgent.execute_advanced_reasoning/2","doc":"iex> AIAgent.execute_advanced_reasoning(agent, %{type: :optimization})\n    {updated_agent, [{:analyze, :analysis_complete}, ...]}","ref":"Object.Subtypes.AIAgent.html#execute_advanced_reasoning/2-examples"},{"type":"function","title":"Object.Subtypes.AIAgent.new/1","doc":"Creates a new AI Agent with advanced learning and reasoning capabilities.","ref":"Object.Subtypes.AIAgent.html#new/1"},{"type":"function","title":"Parameters - Object.Subtypes.AIAgent.new/1","doc":"- `opts` - Configuration options:\n  - `:id` - Agent identifier (generates random if not provided)\n  - `:intelligence_level` - Level of intelligence (`:basic`, `:intermediate`, `:advanced`)\n  - `:specialization` - Agent specialization (`:general`, `:problem_solving`, etc.)\n  - `:autonomy_level` - Degree of autonomy (`:low`, `:medium`, `:high`)\n  - `:goal` - Custom goal function","ref":"Object.Subtypes.AIAgent.html#new/1-parameters"},{"type":"function","title":"Returns - Object.Subtypes.AIAgent.new/1","doc":"AIAgent struct with initialized capabilities and performance metrics","ref":"Object.Subtypes.AIAgent.html#new/1-returns"},{"type":"function","title":"Examples - Object.Subtypes.AIAgent.new/1","doc":"iex> Object.Subtypes.AIAgent.new(intelligence_level: :advanced)\n    %Object.Subtypes.AIAgent{intelligence_level: :advanced, ...}","ref":"Object.Subtypes.AIAgent.html#new/1-examples"},{"type":"function","title":"Object.Subtypes.AIAgent.self_modify/2","doc":"Performs self-modification using meta-DSL constructs.\n\nEnables the AI agent to modify its own behavior and capabilities based\non performance feedback and adaptation requirements.","ref":"Object.Subtypes.AIAgent.html#self_modify/2"},{"type":"function","title":"Parameters - Object.Subtypes.AIAgent.self_modify/2","doc":"- `agent` - AI Agent struct\n- `modification_context` - Context for the modification including performance feedback","ref":"Object.Subtypes.AIAgent.html#self_modify/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.AIAgent.self_modify/2","doc":"Updated AI Agent with modified capabilities and improved performance metrics","ref":"Object.Subtypes.AIAgent.html#self_modify/2-returns"},{"type":"module","title":"Object.Subtypes.ActuatorObject","doc":"Object for environmental manipulation and action execution.","ref":"Object.Subtypes.ActuatorObject.html"},{"type":"function","title":"Object.Subtypes.ActuatorObject.execute_action/2","doc":"Executes a physical action and updates actuator state.\n\nPerforms the specified action, calculates energy consumption and wear,\nthen updates the actuator's internal state and metrics.","ref":"Object.Subtypes.ActuatorObject.html#execute_action/2"},{"type":"function","title":"Parameters - Object.Subtypes.ActuatorObject.execute_action/2","doc":"- `actuator` - ActuatorObject struct\n- `action_command` - Command specifying the action to execute","ref":"Object.Subtypes.ActuatorObject.html#execute_action/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.ActuatorObject.execute_action/2","doc":"Tuple with execution result and updated actuator with wear/energy updates","ref":"Object.Subtypes.ActuatorObject.html#execute_action/2-returns"},{"type":"function","title":"Object.Subtypes.ActuatorObject.new/1","doc":"Creates a new Actuator Object for environmental manipulation.","ref":"Object.Subtypes.ActuatorObject.html#new/1"},{"type":"function","title":"Parameters - Object.Subtypes.ActuatorObject.new/1","doc":"- `opts` - Configuration options:\n  - `:id` - Actuator identifier\n  - `:actuator_type` - Type of actuator (`:motor`, `:hydraulic`, `:pneumatic`)\n  - `:action_range` - Valid action range as tuple\n  - `:precision` - Action precision (0.0-1.0)\n  - `:response_time` - Response time in seconds","ref":"Object.Subtypes.ActuatorObject.html#new/1-parameters"},{"type":"function","title":"Returns - Object.Subtypes.ActuatorObject.new/1","doc":"ActuatorObject struct configured for action execution and queuing","ref":"Object.Subtypes.ActuatorObject.html#new/1-returns"},{"type":"function","title":"Object.Subtypes.ActuatorObject.queue_action/3","doc":"Queues an action for later execution with priority ordering.\n\nAdds an action to the execution queue, sorted by priority and timestamp.\nHigher priority actions are executed first.","ref":"Object.Subtypes.ActuatorObject.html#queue_action/3"},{"type":"function","title":"Parameters - Object.Subtypes.ActuatorObject.queue_action/3","doc":"- `actuator` - ActuatorObject struct\n- `action_command` - Command to queue for execution\n- `priority` - Priority level (`:critical`, `:high`, `:normal`, `:low`)","ref":"Object.Subtypes.ActuatorObject.html#queue_action/3-parameters"},{"type":"function","title":"Returns - Object.Subtypes.ActuatorObject.queue_action/3","doc":"Updated ActuatorObject with action added to sorted queue","ref":"Object.Subtypes.ActuatorObject.html#queue_action/3-returns"},{"type":"module","title":"Object.Subtypes.CoordinatorObject","doc":"Coordination and orchestration object for multi-agent systems.","ref":"Object.Subtypes.CoordinatorObject.html"},{"type":"function","title":"Object.Subtypes.CoordinatorObject.add_managed_object/2","doc":"Adds an object to the coordinator's management scope.","ref":"Object.Subtypes.CoordinatorObject.html#add_managed_object/2"},{"type":"function","title":"Parameters - Object.Subtypes.CoordinatorObject.add_managed_object/2","doc":"- `coordinator` - CoordinatorObject struct\n- `object_id` - ID of the object to manage","ref":"Object.Subtypes.CoordinatorObject.html#add_managed_object/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.CoordinatorObject.add_managed_object/2","doc":"Updated CoordinatorObject with the object added to managed list","ref":"Object.Subtypes.CoordinatorObject.html#add_managed_object/2-returns"},{"type":"function","title":"Object.Subtypes.CoordinatorObject.coordinate_objects/2","doc":"Coordinates managed objects to complete a task.\n\nGenerates and executes a coordination plan for the specified task,\nthen records the coordination history and results.","ref":"Object.Subtypes.CoordinatorObject.html#coordinate_objects/2"},{"type":"function","title":"Parameters - Object.Subtypes.CoordinatorObject.coordinate_objects/2","doc":"- `coordinator` - CoordinatorObject struct\n- `coordination_task` - Task specification for coordination","ref":"Object.Subtypes.CoordinatorObject.html#coordinate_objects/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.CoordinatorObject.coordinate_objects/2","doc":"Updated CoordinatorObject with coordination history updated","ref":"Object.Subtypes.CoordinatorObject.html#coordinate_objects/2-returns"},{"type":"function","title":"Object.Subtypes.CoordinatorObject.new/1","doc":"Creates a new Coordinator Object for multi-agent orchestration.","ref":"Object.Subtypes.CoordinatorObject.html#new/1"},{"type":"function","title":"Parameters - Object.Subtypes.CoordinatorObject.new/1","doc":"- `opts` - Configuration options:\n  - `:id` - Coordinator identifier\n  - `:strategy` - Coordination strategy (`:consensus`, `:delegation`, `:hierarchy`)\n  - `:goal` - Custom goal function for system optimization","ref":"Object.Subtypes.CoordinatorObject.html#new/1-parameters"},{"type":"function","title":"Returns - Object.Subtypes.CoordinatorObject.new/1","doc":"CoordinatorObject struct configured for multi-agent coordination","ref":"Object.Subtypes.CoordinatorObject.html#new/1-returns"},{"type":"function","title":"Object.Subtypes.CoordinatorObject.resolve_conflict/2","doc":"Resolves conflicts between managed objects.\n\nUses the configured conflict resolution strategy to resolve disputes\nbetween objects under management.","ref":"Object.Subtypes.CoordinatorObject.html#resolve_conflict/2"},{"type":"function","title":"Parameters - Object.Subtypes.CoordinatorObject.resolve_conflict/2","doc":"- `coordinator` - CoordinatorObject struct\n- `conflict_context` - Information about the conflict to resolve","ref":"Object.Subtypes.CoordinatorObject.html#resolve_conflict/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.CoordinatorObject.resolve_conflict/2","doc":"Tuple with resolution result and updated coordinator","ref":"Object.Subtypes.CoordinatorObject.html#resolve_conflict/2-returns"},{"type":"module","title":"Object.Subtypes.HumanClient","doc":"Human client interface with natural language processing and preference learning.\nHandles human-AI interaction patterns and learns user preferences.","ref":"Object.Subtypes.HumanClient.html"},{"type":"function","title":"Object.Subtypes.HumanClient.new/1","doc":"Creates a new Human Client interface for human-AI interaction.","ref":"Object.Subtypes.HumanClient.html#new/1"},{"type":"function","title":"Parameters - Object.Subtypes.HumanClient.new/1","doc":"- `opts` - Configuration options:\n  - `:id` - Client identifier\n  - `:user_profile` - User profile information\n  - `:communication_style` - Preferred communication style\n  - `:expertise_domain` - Domain of expertise\n  - `:goal` - Custom goal function for satisfaction","ref":"Object.Subtypes.HumanClient.html#new/1-parameters"},{"type":"function","title":"Returns - Object.Subtypes.HumanClient.new/1","doc":"HumanClient struct initialized with preference learning capabilities","ref":"Object.Subtypes.HumanClient.html#new/1-returns"},{"type":"function","title":"Object.Subtypes.HumanClient.process_natural_language/2","doc":"Processes natural language input using NLP pipeline.\n\nAnalyzes input text for intent, extracts preferences, and performs\nemotional analysis. Updates the client's interaction history and\npreference model based on the processed input.","ref":"Object.Subtypes.HumanClient.html#process_natural_language/2"},{"type":"function","title":"Parameters - Object.Subtypes.HumanClient.process_natural_language/2","doc":"- `client` - HumanClient struct\n- `input_text` - Natural language input to process","ref":"Object.Subtypes.HumanClient.html#process_natural_language/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.HumanClient.process_natural_language/2","doc":"Tuple with parsed intent and updated client with learned preferences","ref":"Object.Subtypes.HumanClient.html#process_natural_language/2-returns"},{"type":"function","title":"Object.Subtypes.HumanClient.provide_feedback/4","doc":"Provides feedback on a service and updates preference model.\n\nRecords feedback with rating and comments, then updates the preference\nmodel to learn from the user's feedback patterns.","ref":"Object.Subtypes.HumanClient.html#provide_feedback/4"},{"type":"function","title":"Parameters - Object.Subtypes.HumanClient.provide_feedback/4","doc":"- `client` - HumanClient struct\n- `service_id` - Identifier of the service being rated\n- `rating` - Numerical rating (typically 1-5)\n- `comments` - Optional textual feedback (default: \"\")","ref":"Object.Subtypes.HumanClient.html#provide_feedback/4-parameters"},{"type":"function","title":"Returns - Object.Subtypes.HumanClient.provide_feedback/4","doc":"Updated HumanClient with feedback recorded and preferences updated","ref":"Object.Subtypes.HumanClient.html#provide_feedback/4-returns"},{"type":"function","title":"Object.Subtypes.HumanClient.update_trust/2","doc":"Updates the client's trust level based on interaction outcomes.\n\nAdjusts trust level positively for positive outcomes and negatively\nfor negative outcomes, maintaining bounds between 0.0 and 1.0.","ref":"Object.Subtypes.HumanClient.html#update_trust/2"},{"type":"function","title":"Parameters - Object.Subtypes.HumanClient.update_trust/2","doc":"- `client` - HumanClient struct\n- `interaction_outcome` - Outcome (`:positive`, `:neutral`, `:negative`)","ref":"Object.Subtypes.HumanClient.html#update_trust/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.HumanClient.update_trust/2","doc":"Updated HumanClient with adjusted trust level","ref":"Object.Subtypes.HumanClient.html#update_trust/2-returns"},{"type":"module","title":"Object.Subtypes.SensorObject","doc":"Specialized object for environmental sensing and data collection.","ref":"Object.Subtypes.SensorObject.html"},{"type":"function","title":"Object.Subtypes.SensorObject.calibrate/2","doc":"Calibrates the sensor against reference values.\n\nCompares sensor readings with known reference values to calculate\ncalibration error and adjust accuracy. Updates calibration status.","ref":"Object.Subtypes.SensorObject.html#calibrate/2"},{"type":"function","title":"Parameters - Object.Subtypes.SensorObject.calibrate/2","doc":"- `sensor` - SensorObject struct\n- `reference_values` - Known reference values for calibration","ref":"Object.Subtypes.SensorObject.html#calibrate/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.SensorObject.calibrate/2","doc":"Updated SensorObject with adjusted accuracy and calibration status","ref":"Object.Subtypes.SensorObject.html#calibrate/2-returns"},{"type":"function","title":"Object.Subtypes.SensorObject.new/1","doc":"Creates a new Sensor Object for environmental monitoring.","ref":"Object.Subtypes.SensorObject.html#new/1"},{"type":"function","title":"Parameters - Object.Subtypes.SensorObject.new/1","doc":"- `opts` - Configuration options:\n  - `:id` - Sensor identifier\n  - `:sensor_type` - Type of sensor (`:temperature`, `:humidity`, `:pressure`, etc.)\n  - `:measurement_range` - Valid measurement range as tuple\n  - `:accuracy` - Measurement accuracy (0.0-1.0)\n  - `:sampling_rate` - Sampling frequency in Hz","ref":"Object.Subtypes.SensorObject.html#new/1-parameters"},{"type":"function","title":"Returns - Object.Subtypes.SensorObject.new/1","doc":"SensorObject struct configured for data collection and calibration","ref":"Object.Subtypes.SensorObject.html#new/1-returns"},{"type":"function","title":"Object.Subtypes.SensorObject.sense/2","doc":"Performs environmental sensing with noise modeling.\n\nTakes measurements from the environment, applies sensor noise model,\nand updates the internal data buffer with timestamped measurements.","ref":"Object.Subtypes.SensorObject.html#sense/2"},{"type":"function","title":"Parameters - Object.Subtypes.SensorObject.sense/2","doc":"- `sensor` - SensorObject struct\n- `environment_state` - Current environmental conditions","ref":"Object.Subtypes.SensorObject.html#sense/2-parameters"},{"type":"function","title":"Returns - Object.Subtypes.SensorObject.sense/2","doc":"Updated SensorObject with new measurement in data buffer","ref":"Object.Subtypes.SensorObject.html#sense/2-returns"},{"type":"module","title":"Object.Supervisor","doc":"Enhanced supervision tree for the AAOS Object system with comprehensive fault tolerance.\n\nImplements advanced supervision strategies including circuit breaker integration,\nprogressive restart policies, health monitoring integration, and intelligent\nfailure isolation to ensure maximum system resilience.","ref":"Object.Supervisor.html"},{"type":"module","title":"Features - Object.Supervisor","doc":"- **Layered Supervision**: Multi-tier supervision with different restart strategies\n- **Intelligent Restart Policies**: Context-aware restart decisions\n- **Circuit Breaker Integration**: Automatic service isolation during failures\n- **Health Monitoring**: Continuous supervision health assessment\n- **Progressive Backoff**: Increasing restart delays for persistent failures\n- **Failure Isolation**: Prevent cascading failures across components\n- **Resource Protection**: Monitor and limit resource consumption","ref":"Object.Supervisor.html#module-features"},{"type":"module","title":"Supervision Hierarchy - Object.Supervisor","doc":"```\nObject.Supervisor (rest_for_one)\n├── Infrastructure Supervisor (one_for_one)\n│   ├── Registry\n│   ├── Error Handling\n│   ├── Health Monitor\n│   └── Resource Monitor\n├── Core Services Supervisor (one_for_one)\n│   ├── Schema Registry\n│   ├── Dead Letter Queue\n│   ├── Graceful Degradation\n│   └── Coordination Service\n├── Object Management Supervisor (rest_for_one)\n│   ├── Dynamic Supervisor\n│   ├── Performance Monitor\n│   └── Schema Evolution Manager\n└── Integration Services Supervisor (one_for_one)\n    ├── Message Router\n    └── AI Reasoning (if available)\n```","ref":"Object.Supervisor.html#module-supervision-hierarchy"},{"type":"module","title":"Restart Strategies - Object.Supervisor","doc":"- **Infrastructure**: Critical components that must be restarted immediately\n- **Core Services**: Essential services with progressive restart delays\n- **Object Management**: Components that may require dependent restarts\n- **Integration**: Optional services that can fail without affecting core functionality","ref":"Object.Supervisor.html#module-restart-strategies"},{"type":"function","title":"Object.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.Supervisor.html#child_spec/1"},{"type":"function","title":"Object.Supervisor.emergency_shutdown/1","doc":"Triggers emergency shutdown with graceful degradation.","ref":"Object.Supervisor.html#emergency_shutdown/1"},{"type":"function","title":"Object.Supervisor.get_supervision_health/0","doc":"Gets the current supervision tree health status.","ref":"Object.Supervisor.html#get_supervision_health/0"},{"type":"function","title":"Object.Supervisor.restart_child_with_backoff/1","doc":"Gracefully restarts a specific child process with backoff.","ref":"Object.Supervisor.html#restart_child_with_backoff/1"},{"type":"function","title":"Object.Supervisor.start_link/1","doc":"Starts the enhanced supervision tree with comprehensive error handling.","ref":"Object.Supervisor.html#start_link/1"},{"type":"function","title":"Options - Object.Supervisor.start_link/1","doc":"- `:restart_strategy` - Overall restart strategy (default: :rest_for_one)\n- `:max_restarts` - Maximum restarts in time period (default: 5)\n- `:max_seconds` - Time period for restart counting (default: 60)\n- `:enable_circuit_breakers` - Enable circuit breaker integration (default: true)\n- `:enable_health_monitoring` - Enable health monitoring (default: true)\n- `:enable_progressive_backoff` - Enable progressive restart delays (default: true)","ref":"Object.Supervisor.html#start_link/1-options"},{"type":"module","title":"Object.SystemDemo","doc":"Demonstration of the comprehensive Object system with mailboxes and subtypes\nbased on the AAOS specification.","ref":"Object.SystemDemo.html"},{"type":"function","title":"Object.SystemDemo.run_demo/0","doc":"Runs a comprehensive demo of the Object system.\n\nExecutes a complete demonstration including:\n- Creating specialized object subtypes\n- AI agent reasoning demonstrations\n- Human-AI interactions\n- Sensor and actuator operations\n- Multi-object coordination\n- Message passing between objects\n- Meta-DSL self-modification","ref":"Object.SystemDemo.html#run_demo/0"},{"type":"function","title":"Returns - Object.SystemDemo.run_demo/0","doc":"Map containing results from all demonstration scenarios","ref":"Object.SystemDemo.html#run_demo/0-returns"},{"type":"function","title":"Examples - Object.SystemDemo.run_demo/0","doc":"iex> Object.SystemDemo.run_demo()\n    %{ai_reasoning: %{problem_solved: true}, ...}","ref":"Object.SystemDemo.html#run_demo/0-examples"},{"type":"module","title":"Object.SystemOrchestrator","doc":"Self-organizing system orchestrator that manages the entire Object ecosystem.\n\nThis module enables:\n1. Dynamic system topology discovery and adaptation\n2. Emergent hierarchy formation based on capabilities\n3. Load balancing and resource optimization\n4. Fault tolerance and recovery mechanisms\n5. Performance monitoring and adaptive scaling\n\nThe orchestrator itself is an Object that can reason about and modify\nthe system architecture using LLM-powered decision making.","ref":"Object.SystemOrchestrator.html"},{"type":"function","title":"Object.SystemOrchestrator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Object.SystemOrchestrator.html#child_spec/1"},{"type":"function","title":"Object.SystemOrchestrator.get_system_status/0","doc":"Gets the current system topology and health metrics.","ref":"Object.SystemOrchestrator.html#get_system_status/0"},{"type":"function","title":"Object.SystemOrchestrator.register_object/1","doc":"Registers a new object in the system and evaluates its role.","ref":"Object.SystemOrchestrator.html#register_object/1"},{"type":"function","title":"Object.SystemOrchestrator.self_organize/1","doc":"Triggers system self-organization based on current state.","ref":"Object.SystemOrchestrator.html#self_organize/1"},{"type":"function","title":"Object.SystemOrchestrator.start_link/1","doc":"Starts the system orchestrator with an Object-based approach.","ref":"Object.SystemOrchestrator.html#start_link/1"},{"type":"module","title":"Object.TransferLearning","doc":"Object-Oriented Transfer Learning mechanisms for OORL framework.\n\nImplements transfer learning capabilities as specified in AAOS section 11,\nenabling objects to leverage prior experience and knowledge to learn faster\nand generalize better to new tasks and domains.\n\nKey mechanisms:\n- Object similarity and embedding spaces\n- Analogical reasoning between objects and domains\n- Meta-learning for rapid adaptation\n- Knowledge distillation between objects\n- Cross-domain policy transfer","ref":"Object.TransferLearning.html"},{"type":"type","title":"Object.TransferLearning.abstraction_level/0","doc":"","ref":"Object.TransferLearning.html#t:abstraction_level/0"},{"type":"type","title":"Object.TransferLearning.action_id/0","doc":"","ref":"Object.TransferLearning.html#t:action_id/0"},{"type":"type","title":"Object.TransferLearning.adaptation_strategy/0","doc":"","ref":"Object.TransferLearning.html#t:adaptation_strategy/0"},{"type":"type","title":"Object.TransferLearning.analogy_engine/0","doc":"","ref":"Object.TransferLearning.html#t:analogy_engine/0"},{"type":"type","title":"Object.TransferLearning.analogy_key/0","doc":"","ref":"Object.TransferLearning.html#t:analogy_key/0"},{"type":"type","title":"Object.TransferLearning.analogy_result/0","doc":"","ref":"Object.TransferLearning.html#t:analogy_result/0"},{"type":"type","title":"Object.TransferLearning.analogy_template/0","doc":"","ref":"Object.TransferLearning.html#t:analogy_template/0"},{"type":"function","title":"Object.TransferLearning.compute_object_similarity/3","doc":"Computes similarity between two objects using multiple metrics.","ref":"Object.TransferLearning.html#compute_object_similarity/3"},{"type":"function","title":"Parameters - Object.TransferLearning.compute_object_similarity/3","doc":"- `transfer_system` - Transfer learning system struct\n- `source_object` - First object for comparison\n- `target_object` - Second object for comparison","ref":"Object.TransferLearning.html#compute_object_similarity/3-parameters"},{"type":"function","title":"Returns - Object.TransferLearning.compute_object_similarity/3","doc":"Map containing:\n- `:overall_similarity` - Weighted average similarity score (0.0-1.0)\n- `:detailed_scores` - Individual metric scores\n- `:confidence` - Confidence in similarity measurement","ref":"Object.TransferLearning.html#compute_object_similarity/3-returns"},{"type":"type","title":"Object.TransferLearning.domain_id/0","doc":"","ref":"Object.TransferLearning.html#t:domain_id/0"},{"type":"type","title":"Object.TransferLearning.domain_mapping/0","doc":"","ref":"Object.TransferLearning.html#t:domain_mapping/0"},{"type":"type","title":"Object.TransferLearning.embedding_model/0","doc":"","ref":"Object.TransferLearning.html#t:embedding_model/0"},{"type":"type","title":"Object.TransferLearning.embedding_space/0","doc":"","ref":"Object.TransferLearning.html#t:embedding_space/0"},{"type":"type","title":"Object.TransferLearning.embedding_vector/0","doc":"","ref":"Object.TransferLearning.html#t:embedding_vector/0"},{"type":"type","title":"Object.TransferLearning.episode/0","doc":"","ref":"Object.TransferLearning.html#t:episode/0"},{"type":"function","title":"Object.TransferLearning.evaluate_transfer_effectiveness/1","doc":"Evaluates the effectiveness of transfer learning.","ref":"Object.TransferLearning.html#evaluate_transfer_effectiveness/1"},{"type":"function","title":"Parameters - Object.TransferLearning.evaluate_transfer_effectiveness/1","doc":"- `transfer_system` - Transfer learning system struct","ref":"Object.TransferLearning.html#evaluate_transfer_effectiveness/1-parameters"},{"type":"function","title":"Returns - Object.TransferLearning.evaluate_transfer_effectiveness/1","doc":"Map containing:\n- `:overall_effectiveness` - Aggregate effectiveness score (0.0-1.0)\n- `:detailed_metrics` - Individual performance metrics\n- `:recommendations` - Improvement recommendations","ref":"Object.TransferLearning.html#evaluate_transfer_effectiveness/1-returns"},{"type":"type","title":"Object.TransferLearning.feature_id/0","doc":"","ref":"Object.TransferLearning.html#t:feature_id/0"},{"type":"function","title":"Object.TransferLearning.identify_transfer_opportunities/3","doc":"Identifies transfer opportunities from source to target domain.","ref":"Object.TransferLearning.html#identify_transfer_opportunities/3"},{"type":"function","title":"Parameters - Object.TransferLearning.identify_transfer_opportunities/3","doc":"- `transfer_system` - Transfer learning system struct\n- `source_domain` - Source domain specification\n- `target_domain` - Target domain specification","ref":"Object.TransferLearning.html#identify_transfer_opportunities/3-parameters"},{"type":"function","title":"Returns - Object.TransferLearning.identify_transfer_opportunities/3","doc":"Map with comprehensive transfer analysis:\n- `:domain_similarity` - Similarity metrics between domains\n- `:analogical_mappings` - Structural correspondences found\n- `:transfer_feasibility` - Assessment of transfer viability\n- `:recommendations` - Specific transfer method recommendations\n- `:estimated_benefit` - Expected benefit of transfer","ref":"Object.TransferLearning.html#identify_transfer_opportunities/3-returns"},{"type":"type","title":"Object.TransferLearning.knowledge_base/0","doc":"","ref":"Object.TransferLearning.html#t:knowledge_base/0"},{"type":"type","title":"Object.TransferLearning.learning_episode/0","doc":"","ref":"Object.TransferLearning.html#t:learning_episode/0"},{"type":"type","title":"Object.TransferLearning.mapping_rule/0","doc":"","ref":"Object.TransferLearning.html#t:mapping_rule/0"},{"type":"function","title":"Object.TransferLearning.meta_learn/3","doc":"Executes meta-learning for rapid adaptation to new tasks.","ref":"Object.TransferLearning.html#meta_learn/3"},{"type":"function","title":"Parameters - Object.TransferLearning.meta_learn/3","doc":"- `transfer_system` - Transfer learning system struct\n- `adaptation_task` - Task specification for adaptation\n- `few_shot_examples` - Limited examples for rapid learning","ref":"Object.TransferLearning.html#meta_learn/3-parameters"},{"type":"function","title":"Returns - Object.TransferLearning.meta_learn/3","doc":"- `{:ok, adapted_parameters, updated_system}` - Success with adapted parameters\n- `{:error, reason}` - Adaptation failed","ref":"Object.TransferLearning.html#meta_learn/3-returns"},{"type":"type","title":"Object.TransferLearning.meta_learning_state/0","doc":"","ref":"Object.TransferLearning.html#t:meta_learning_state/0"},{"type":"function","title":"Object.TransferLearning.new/2","doc":"Creates a new transfer learning system for an object.","ref":"Object.TransferLearning.html#new/2"},{"type":"function","title":"Parameters - Object.TransferLearning.new/2","doc":"- `object_id` - Unique identifier for the object\n- `opts` - Configuration options:\n  - `:embedding_dimensions` - Size of embedding vectors (default: 64)\n  - `:embedding_model` - Type of embedding model (default: :neural_embedding)","ref":"Object.TransferLearning.html#new/2-parameters"},{"type":"function","title":"Returns - Object.TransferLearning.new/2","doc":"New transfer learning system struct with initialized components","ref":"Object.TransferLearning.html#new/2-returns"},{"type":"function","title":"Examples - Object.TransferLearning.new/2","doc":"iex> Object.TransferLearning.new(\"agent_1\", embedding_dimensions: 128)\n    %Object.TransferLearning{object_id: \"agent_1\", ...}","ref":"Object.TransferLearning.html#new/2-examples"},{"type":"type","title":"Object.TransferLearning.object_id/0","doc":"","ref":"Object.TransferLearning.html#t:object_id/0"},{"type":"function","title":"Object.TransferLearning.perform_analogical_reasoning/3","doc":"Performs analogical reasoning to find structural correspondences.","ref":"Object.TransferLearning.html#perform_analogical_reasoning/3"},{"type":"function","title":"Parameters - Object.TransferLearning.perform_analogical_reasoning/3","doc":"- `transfer_system` - Transfer learning system struct\n- `source_structure` - Source structure for analogy\n- `target_structure` - Target structure for analogy","ref":"Object.TransferLearning.html#perform_analogical_reasoning/3-parameters"},{"type":"function","title":"Returns - Object.TransferLearning.perform_analogical_reasoning/3","doc":"Map containing:\n- `:correspondences` - Structural element mappings\n- `:template_matches` - Template-based analogy matches\n- `:inferences` - Generated analogical inferences\n- `:confidence` - Overall confidence in analogical reasoning","ref":"Object.TransferLearning.html#perform_analogical_reasoning/3-returns"},{"type":"type","title":"Object.TransferLearning.procedure/0","doc":"","ref":"Object.TransferLearning.html#t:procedure/0"},{"type":"type","title":"Object.TransferLearning.similarity_metric/0","doc":"","ref":"Object.TransferLearning.html#t:similarity_metric/0"},{"type":"type","title":"Object.TransferLearning.t/0","doc":"","ref":"Object.TransferLearning.html#t:t/0"},{"type":"type","title":"Object.TransferLearning.task_id/0","doc":"","ref":"Object.TransferLearning.html#t:task_id/0"},{"type":"function","title":"Object.TransferLearning.transfer_knowledge/4","doc":"Transfers knowledge from source object to target object.","ref":"Object.TransferLearning.html#transfer_knowledge/4"},{"type":"function","title":"Parameters - Object.TransferLearning.transfer_knowledge/4","doc":"- `transfer_system` - Transfer learning system struct\n- `source_object` - Object providing knowledge\n- `target_object` - Object receiving knowledge\n- `transfer_method` - Method to use (`:automatic`, `:policy_distillation`, `:feature_mapping`, `:analogical`, `:meta_learning`)","ref":"Object.TransferLearning.html#transfer_knowledge/4-parameters"},{"type":"function","title":"Returns - Object.TransferLearning.transfer_knowledge/4","doc":"- `{:ok, transferred_knowledge, updated_system}` - Success with transferred knowledge\n- `{:error, reason}` - Transfer failed","ref":"Object.TransferLearning.html#transfer_knowledge/4-returns"},{"type":"type","title":"Object.TransferLearning.transfer_method/0","doc":"","ref":"Object.TransferLearning.html#t:transfer_method/0"},{"type":"type","title":"Object.TransferLearning.transfer_record/0","doc":"","ref":"Object.TransferLearning.html#t:transfer_record/0"},{"type":"function","title":"Object.TransferLearning.update_object_embedding/3","doc":"Updates object embeddings in the shared embedding space.","ref":"Object.TransferLearning.html#update_object_embedding/3"},{"type":"function","title":"Parameters - Object.TransferLearning.update_object_embedding/3","doc":"- `transfer_system` - Transfer learning system struct\n- `object` - Object whose embedding should be updated\n- `new_experiences` - Recent experiences to incorporate","ref":"Object.TransferLearning.html#update_object_embedding/3-parameters"},{"type":"function","title":"Returns - Object.TransferLearning.update_object_embedding/3","doc":"Updated transfer learning system with modified embedding space","ref":"Object.TransferLearning.html#update_object_embedding/3-returns"},{"type":"module","title":"Object.TrustManager","doc":"Manages trust relationships between objects, including reputation tracking,\nByzantine fault detection, and trust-based decision making.","ref":"Object.TrustManager.html"},{"type":"function","title":"Object.TrustManager.apply_reputation_decay/1","doc":"","ref":"Object.TrustManager.html#apply_reputation_decay/1"},{"type":"function","title":"Object.TrustManager.detect_byzantine_behavior/4","doc":"","ref":"Object.TrustManager.html#detect_byzantine_behavior/4"},{"type":"function","title":"Object.TrustManager.get_trust_network_stats/1","doc":"","ref":"Object.TrustManager.html#get_trust_network_stats/1"},{"type":"function","title":"Object.TrustManager.get_trust_score/2","doc":"","ref":"Object.TrustManager.html#get_trust_score/2"},{"type":"function","title":"Object.TrustManager.is_trustworthy?/2","doc":"","ref":"Object.TrustManager.html#is_trustworthy?/2"},{"type":"function","title":"Object.TrustManager.new/1","doc":"","ref":"Object.TrustManager.html#new/1"},{"type":"function","title":"Object.TrustManager.should_verify?/2","doc":"","ref":"Object.TrustManager.html#should_verify?/2"},{"type":"function","title":"Object.TrustManager.update_reputation/3","doc":"","ref":"Object.TrustManager.html#update_reputation/3"}],"proglang":"elixir","producer":{"name":"ex_doc","version":"0.38.2"},"content_type":"text/markdown"}